/* Tabela BAIXAPAGA: Baixa de Conta a Pagar */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela BAIXAPAGA */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela Baixa de Conta a Pagar,
             utilizando a tabela Geral de Logs de Operaes */
CREATE OR REPLACE TRIGGER LOG_FIN_BXPAGAR
AFTER DELETE OR INSERT OR UPDATE
ON BAIXAPAGA FOR EACH ROW
DECLARE
  V_USUARIO      VARCHAR2(40);
  V_TIPO         VARCHAR2(1);
  V_ITPESQ       VARCHAR2(40);
  V_DESC         VARCHAR2(300);
  V_CDFILLOGOPER VARCHAR2(4);
  V_DTOPER       DATE;
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
BEGIN
   V_CDFILLOGOPER := '';
   IF DELETING THEN
      V_TIPO   := '3';
      V_DESC   := 'Dt. Baixa '   || TO_CHAR(:OLD.DTBAIXAPAG, 'DD/MM/YYYY') ||
                  ' Valor '      || TO_CHAR(:OLD.VRBAIXAPAG)               ||
                  ' ContCC '     || :OLD.CDREDUCONT                        ||
                  ' Empresa '    || :OLD.CDEMPRESA                         ||
                  ' Tipo Baixa ' || :OLD.CDTPBAIXAPAG                      ||
                  ' Status '     || :OLD.IDSTATUSBPAG                      ||
                  ' Cheque '     || :OLD.NRCHEQUE                          ||
                  ' NrMovBanc '  || :OLD.NRMOVBANC                         ||
                  ' SitCheque '  || :OLD.IDSTEMICHEQ;

      V_ITPESQ       := :OLD.CDFILIAL||:OLD.NRBAIXAPAG|| '/' ||:OLD.NRMOVBANC;
      V_CDFILLOGOPER := :OLD.CDFILIAL;
   ELSE
      IF UPDATING THEN
         V_ITPESQ       := :OLD.CDFILIAL||:OLD.NRBAIXAPAG|| '/' ||:OLD.NRMOVBANC;
         V_CDFILLOGOPER := :OLD.CDFILIAL;

         IF (:NEW.DTBAIXAPAG   <> :OLD.DTBAIXAPAG)    OR
            (:NEW.VRBAIXAPAG   <> :OLD.VRBAIXAPAG)    OR
            (:NEW.CDREDUCONT   <> :OLD.CDREDUCONT)    OR
            (:NEW.CDEMPRESA    <> :OLD.CDEMPRESA)     OR
            (:NEW.CDTPBAIXAPAG <> :OLD.CDTPBAIXAPAG)  OR
            (:NEW.NRMOVBANC    <> :OLD.NRMOVBANC)     OR
            (:NEW.NRCHEQUE     <> :OLD.NRCHEQUE)      OR
            (:NEW.IDSTEMICHEQ  <> :OLD.IDSTEMICHEQ)   OR
            (:NEW.IDSTATUSBPAG <> :OLD.IDSTATUSBPAG)  THEN
            V_TIPO   := '2';
         END IF;
      ELSE
         V_TIPO         := '1';
         V_ITPESQ       := :NEW.CDFILIAL||:NEW.NRBAIXAPAG|| '/' ||:NEW.NRMOVBANC;
         V_CDFILLOGOPER := :NEW.CDFILIAL;
      END IF;

      V_DESC   := 'Dt. Baixa '   || TO_CHAR(:NEW.DTBAIXAPAG, 'DD/MM/YYYY') ||
                  ' Valor '      || TO_CHAR(:NEW.VRBAIXAPAG)               ||
                  ' ContCC '     || :NEW.CDREDUCONT                        ||
                  ' Empresa '    || :NEW.CDEMPRESA                         ||
                  ' Tipo Baixa ' || :NEW.CDTPBAIXAPAG                      ||
                  ' Status '     || :NEW.IDSTATUSBPAG                      ||
                  ' Cheque '     || :NEW.NRCHEQUE                          ||
                  ' NrMovBanc '  || :NEW.NRMOVBANC                         ||
                  ' SitCheque '  || :NEW.IDSTEMICHEQ;
   END IF;

   IF V_TIPO <> '0' THEN
      NMUSUARIO(V_USUARIO);
      WEBTUNNING(V_DSREMOTEADDR,
                 V_DSREMOTEHOST,
                 V_DSSERVERRDM,
                 V_DSSERVMETHOD,
                 V_DSREMOTEOPER);
      IF NOT V_DESC IS NULL THEN
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;

            INSERT INTO LOGOPERA
               (NMTABELA,   DTOPERACAO, NMRESPOPER,
                IDTIPOOPER, CDPESQITEM, DSOPERACAO,
                CDFILLOGOPER, DSRDMUSUOPER, DSENDUSUOPER,
                DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER)
            VALUES
               ('BAIXAPAGA', V_DTOPER, V_USUARIO,
                V_TIPO,      V_ITPESQ, V_DESC,
                V_CDFILLOGOPER, V_DSSERVERRDM, V_DSREMOTEADDR,
                V_DSREMOTEHOST, V_DSSERVMETHOD, V_DSREMOTEOPER);
         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_FIN_BXPAGAR','5.20.000'); END;
/

