var Fis00100_ApuracaoDeImposto_Controller = function(templateManager, General, Fis00100_ApuracaoDeImposto_Service, ScreenService,localStorageEngine, Messages_fiscal, maskEngine, ZhFilterPreferences) {
    
    var self = this;
    
    // Códigos dos impostos 
    var impostosInss        = ["42"];
    var impostosIrpjCsll    = ["25","70"];
    var impostoIcms         = "00";
    var impostosFecp        = "01";
    var impostosCargaRj     = "03";
    var impostoIpi          = "10";
    var impostosIrrfE       = "21";
    var impostosIrrfS       = "22";
    var impostosPcc         = "24";
    var impostosIssqnE      = "24";
    var impostoPis          = "50";
    var impostoPisRetS      = "56";
    var impostosCofins      = "60";
    var impostosCofinsRetS  = "66";
    var impostoIcmsSt       = "80";
    
    // Variável que armazenam os valores inseridos do filtro.
    var filteredData = {};


    /********************************************************
     *                                                      *
     *                   Funções do Filtro                  *
     *                                                      *
     ********************************************************/

    this.openFilterApuracaoImposto = function(widget){
        var filterRow = {
        };
        ZhFilterPreferences.setOriginalFilter(widget.id, filterRow);
        ZhFilterPreferences.openFilterWidget(widget);   
    };
    
    /*
     * Função para alterar o comportamento e exibição da tela conforme filtro
     * selecionado.
     */
    this.alteraExibicaoTela = function(widget, preference) {
        //var filterPopup = widget.appliedFilter;
        var filterPopup = preference;
        var idtipoapura = filterPopup.FILTER_ROW.IDTIPOAPURA;
        var cdimposto = filterPopup.FILTER_ROW.CDIMPOSTO;

        alteraVisibilidadeWidgets(idtipoapura, cdimposto, filterPopup.FILTER_ROW);
        alteraVisibilidadeFields(widget, idtipoapura, cdimposto);
        var notasFiscaisWidget = templateManager.container.getWidget("notasFiscais");
        //alteraVisibilidadeConferencia(widget, cdimposto);

        // Altera o dataSource.name conforme tipo de apuração e imposto selecionados no filtro.
        
        // Apurção Simples Nacional
        if (simplesNacionalIsSelected(idtipoapura)) {
            // Utiliza filtro somente de empresa.
            widget.dataSourceFilter = [
                {
                    "name": "CDEMPRESA",
                    "operator": "=",
                    "value": filterPopup.FILTER_ROW.CDEMPRESA
                }
            ];
            widget.dataSource.name = 'fis_apuracoes#/crud/mapaapuracsn_completo';
            // Altera o dataSource para trazer as notas do Simples.
            notasFiscaisWidget.dataSource.name = 'fis_apuracoes#/notasfiscais_apuracaoimposto_simples';
        }
        else {
            /*
            // Remove o filtro por tipo de apuração.
            widget.dataSourceFilter = widget.dataSourceFilter.filter(function(filter) {
                return filter.name != "IDTIPOAPURA";
            });
            */
            var orgao       = filterPopup.FILTER_ROW.IDORGARRECADNFE == 'F' ? null : filterPopup.FILTER_ROW.IDORGARRECADNFE;
            // Verifica se um imposto de contribuições foi selecionado.
            if (contribuicoesIsSelected(cdimposto)) {
                var filtroContribuicoes = [
                        {
                            "name":"CDEMPRESA",
                            "operator":"=",
                            "value": filterPopup.FILTER_ROW.CDEMPRESA
                        },
                        {
                            "name":"CDIMPOSTO",
                            "operator":"=",
                            "value": filterPopup.FILTER_ROW.CDIMPOSTO
                        }
                ];
                widget.dataSourceFilter = filtroContribuicoes;
                widget.dataSource.name  = 'fis_apuracoes#/crud/mapaapurac_contribuicoes';
                // Altera o dataSource para trazer as notas de mapas gerais.
                notasFiscaisWidget.dataSource.name = 'fis_apuracoes#/notasfiscais_apuracaoimposto_geral';
            }
            else if(inssIsSelected(cdimposto)){
                var filtroInss = [
                    {
                        "name":"P_IDORGARRECAD",
                        "operator":"=",
                        "value": orgao
                    },
                    {
                        "name":"P_INSCRICAO",
                        "operator":"=",
                        "value": filterPopup.FILTER_ROW.CDINSCESTA  ? filterPopup.FILTER_ROW.CDINSCESTA : filterPopup.FILTER_ROW.CDINSCMUNI
                    },
                    {
                        "name":"CDEMPRESA",
                        "operator":"=",
                        "value": filterPopup.FILTER_ROW.CDEMPRESA
                    },
                    {
                        "name":"CDIMPOSTO",
                        "operator":"=",
                        "value": filterPopup.FILTER_ROW.CDIMPOSTO
                    }
                ];
                widget.dataSourceFilter = filtroInss;
                widget.dataSource.name  = 'fis_apuracoes#/crud/mapaapurac_inss';
                // Altera o dataSource para trazer as notas de mapas gerais.
                notasFiscaisWidget.dataSource.name = 'fis_apuracoes#/notasfiscais_apuracaoimposto_geral'; 
                widget.getField('VRSALDOCRED').isVisible = false;
            }
            else if (irpjCsllIsSelected(cdimposto)) {
                widget.dataSourceFilter = [
                    {
                        "name": "P_EMPRESA",
                        "operator": "=",
                        "value": filterPopup.FILTER_ROW.CDEMPRESA
                    },
                    {
                        "name": "P_IMPOSTO",
                        "operator": "=",
                        "value": filterPopup.FILTER_ROW.CDIMPOSTO
                    }
                ];
                widget.dataSource.name = 'fis_apuracoes#/crud/mapaapurac_irpjcsll';
            }
            else {
                var filtroGeral = [
                        {
                            "name":"P_IDORGARRECAD",
                            "operator":"=",
                            "value": orgao
                        },
                        {
                            "name":"P_INSCRICAO",
                            "operator":"=",
                            "value": filterPopup.FILTER_ROW.CDINSCESTA  ? filterPopup.FILTER_ROW.CDINSCESTA : filterPopup.FILTER_ROW.CDINSCMUNI
                        },
                        {
                            "name":"CDEMPRESA",
                            "operator":"=",
                            "value": filterPopup.FILTER_ROW.CDEMPRESA
                        },
                        {
                            "name":"CDIMPOSTO",
                            "operator":"=",
                            "value": filterPopup.FILTER_ROW.CDIMPOSTO
                        }
                ];
                widget.dataSourceFilter = filtroGeral;
                widget.dataSource.name  = 'fis_apuracoes#/crud/mapaapurac_impostosGerais';
                // Altera o dataSource para trazer as notas de mapas gerais.
                notasFiscaisWidget.dataSource.name = 'fis_apuracoes#/notasfiscais_geral';
                controlaGuiaComplementar(cdimposto,idtipoapura);
                controlaCamposIcms(cdimposto);
                controlaCampoReceitaArrecadacao(idtipoapura);
            }
            
            /*
            else if(impostosGeraisIsSelected(cdimposto)){
                widget.dataSource.name = 'fis_apuracoes#/crud/mapaapurac_impostosGerais';
            }
            else{
                widget.dataSource.name = 'fis_apuracoes#/crud/apuracao_mapaapurac';
            }*/
        }

        // Correção temporária de erro do framework que não exibe os campos que
        // tiveram a visibilidade alterada.
        widget.resizeGridColumns(true);
        widget.reload();
    };

    /*
     * Função auxiliar para alterar a visibilidade das widgets da tela conforme
     * filtro selecionado.
     */
    var alteraVisibilidadeFields = function(mainWidget, idtipoapura, cdimposto) {
        // Fields que são exibidos ou não quando o tipo de apuração é Simples
        // Nacional.
        var fieldsSimples       = ["DTREFERENCIA", "DTREALAPURA"];
        //var fieldsContribuicoes = ["VRSALDOCRED"];
        var fieldsGerais        = ["DTINIPERIODO", "DTFIMPERIODO","VRSALDOCRED"];
        
        // Verifica o tipo de apuração e imposto selecionados.
        var isSimplesNacional = simplesNacionalIsSelected(idtipoapura);
        //var isContribuicoes   = contribuicoesIsSelected(cdimposto);
        //var isImpostosGerais  = impostosGeraisIsSelected(cdimposto);
        
        fieldsSimples.forEach(function(fieldName) {
            mainWidget.getField(fieldName).isVisible  = isSimplesNacional;
        });

        /*
        fieldsContribuicoes.forEach(function(fieldName) {
            mainWidget.getField(fieldName).isVisible = isContribuicoes;
        });
        
        fieldImpostosGerais.forEach(function(fieldName) {
            mainWidget.getField(fieldName).isVisible = isImpostosGerais;
        });

        *///
        
        fieldsGerais.forEach(function(fieldName) {
            mainWidget.getField(fieldName).isVisible  = !isSimplesNacional;
        });
        
        /*
        fieldsGerais.forEach(function(fieldName) {
            mainWidget.getField(fieldName).showOnView  = !isSimplesNacional;
        });
        
        fieldsGerais.forEach(function(fieldName) {
            mainWidget.getField(fieldName).showOnForm  = !isSimplesNacional;
        });
        */
        // Muda o nome do campo de imposto a recolher, conforme tipo de apuração
        // escolhido.
        mainWidget.getField("VRTOTAIMPOS").label = isSimplesNacional ? "Simples a Recolher" : "Imposto a Recolher";
        
        mainWidget.redraw();
        
    };

    /*
     * Função auxiliar para alterar a visibilidade das widgets da tela conforme
     * filtro selecionado.
     */
    var alteraVisibilidadeWidgets = function(idtipoapura, cdimposto, row) {
        // Widgets que são exibidas quando o tipo de apuração é Simples Nacional.
        var widgetsSimples = ["simplesNacionalTabelaReferencia"];

        // Widgets que são exibidas quando o tipo de apuração é Contribuições.
        var widgetsContribuicoes = ["tabbedContribuicoesDetalhamento", "contribuicoesDetalhamento", "contribuicoesArrecadacao", "contribuicoesDetalhamentoCompetencia", "ajusteContribuicao"];
        
        // Widgets que são exibidas quando o tipo de apuração é ImpostosGerais.
        var widgetsImpostosGerais = ["detalhamentoGeral","tabbedArrecadacaoGeral"];
        
        var widgetsInss = ["detalhamentoInss","tabbedArrecadacaoGeral"];
        
        // Widgets que são exibidas quando o imposto é ICMS.
        var widgetsIcms = ["widgetInformacoesAdicionais","widgetDifalIcms", "tabbedArrecadacaoGeral"];
        
        var widgetsIcmsSt = ["detalhamentoIcmsSt"];
        
        // Widgets que são exibidas quando o imposto é IRPJ ou CSLL.
        var widgetsIrpjCsll = ["detalhamentoIrpjCsll", "detalhamentoIrpjCsllLucroRealTrimestral", "detalhamentoIrpjCsllLucroPresumidoCompet", "detalhamentoIrpjCsllLucroPresumidoPag", "detalhamentoIrpjCsllLucroRealMensal", "tabbedArrecadacaoGeral"];
        
        var widgetNotasFiscais = ["notasFiscais"];
        
        // Verifica o tipo de apuração e imposto selecionados.
        var isSimplesNacional = simplesNacionalIsSelected(idtipoapura);
        var isContribuicoes   = contribuicoesIsSelected(cdimposto);
        var isInss            = inssIsSelected(cdimposto);
        var isIcmstSt         = icmsStIsSelected(cdimposto);
        var isIrpjCsll        = irpjCsllIsSelected(cdimposto);
        
         if(cdimposto == '80'){
    		templateManager.container.getWidget('simplesNacionalTabelaReferencia').isVisible = false;
    		templateManager.container.getWidget('detalhamentoIcmsSt').isVisible = true;
    		templateManager.container.getWidget('detalhamentoInss').isVisible = false;
    		templateManager.container.getWidget('detalhamentoGeral').isVisible = false;
    		templateManager.container.getWidget('tabbedContribuicoesDetalhamento').isVisible = false;
    		templateManager.container.getWidget('detalhamentoIrpjCsll').isVisible = false;
    		templateManager.container.getWidget('ConfAjusteSt').isVisible = true;
    		templateManager.container.getWidget('notasFiscais').isVisible = true;
    		templateManager.container.getWidget('ajusteContribuicao').isVisible = false;
    		templateManager.container.getWidget('widgetDifalIcms').isVisible = false;
    		templateManager.container.getWidget('widgetInformacoesAdicionais').isVisible = true;
    		templateManager.container.getWidget('contribuicoesArrecadacao').isVisible = false;
    		templateManager.container.getWidget('tabbedArrecadacaoGeral').isVisible = true;
    	 }else if (cdimposto == '42'){
    		templateManager.container.getWidget('simplesNacionalTabelaReferencia').isVisible = false;
    		templateManager.container.getWidget('detalhamentoIcmsSt').isVisible = false;
    		templateManager.container.getWidget('detalhamentoInss').isVisible = true;
    		templateManager.container.getWidget('detalhamentoGeral').isVisible = false;
    		templateManager.container.getWidget('tabbedContribuicoesDetalhamento').isVisible = false;
    		templateManager.container.getWidget('detalhamentoIrpjCsll').isVisible = false;
    		templateManager.container.getWidget('ConfAjusteSt').isVisible = false;
    		templateManager.container.getWidget('notasFiscais').isVisible = true;
    		templateManager.container.getWidget('ajusteContribuicao').isVisible = false;
    		templateManager.container.getWidget('widgetDifalIcms').isVisible = false;
    		templateManager.container.getWidget('widgetInformacoesAdicionais').isVisible = true;
    		templateManager.container.getWidget('contribuicoesArrecadacao').isVisible = false;
    		templateManager.container.getWidget('tabbedArrecadacaoGeral').isVisible = true;
    	 }else if (cdimposto == '25' || cdimposto == '70'){
    		templateManager.container.getWidget('simplesNacionalTabelaReferencia').isVisible = false;
    		templateManager.container.getWidget('detalhamentoIcmsSt').isVisible = false;
    		templateManager.container.getWidget('detalhamentoInss').isVisible = false;
    		templateManager.container.getWidget('detalhamentoGeral').isVisible = false;
    		templateManager.container.getWidget('tabbedContribuicoesDetalhamento').isVisible = false;
    		templateManager.container.getWidget('detalhamentoIrpjCsll').isVisible = true;
    		templateManager.container.getWidget('ConfAjusteSt').isVisible = false;
    		templateManager.container.getWidget('notasFiscais').isVisible = false;
    		templateManager.container.getWidget('ajusteContribuicao').isVisible = false;
    		templateManager.container.getWidget('widgetDifalIcms').isVisible = false;
    		templateManager.container.getWidget('widgetInformacoesAdicionais').isVisible = false;
    		templateManager.container.getWidget('contribuicoesArrecadacao').isVisible = false;
    		templateManager.container.getWidget('tabbedArrecadacaoGeral').isVisible = true;
    	 }else if (cdimposto == '50' || cdimposto == '60'){
    		templateManager.container.getWidget('ajusteContribuicao').isVisible = true;
    		templateManager.container.getWidget('contribuicoesArrecadacao').isVisible = true;
    		templateManager.container.getWidget('notasFiscais').isVisible = true;
    		templateManager.container.getWidget('tabbedContribuicoesDetalhamento').isVisible = true;
    		templateManager.container.getWidget('tabbedArrecadacaoGeral').isVisible = false;
    		templateManager.container.getWidget('widgetInformacoesAdicionais').isVisible = false;
    		templateManager.container.getWidget('detalhamentoGeral').isVisible = false;
    		templateManager.container.getWidget('simplesNacionalTabelaReferencia').isVisible = false;
    		templateManager.container.getWidget('detalhamentoIcmsSt').isVisible = false;
    		templateManager.container.getWidget('detalhamentoInss').isVisible = false;
    		templateManager.container.getWidget('detalhamentoIrpjCsll').isVisible = false;
    		templateManager.container.getWidget('ConfAjusteSt').isVisible = false;
    		templateManager.container.getWidget('widgetDifalIcms').isVisible = false;
    	 }else if (cdimposto == '00'){
    		templateManager.container.getWidget('simplesNacionalTabelaReferencia').isVisible = false;
    		templateManager.container.getWidget('detalhamentoIcmsSt').isVisible = false;
    		templateManager.container.getWidget('detalhamentoInss').isVisible = false;
    		templateManager.container.getWidget('detalhamentoGeral').isVisible = true;
    		templateManager.container.getWidget('tabbedContribuicoesDetalhamento').isVisible = false;
    		templateManager.container.getWidget('detalhamentoIrpjCsll').isVisible = false;
    		templateManager.container.getWidget('ConfAjusteSt').isVisible = false;
    		templateManager.container.getWidget('notasFiscais').isVisible = true;
    		templateManager.container.getWidget('ajusteContribuicao').isVisible = false;
    		templateManager.container.getWidget('widgetDifalIcms').isVisible = false;
    		templateManager.container.getWidget('widgetInformacoesAdicionais').isVisible = true;
    		templateManager.container.getWidget('contribuicoesArrecadacao').isVisible = false;
    		templateManager.container.getWidget('tabbedArrecadacaoGeral').isVisible = true;
    	 }else if (isSimplesNacional){
    		templateManager.container.getWidget('simplesNacionalTabelaReferencia').isVisible = true;
    		templateManager.container.getWidget('detalhamentoIcmsSt').isVisible = false;
    		templateManager.container.getWidget('detalhamentoInss').isVisible = false;
    		templateManager.container.getWidget('detalhamentoGeral').isVisible = false;
    		templateManager.container.getWidget('tabbedContribuicoesDetalhamento').isVisible = false;
    		templateManager.container.getWidget('detalhamentoIrpjCsll').isVisible = false;
    		templateManager.container.getWidget('ConfAjusteSt').isVisible = false;
    		templateManager.container.getWidget('notasFiscais').isVisible = true;
    		templateManager.container.getWidget('ajusteContribuicao').isVisible = false;
    		templateManager.container.getWidget('widgetDifalIcms').isVisible = false;
    		templateManager.container.getWidget('widgetInformacoesAdicionais').isVisible = false;
    		templateManager.container.getWidget('contribuicoesArrecadacao').isVisible = false;
    		templateManager.container.getWidget('tabbedArrecadacaoGeral').isVisible = true;
    	 }else {
    	    templateManager.container.getWidget('simplesNacionalTabelaReferencia').isVisible = false;
    		templateManager.container.getWidget('detalhamentoIcmsSt').isVisible = false;
    		templateManager.container.getWidget('detalhamentoInss').isVisible = false;
    		templateManager.container.getWidget('detalhamentoGeral').isVisible = false;
    		templateManager.container.getWidget('tabbedContribuicoesDetalhamento').isVisible = false;
    		templateManager.container.getWidget('detalhamentoIrpjCsll').isVisible = false;
    		templateManager.container.getWidget('ConfAjusteSt').isVisible = false;
    		templateManager.container.getWidget('notasFiscais').isVisible = false;
    		templateManager.container.getWidget('ajusteContribuicao').isVisible = false;
    		templateManager.container.getWidget('widgetDifalIcms').isVisible = false;
    		templateManager.container.getWidget('widgetInformacoesAdicionais').isVisible = false;
    		templateManager.container.getWidget('contribuicoesArrecadacao').isVisible = false;
    		templateManager.container.getWidget('tabbedArrecadacaoGeral').isVisible = false;
    	 }
    };

    /*
     * Função para controlar o filtro por empresa e a propriedade readOnly do
     * campo de inscrição habilitado no filtro.
     */
    this.checkInscricaoHabilitada = function(filterPopup) {
        var cdempresa = filterPopup.currentRow.CDEMPRESA;
        var cdinscestaField = filterPopup.getField("CDINSCESTA");
        var cdinscmuniField = filterPopup.getField("CDINSCMUNI");

        // Reseta os valores de inscrição do filtro.
        filterPopup.currentRow.CDINSCESTA = '';
        filterPopup.currentRow.CDINSCMUNI = '';

        // Filtro a ser setado no dataSourceFilter do field de inscrição
        // exibido.
        var filter = [
            {
                "name": "CDEMPRESA",
                "operator": "=",
                "value": cdempresa
            }
        ];

        // Altera a obrigatoriedade dos campos e atualiza os filtros de
        // inscrição quando a empresa for alterada.
        if (cdinscestaField.isVisible) {
            // Seta o campo de inscrição estadual como obrigatório e altera a
            // propriedade readOnly conforme inserção de empresa.
            setCampoObrigatorio(cdinscestaField, !cdempresa);
            cdinscestaField.dataSourceFilter = filter;
            cdinscestaField.needReload = true;
            cdinscestaField.reload();
        }

        if (cdinscmuniField.isVisible) {
            // Seta o campo de inscrição municipal como obrigatório e altera a
            // propriedade readOnly conforme inserção de empresa.
            setCampoObrigatorio(cdinscmuniField, !cdempresa);
            cdinscmuniField.dataSourceFilter = filter;
            cdinscmuniField.needReload = true;
            cdinscmuniField.reload();
        }
    };

    /*
     * Função para alterar exibição e obrigatoriedade de campos no filtro,
     * conforme tipo de apuração inserido.
     */
    this.controlaCamposFiltro = function(filterPopup) {
        var filterRow = filterPopup.currentRow;

        var impostoField = filterPopup.getField("DSIMPOSTONFE");
        var inscricaoEstadualField = filterPopup.getField("CDINSCESTA");
        var inscricaoMunicipalField = filterPopup.getField("CDINSCMUNI");
        var tipoApurac = filterRow.IDTIPOAPURA;

        // Reseta os valores no filtro.
        filterRow.DSIMPOSTONFE = '';
        filterRow.CDIMPOSTO = '';
        filterRow.SGIMPOSTONFE = '';
        filterRow.CDINSCESTA = '';
        filterRow.CDINSCMUNI = '';
        
        // Valida quais campos deverão ser exibidos no filtro para cada tipo
        // de apuração.
        switch (tipoApurac) {
            case "F":
                setCampoObrigatorio(impostoField, false);
                setCampoInvisible(inscricaoEstadualField);
                setCampoInvisible(inscricaoMunicipalField);
                break;
            case "E":
                setCampoObrigatorio(impostoField, false);
                setCampoObrigatorio(inscricaoEstadualField, true);
                setCampoInvisible(inscricaoMunicipalField);
                break;
            case "M":
                setCampoObrigatorio(impostoField, false);
                setCampoInvisible(inscricaoEstadualField);
                setCampoObrigatorio(inscricaoMunicipalField, true);
                break;
            case "S":
                setCampoInvisible(impostoField);
                setCampoInvisible(inscricaoEstadualField);
                setCampoInvisible(inscricaoMunicipalField);
                break;
        }
        this.checkInscricaoHabilitada(filterPopup);
        // Para as apurações em que o campo Imposto é visível, só devem
        // aparecer nos filtros os impostos dessa apuração.
        if (impostoField.isVisible) {
            impostoField.dataSourceFilter = [
                {
                    "name": "IDORGARRECADNFE",
                    "operator": "=",
                    "value": tipoApurac
                }
            ];
            impostoField.needReload = true;
            impostoField.reload();
        }
    };

    /*
     * Função para armazenar os dados filtrados em variável dentro do escopo
     * deste controller. Essa variável é utilizada nos demais processos da
     * tela, facilitando-os.
     */
    this.salvaDadosFiltro = function(widget) {
        var filterPopup = widget.appliedFilter;
        // Armazena uma cópia dos valores na variável declarada no controller.
        filteredData = Util.clone(filterPopup.FILTER_ROW);
    };

    /*
     * Função para esconder um campo, removendo quaisquer validações
     * associadas.
     */
    var setCampoInvisible = function(field) {
        field.isVisible = false;
        field.readOnly = true;
        field.validations = {};
    };

    /*
     * Função para exibir um campo e setá-lo como obrigatório.
     */
    var setCampoObrigatorio = function(field, readOnly) {
        field.isVisible = true;
        field.readOnly = !!readOnly;
        field.validations = {required: true};
    };

    /*
     * Função para exibir um campo e sem colocar-lo como obrigatório.
     */
    var setCampoVisible = function(field, readOnly) {
        field.isVisible = true;
        field.readOnly = !!readOnly;
    };

    /*
     * Função chamada ao alterar o imposto selecionado. Verifica a
     * parametrização de impostos relacionados.
     */
    this.validaImpostosRelacionados = function(filterPopup) {
        var filterRow = filterPopup.currentRow;
        // Verifica se há um valor inserido para o campo de imposto.
        if (filterRow.CDIMPOSTO) {
            Fis00100_ApuracaoDeImposto_Service.vdImpostoRelac({"CDIMPOSTONFE": filterRow.CDIMPOSTO})
            .then(function(response) {
                // Verifica se a validação retornou true ou false.
                var impostoIsValid = response.dataset.validation.VDPARAMIMPRELAC;
                if (!impostoIsValid) {
                    // Exibe a mensagem de erro e remove o imposto inserido.
                    ScreenService.showMessage(Messages_fiscal.PARAM_IMPOSTO_RELAC_ERROR, 'error');
                    filterRow.CDIMPOSTO = null;
                    filterRow.SGIMPOSTONFE = null;
                    filterRow.DSIMPOSTONFE = null;
                }
            });
        }
    };


    /*
        Função para controlar elementros que serã visíveis somente
        quando o imposto selecionado for ICMS
    */
    var controlaCamposIcms = function (cdimposto){
        var widgetDetalhamento = templateManager.container.getWidget('detalhamentoGeral');
        var widgetDetalhamentoICMS = templateManager.container.getWidget('detalhamentoIcmsSt');
        var camposIcmsDetalhamento = ['VRFCPNC','VRDIFALNC','BUTDIFALIQ','VRDIFALIQU','VRIMPCARGATRIBM'];
        camposIcmsDetalhamento.forEach(function(field) {
                widgetDetalhamento.getField(field).isVisible = cdimposto===impostoIcms;
                widgetDetalhamentoICMS.isVisible = cdimposto===impostoIcms;
        });
           
    };
    
    /*
        Função que controla campos referente a codigo da receita, 
        que são diferente quando o imposto e federal e estadual.
    */
    var controlaCampoReceitaArrecadacao = function (idtipoapura){
        var campos = ['CDVARIACAO','IDPERIODICREC','IDDEBSCPINC'];
        var widgetArrecadacao = templateManager.container.getWidget('guiaFiscalArrecadaoGeral');
        if(idtipoapura ==='E'){
            visibilidadeField(widgetArrecadacao, campos, false);
        }else if (idtipoapura ==='F') {
            visibilidadeField(widgetArrecadacao, campos, true);
        }
    };
    
    var retornaMensagemApuracaoContribucies = function(avisos, nomeImpostoReferente){
        var mensagem ='';
        var mapaAtualApurado       =  avisos.mapaAtual.apurado;
        var mapaReferenteApurado   =  avisos.mapaReferente.apurado;
        
        var mapaAtualMensagens     =  avisos.mapaAtual.mensagens;
        var mapaReferenteMensagens = avisos.mapaReferente.mensagens;
        
        var nomeImpostoAtual = nomeImpostoReferente ==='60 - COFINS'? '50 - PIS':'60 - COFINS' ;
        
        
        if(mapaAtualApurado && mapaReferenteApurado && mapaAtualMensagens.length === 0 && mapaReferenteMensagens.length ===0)
            return 'Apurações realizadas com sucesso.';
        else{
            
            mensagem = nomeImpostoAtual+'<br>';
            if(mapaAtualApurado)
                mensagem = mensagem +'Apuração realizada com sucesso.<br>';
            if(mapaAtualMensagens.length>0)
                mensagem = mensagem + mapaAtualMensagens;    
            
            mensagem = mensagem +'<br>'+nomeImpostoReferente+'<br>';
            if(mapaReferenteApurado)
                mensagem = mensagem +'Apuração realizada com sucesso.<br>';
            if(mapaReferenteMensagens.length>0)
                mensagem = mensagem + mapaReferenteMensagens;    
            
            return mensagem;    
        }
   
    };
    
    
    /********************************************************
     *                                                      *
     *               Funções de Procedimentos               *
     *                                                      *
     ********************************************************/
   
    /*
        Função para realizar apuração conjunta dos mapas do
        PIS E COFINS
    */
    this.apuraMapasContribuicoes =  function (mainWidget){
        General.callRestEngine('fis_apuracoes#/apuraMapasContribuicoes','Row', mainWidget.currentRow ).then(
            function (response)  {
                var avisos = response.dataset.avisos;
                ScreenService.closePopup();
                mainWidget.reload().then(
                    function() {
                        this.checkElementsVisibility(mainWidget);
                        ScreenService.showMessage(retornaMensagemApuracaoContribucies(avisos,mainWidget.currentRow.impostoReferente));
                        var realizavalidacao = localStorage.getItem('realizavalidacao');
                        if(realizavalidacao == 'A'){
                            var codimposto = mainWidget.currentRow.CDIMPOSTO;
                            if(codimposto == '00' || codimposto == '80'  ||  codimposto == '10' || codimposto == '50' || codimposto == '60' || codimposto == '41' || codimposto == '42'){
                                var imposto   = localStorage.getItem('imposto');
                                var empresa   = localStorage.getItem('empresa');
                                var nomeempr  = localStorage.getItem('nomeempr');
                                var inscricao = localStorage.getItem('inscricao');
                                var mapa      = localStorage.getItem('mapa');
                                var nomemapa  = localStorage.getItem('nomemapa');
                    	 
                                    localStorage.setItem("imposto", mainWidget.currentRow.CDIMPOSTO);
                                	localStorage.setItem("empresa", mainWidget.currentRow.CDEMPRESA);
                                	localStorage.setItem("nomeempr", stripeWidget.currentRow.NMEMPRESA);
                                	localStorage.setItem("inscricao", mainWidget.currentRow.CDINSCESTA);
                                	localStorage.setItem("mapa", mainWidget.currentRow.NRSEQUMAPAPU);
                                	localStorage.setItem("nomemapa", mainWidget.currentRow.NMMAPAAPUR);
                                    ScreenService.openWindow('fis#fis22000_pre_validacao_declaracoes_acessorias');
                            }
                        }
                        
                    }.bind(this)
                );
                templateManager.container.getWidget("notasFiscais").needReload = true;
                templateManager.container.getWidget("apuracao_de_imposto").needReload = true;
                 var realizavalidacao = localStorage.getItem('realizavalidacao');
                        if(realizavalidacao == 'A'){
                            var codimposto = mainWidget.currentRow.CDIMPOSTO;
                            if(codimposto == '00' || codimposto == '80'  ||  codimposto == '10' || codimposto == '50' || codimposto == '60' || codimposto == '41' || codimposto == '42'){
                                var imposto   = localStorage.getItem('imposto');
                                var empresa   = localStorage.getItem('empresa');
                                var nomeempr  = localStorage.getItem('nomeempr');
                                var inscricao = localStorage.getItem('inscricao');
                                var mapa      = localStorage.getItem('mapa');
                                var nomemapa  = localStorage.getItem('nomemapa');
                    	 
                                    localStorage.setItem("imposto", mainWidget.currentRow.CDIMPOSTO);
                                	localStorage.setItem("empresa", mainWidget.currentRow.CDEMPRESA);
                                	localStorage.setItem("nomeempr", stripeWidget.currentRow.NMEMPRESA);
                                	localStorage.setItem("inscricao", mainWidget.currentRow.CDINSCESTA);
                                	localStorage.setItem("mapa", mainWidget.currentRow.NRSEQUMAPAPU);
                                	localStorage.setItem("nomemapa", mainWidget.currentRow.NMMAPAAPUR);
                                    ScreenService.openWindow('fis#fis22000_pre_validacao_declaracoes_acessorias');
                            }
                        }
            }.bind(this),
            function (callback) {
                if (callback.data) {
                    ScreenService.showMessage(callback.data.error);
                }
            }  
        );
    };
    
    // Apurar Mapa
    this.apurar = function (mainWidget){
        var self = this;
        var stripeWidget = templateManager.container.getWidget("stripe");
        Fis00100_ApuracaoDeImposto_Service.apurarMapa(mainWidget.currentRow)
        .then(function(response) {
            // Armazena os avisos retornados.
            var avisos = response.dataset.avisos;
            ScreenService.closePopup();
            // Verifica se houve algum aviso retornado.
            if (Array.isArray(avisos) && avisos.length > 0) {
                // Monta a string com os avisos e exibe ao usuário.
                var avisosMessage = avisos.join("\n");
                ScreenService.showMessage(avisosMessage).then(function() {
                    ScreenService.showMessage("Apuração concluída com sucesso. Favor realizar a pré-validação das notas e verificar se existem pendências para a geração da obrigação acessória");
                        var realizavalidacao = localStorage.getItem('realizavalidacao');
                        if(realizavalidacao == 'A'){
                            var codimposto = mainWidget.currentRow.CDIMPOSTO;
                            if(codimposto == '00' || codimposto == '80'  ||  codimposto == '10' || codimposto == '50' || codimposto == '60' || codimposto == '41' || codimposto == '42'){
                                var imposto   = localStorage.getItem('imposto');
                                var empresa   = localStorage.getItem('empresa');
                                var nomeempr  = localStorage.getItem('nomeempr');
                                var inscricao = localStorage.getItem('inscricao');
                                var mapa      = localStorage.getItem('mapa');
                                var nomemapa  = localStorage.getItem('nomemapa');
                    	 
                                    localStorage.setItem("imposto", mainWidget.currentRow.CDIMPOSTO);
                                	localStorage.setItem("empresa", mainWidget.currentRow.CDEMPRESA);
                                	localStorage.setItem("nomeempr", stripeWidget.currentRow.NMEMPRESA);
                                	localStorage.setItem("inscricao", mainWidget.currentRow.CDINSCESTA);
                                	localStorage.setItem("mapa", mainWidget.currentRow.NRSEQUMAPAPU);
                                	localStorage.setItem("nomemapa", mainWidget.currentRow.NMMAPAAPUR);
                                    ScreenService.openWindow('fis#fis22000_pre_validacao_declaracoes_acessorias');
                            }
                        }
                });
            }
            else {
                ScreenService.showMessage("Apuração concluída com sucesso. Favor realizar a pré-validação das notas e verificar se existem pendências para a geração da obrigação acessória");
                   var realizavalidacao = localStorage.getItem('realizavalidacao');
                   if(realizavalidacao == 'A'){
                            var codimposto = mainWidget.currentRow.CDIMPOSTO;
                            if(codimposto == '00' || codimposto == '80' || codimposto == '10' || codimposto == '50' || codimposto == '60' || codimposto == '41' || codimposto == '42'){
                                var imposto   = localStorage.getItem('imposto');
                                var empresa   = localStorage.getItem('empresa');
                                var nomeempr  = localStorage.getItem('nomeempr');
                                var inscricao = localStorage.getItem('inscricao');
                                var mapa      = localStorage.getItem('mapa');
                    	    	var nomemapa  = localStorage.getItem('nomemapa');
                                
                                    localStorage.setItem("imposto", mainWidget.currentRow.CDIMPOSTO);
                                	localStorage.setItem("empresa", mainWidget.currentRow.CDEMPRESA);
                                	localStorage.setItem("nomeempr", stripeWidget.currentRow.NMEMPRESA);
                                	localStorage.setItem("inscricao", mainWidget.currentRow.CDINSCESTA);
                                	localStorage.setItem("mapa", mainWidget.currentRow.NRSEQUMAPAPU);
                                	localStorage.setItem("nomemapa", mainWidget.currentRow.NMMAPAAPUR);
                                    ScreenService.openWindow('fis#fis22000_pre_validacao_declaracoes_acessorias');
                            }
                        }
                    
            }
            
            mainWidget.reload().then(function() {
                self.checkElementsVisibility(mainWidget);
                //self.verificaEdicaoDetalhamento(mainWidget);
            });
            // Seta as widgets que são grids para que sejam recarregadas ao
            // entrar.
            templateManager.container.getWidget("detalhamentoIcmsSt").needReload = true;
            templateManager.container.getWidget("notasFiscais").needReload = true;
            templateManager.container.getWidget("apuracao_de_imposto").needReload = true;
            if (simplesNacionalIsSelected()) {
                templateManager.container.getWidget("simplesNacionalTabelaReferencia").needReload = true;
            }
        })
        .catch(function(errorResponse) {
            if (errorResponse.data) {
                ScreenService.showMessage(errorResponse.data.error);
            }
        });         
    };
    
    /*
     * Função para apurar um mapa desbloqueado.
     */
    this.apurarMapa = function() {
        var mainWidget    = templateManager.container.getWidget("apuracao_de_imposto");
        var cdsitucrt     = filteredData.CDSITUCRT;
        var idapuimpgersn = filteredData.IDAPUIMPGERESN;
        var idtipoapura   = filteredData.IDTIPOAPURA;
        var cdimposto       = mainWidget.currentRow.CDIMPOSTO;
        var stripeWidget = templateManager.container.getWidget("stripe");

        //mainWidget.currentRow.IDTIPOAPURA = idtipoapura;
        // Correção de erro do Zeedhi, que não fecha a popup de actions.
        ScreenService.closePopup();
        if (!Fis00100_ApuracaoDeImposto_Service.bloqueiaMapaRegime(idtipoapura, cdsitucrt, idapuimpgersn)) {
            var self = this;
            if(contribuicoesIsSelected(mainWidget.currentRow.CDIMPOSTO)){
                var impostoReferente                     = mainWidget.currentRow.CDIMPOSTO === impostoPis ? '60 - COFINS' :'50 - PIS';
                var cdimpostoReferente                   = mainWidget.currentRow.CDIMPOSTO === impostoPis ? '60' :'50';
                var nmimpostoReferente                   = mainWidget.currentRow.CDIMPOSTO === impostoPis ? 'COFINS' :'PIS';
                
                mainWidget.currentRow.impostoReferente   = impostoReferente;
                mainWidget.currentRow.CDIMPOSTOREFERENTE = cdimpostoReferente;
                mainWidget.currentRow.NMIMPOSTOREFERENTE = nmimpostoReferente;
                
                ScreenService.confirmMessage(ScreenService.i18n("Deseja apurar também o mapa do '"+impostoReferente+"' para o mesmo período ?"), 'question', 
                    function (success) {
                        self.apuraMapasContribuicoes(mainWidget);
                         var realizavalidacao = localStorage.getItem('realizavalidacao');
                           if(realizavalidacao == 'A'){
                            var codimposto = mainWidget.currentRow.CDIMPOSTO;
                            if(codimposto == '00' || codimposto == '80' || codimposto == '10' || codimposto == '50' || codimposto == '60' || codimposto == '41' || codimposto == '42'){
                                var imposto   = localStorage.getItem('imposto');
                                var empresa   = localStorage.getItem('empresa');
                                var nomeempr  = localStorage.getItem('nomeempr');
                                var inscricao = localStorage.getItem('inscricao');
                                var mapa      = localStorage.getItem('mapa');
                    	        var nomemapa  = localStorage.getItem('nomemapa');
                    	        
                                	localStorage.setItem("nomemapa", mainWidget.currentRow.NMMAPAAPUR);
                                    localStorage.setItem("imposto", mainWidget.currentRow.CDIMPOSTO);
                                	localStorage.setItem("empresa", mainWidget.currentRow.CDEMPRESA);
                                	localStorage.setItem("nomeempr", stripeWidget.currentRow.NMEMPRESA);
                                	localStorage.setItem("inscricao", mainWidget.currentRow.CDINSCESTA);
                                	localStorage.setItem("mapa", mainWidget.currentRow.NRSEQUMAPAPU);
                                    ScreenService.openWindow('fis#fis22000_pre_validacao_declaracoes_acessorias');
                            }
                        }
                    },
                    function (error){
                        self.apurar(mainWidget);
                    }
                );
            }else{
                self.apurar(mainWidget);
            }
        }
        else {
            ScreenService.showMessage(Messages_fiscal.MAPA_REGIME_EMPRESA_ERROR, 'error');
        }
                };

    /*
     * Função para bloquear o último mapa de apuração desbloqueado.
     */
    this.bloquearMapa = function() {
        var mainWidget = templateManager.container.getWidget("apuracao_de_imposto");
        var cdsitucrt = filteredData.CDSITUCRT;
        var idapuimpgersn = filteredData.IDAPUIMPGERESN;
        var idtipoapura = filteredData.IDTIPOAPURA;
        var stripeWidget = templateManager.container.getWidget("stripe");
        
        //mainWidget.currentRow.IDTIPOAPURA = idtipoapura;
        // Correção de erro do Zeedhi, que não fecha a popup de actions.
        ScreenService.closePopup();
        if (!Fis00100_ApuracaoDeImposto_Service.bloqueiaMapaRegime(idtipoapura, cdsitucrt, idapuimpgersn)) {
            var self = this;
            // Executa validação de bloqueio de um mapa de Contribuições.
            if (contribuicoesIsSelected()) {
                var arrecadacaoWidget = templateManager.container.getWidget("contribuicoesArrecadacao");
                if (!arrecadacaoWidget.isValid()) {
                    // Muda para a widget de Arrecadação.
                    arrecadacaoWidget.activate().then(function() {
                        // Executa a função novamente para exibir quais campos estão
                        // inválidos.
                        arrecadacaoWidget.isValid(function(validations) {
                            var invalidFields = validations.filter(function(validation) {
                                return validation.length > 0;
                            });
                            var invalidFieldLabel = invalidFields[0][0].fieldLabel;
                            // Exibe o primeiro field inválido.
                            ScreenService.showMessage(invalidFieldLabel + " deve ser informado.");
                        });
                    });

                    // Sai da função, devido aos dados inválidos.
                    return;
                }
            }else if(impostosGeraisIsSelected(mainWidget.currentRow) && mainWidget.currentRow.CDIMPOSTO !== impostoIcmsSt ) {
                var arrecadacaoGeralWidget = templateManager.container.getWidget('guiaFiscalArrecadaoGeral');
                /* Caso o mapa esteja apurado e o valor total for igual a zero
                não é necessário informar o  codigo da natureza e o vencimento
                */
                if(mainWidget.currentRow.IDBLOQMAPAPU==='A'){
                     if(parseFloat(mainWidget.currentRow.VRTOTAIMPOS) >0){
                        if(!arrecadacaoGeralWidget.currentRow.DTVENCGUIA){
                            arrecadacaoGeralWidget.getParent().activate().then(function() {
                                ScreenService.showMessage('Data de Vencimento deve ser informada.');
                            });
                            return;
                        }else if(!arrecadacaoGeralWidget.currentRow.CDRECEGUIA){
                            arrecadacaoGeralWidget.getParent().activate().then(function() {
                                ScreenService.showMessage('Código da Receita deve ser informado.');
                            });
                            return;
                        }
                    }
                }
                /* Caso occora uma tentativa de bloquear o mapa sem ele estar apurado, ´
                é necessário informar o codigo da receita e o vencimento
                */
                else{
                    if(!arrecadacaoGeralWidget.currentRow.DTVENCGUIA){
                        arrecadacaoGeralWidget.getParent().activate().then(function() {
                            ScreenService.showMessage('Data de Vencimento deve ser informada.');
                        });
                        return;
                    }else if(!arrecadacaoGeralWidget.currentRow.CDRECEGUIA){
                        arrecadacaoGeralWidget.getParent().activate().then(function() {
                            ScreenService.showMessage('Código da Receita deve ser informado.');
                        });
                        return;
                    }
                }
                
                
            }
            
            Fis00100_ApuracaoDeImposto_Service.bloquearMapa(mainWidget.currentRow)
            .then(function() {
                ScreenService.closePopup();
                ScreenService.showMessage("Mapa Bloqueado com Sucesso! Favor realizar a pré-validação das notas e verificar se existem pendências para a geração da obrigação acessória");
                mainWidget.reload().then(function() {
                    self.checkElementsVisibility(mainWidget);
                    //self.verificaEdicaoDetalhamento(mainWidget);
                });
                // Seta as widgets que são grids para que sejam recarregadas ao
                // entrar.
                templateManager.container.getWidget("detalhamentoIcmsSt").needReload = true;
                templateManager.container.getWidget("notasFiscais").needReload = true;
                if (simplesNacionalIsSelected()) {
                    templateManager.container.getWidget("simplesNacionalTabelaReferencia").needReload = true;
                }
                var realizavalidacao = localStorage.getItem('realizavalidacao');
                if(realizavalidacao == 'B' || realizavalidacao == 'A'){
                            var codimposto = mainWidget.currentRow.CDIMPOSTO;
                            if(codimposto == '00' || codimposto == '80' || codimposto == '10' || codimposto == '50' || codimposto == '60' || codimposto == '41' || codimposto == '42'){
                                var imposto   = localStorage.getItem('imposto');
                                var empresa   = localStorage.getItem('empresa');
                                var nomeempr  = localStorage.getItem('nomeempr');
                                var inscricao = localStorage.getItem('inscricao');
                                var mapa      = localStorage.getItem('mapa');
                    	    	var nomemapa  = localStorage.getItem('nomemapa');
                    	    	
                                	localStorage.setItem("nomemapa", mainWidget.currentRow.NMMAPAAPUR);
                                    localStorage.setItem("imposto", mainWidget.currentRow.CDIMPOSTO);
                                	localStorage.setItem("empresa", mainWidget.currentRow.CDEMPRESA);
                                	localStorage.setItem("nomeempr", stripeWidget.currentRow.NMEMPRESA);
                                	localStorage.setItem("inscricao", mainWidget.currentRow.CDINSCESTA);
                                	localStorage.setItem("mapa", mainWidget.currentRow.NRSEQUMAPAPU);
                                    ScreenService.openWindow('fis#fis22000_pre_validacao_declaracoes_acessorias');
                            }
                        }
            })
            .catch(function(errorResponse) {
                if (errorResponse.data) {
                    
                    //Casso o error for referente a somas do valores do ICMS ST , redireciona para widget correspondente
                    if( errorResponse.data.error.indexOf('O(s) seguinte(s) estado(s)') !== -1 )
                        templateManager.container.getWidget('detalhamentoIcmsSt').activate();
                    
                    ScreenService.showMessage(errorResponse.data.error);
                }
            });
        }
        else {
            ScreenService.showMessage(Messages_fiscal.MAPA_REGIME_EMPRESA_ERROR, 'error');
        }
    };

    /*
     * Função para excluir um item de detalhamento de um mapa de Contribuições.
     */
    this.deleteItemDetalhamentoContribuicoes = function(widget) {
        if(!widget.currentRow.CDLOTE){
            General.deleteCrud(widget).then(function() {
                var mainWidget = templateManager.container.getWidget("apuracao_de_imposto");
                
                mainWidget.reload();
            });            
        }else{
            ScreenService.showMessage('Exclusão não permitida! Existe um lote associado a esse ajuste.');
        }
    };

    /*
     * Função para excluir o último mapa de apuração, contanto que não esteja
     * bloqueado.
     */
    this.deleteMapa = function(args) {
        var widget = args.owner.widget;
        var cdsitucrt = filteredData.CDSITUCRT;
        var idapuimpgersn = filteredData.IDAPUIMPGERESN;
        var idtipoapura = filteredData.IDTIPOAPURA;
        if (!Fis00100_ApuracaoDeImposto_Service.bloqueiaMapaRegime(idtipoapura, cdsitucrt, idapuimpgersn)) {
            // Exibe uma mensagem de confirmação para o usuário
            ScreenService.confirmMessage(ScreenService.i18n('Excluir Registro?'), 'question', function() {
                widget.currentRow.IDTIPOAPURA = filteredData.IDTIPOAPURA;
                Fis00100_ApuracaoDeImposto_Service.deleteMapa(widget.currentRow).then(
                    function() {
                        ScreenService.closeSwipe().then(function() {
                            ScreenService.showMessage('Deletado com sucesso.');
                            widget.activate();
                            widget.reload();
                        });
                    },
                    function (error) {
                        if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
                            ScreenService.showMessage('Exclusão não permitida! O registro possui registros filhos.');
                        } else {
                            ScreenService.showMessage(error.data.error);
                        }
                    
                    }
                );
            });
        }
        else {
            ScreenService.showMessage(Messages_fiscal.MAPA_REGIME_EMPRESA_ERROR, 'error');
        }
    };

    /*
     * Função para desbloquear um mapa de apuração bloqueado.
     */
    this.desbloquearMapa = function() {
        var mainWidget = templateManager.container.getWidget("apuracao_de_imposto");
        var cdsitucrt = filteredData.CDSITUCRT;
        var idapuimpgersn = filteredData.IDAPUIMPGERESN;
        var idtipoapura = filteredData.IDTIPOAPURA;
        
        ScreenService.closePopup();
        //mainWidget.currentRow.IDTIPOAPURA = idtipoapura;
        
        if (!Fis00100_ApuracaoDeImposto_Service.bloqueiaMapaRegime(idtipoapura, cdsitucrt, idapuimpgersn)) {
            var self = this;
            Fis00100_ApuracaoDeImposto_Service.desbloquearMapa(mainWidget.currentRow)
            .then(function() {
                mainWidget.reload().then(function() {
                    self.checkElementsVisibility(mainWidget);
                    //self.verificaEdicaoDetalhamento(mainWidget);
                });
                ScreenService.showMessage(Messages_fiscal.MAPA_DESBLOQUEADO_SUCESSO);
            })
            .catch(errorHandler);
        }
        else {
            ScreenService.showMessage(Messages_fiscal.MAPA_REGIME_EMPRESA_ERROR, 'error');
        }
    };

    /*
     * Função para salvar um detalhamento de um mapa de Simples Nacional.
     */
    this.salvarDetalhamentoSimplesNacional = function(widget) {
        // Calcula valores conforme widget selecionada.
        Fis00100_ApuracaoDeImposto_Service.calculaValorTotalDetalhamento(widget.currentRow, widget.name);
        widget.saveRow().then(
            function() {
                widget.reload();
                widget.template = widget.templateToView;
                widget.view();
                widget.activate();
                widget.getParent().view();
                changeWidgetsEnabledProperty(true);
            }.bind(this),
            function(callback) {
                if (callback.data) {
                    ScreenService.showMessage(callback.data.error);
                }
            }
        );
    };

    /*
     * Função para salvar um mapa de apurações, após realizar as devidas
     * validações.
     */
    this.salvarMapa = function(widget) {
        if (widget.isValid()) {
            var currentRow = widget.currentRow;
            // Verifica se a data final é igual ou maior à data inicial.
            if (currentRow.DTFIMPERIODO && moment(currentRow.DTFIMPERIODO, 'DD/MM/YYYY').isBefore(moment(currentRow.DTINIPERIODO, 'DD/MM/YYYY'))) {
                ScreenService.showMessage(Messages_fiscal.DTINI_POST_DTFIM_ERROR);
                return;
            }
            if (widget.isNewRow()) {
                // Seta na currentRow os valores do paramsNewCode da widget.
                Object.keys(widget.paramsNewCode).forEach(function(value) {
                    currentRow[value] = widget.paramsNewCode[value];
                });

                // Seta os dados filtrados na currentRow.
                currentRow.CDEMPRESA = filteredData.CDEMPRESA;
                currentRow.CDIMPOSTO = filteredData.CDIMPOSTO;
                currentRow.CDINSCESTA = filteredData.CDINSCESTA;
                currentRow.CDINSCMUNI = filteredData.CDINSCMUNI;
                // Se não houver Data Final preenchida, implica que esta não é
                // obrigatória e a data referência está sendo utilizada.
                if (!currentRow.DTFIMPERIODO) {
                    var dataReferencia = moment(currentRow.DTREFERENCIA, 'DD/MM/YYYY');
                    currentRow.DTINIPERIODO = dataReferencia.format('DD/MM/YYYY');
                    currentRow.DTFIMPERIODO = dataReferencia.endOf('month').format('DD/MM/YYYY');
                }
                var self = this;
                Fis00100_ApuracaoDeImposto_Service.saveMapa(currentRow)
                .then(function(response) {
                    currentRow.NRORG = response.dataset.columnsToReturn[0].NRORG;
                    widget.view();
                    widget.reload().then(function() {
                        self.checkElementsVisibility(widget);
                    });
                    widget.reload([], false);
                    changeWidgetsEnabledProperty(true);
                    changeEnabledPropertyGridWidgets(widget);
                    habilitaAjusteContribuicao(widget);
                })
                .catch(errorHandler);
            }
            else {
                Fis00100_ApuracaoDeImposto_Service.saveMapa(currentRow)
                .then(function() {
                    widget.view();
                    changeWidgetsEnabledProperty(true);
                    changeEnabledPropertyGridWidgets(widget);
                    habilitaAjusteContribuicao(widget);
                })
                .catch(errorHandler);
            }
        }
    };

    /*
     * Função para salvar dados na widget de ajustes para um mapa de
     * Contribuições, realizando as devidas validações.
     */
    this.saveAjusteContribuicoes = function(widget) {
        if (widget.isValid()) {
            var currentRow = widget.currentRow;
            var isCredito = currentRow.IDINDICAJUSTE == "C";
            var isRegimeCumulativo = currentRow.IDCUMUPISCOFIL == "N";
            // Se um ajuste for de crédito, o regime não pode ser cumulativo.
            if (isCredito && isRegimeCumulativo) {
                ScreenService.showMessage(Messages_fiscal.AJUSTE_CREDITO_CUMULATIVO_ERROR);
                return;
            }
            
            if(widget.currentRow.IDAPROPRIACAO == null){
                widget.currentRow.IDAPROPRIACAO = "01";
            }

            var mainWidget = templateManager.container.getWidget("apuracao_de_imposto");

            // Se for um ajuste novo, deve retornar um sequencial gerado para
            // este ajuste antes de salvá-lo.
            if (widget.isNewRow()) {
                Fis00100_ApuracaoDeImposto_Service.getNextSequencialAjusteContribuicoes(currentRow)
                .then(function(response) {
                    currentRow.NRSEQAJUSTE = response.dataset.codigo.NRSEQAJUSTE;
                    General.saveCrud(widget).then(function() {
                        mainWidget.reload();
                        templateManager.container.getWidget("ajusteContribuicao").reload();
                    });
                });
            }
            else {
                Fis00100_ApuracaoDeImposto_Service.saveAjusteContribuicoes(currentRow).then(function() {
                //General.saveCrud(widget).then(function() {
                    widget.view();
                    widget.reload();
                    mainWidget.reload();
                    templateManager.container.getWidget("ajusteContribuicao").reload();
                });
            }
        }
    };

    this.salvarArrecadacaoGeral = function (widget) {
        if( widget.isValid() ) {
            General.callRestEngine('fis_apuracoes#/salvarArrecadacaoGeral','Row', widget.currentRow ).then(
                function (success)  {
                    var mainWidget = templateManager.container.getWidget("apuracao_de_imposto");
                    // Muda o template para modo de visualização novamente.
                    widget.view();
                    General.formWidgetSwitchTemplate(widget);
                    changeWidgetsEnabledProperty(true);
                    mainWidget.reload();
                    widget.getParent().view();
                    this.checkElementsVisibility(templateManager.container.getWidget('apuracao_de_imposto'));
                }.bind(this),
                function (callback) {
                    if (callback.data) {
                        ScreenService.showMessage(callback.data.error);
                    }
                }  
            );
        }
        
    };

    /*
     * Função para salvar alterações realizadas na widget de Arredação Fiscal
     * para mapas de Contribuições.
     */
    this.saveArrecadacaoContribuicoes = function(widget) {
        var currentRow = widget.currentRow;
        // Seta os dados comuns aos dois campos de Código da Receita. Seta o
        // valor de um que não esteja nulo, ou nulo, caso não haja valor
        // inserido em ambos.
        currentRow.CDVARIACAO = currentRow.CDVARIACAO || currentRow.CDVARIACAONC || currentRow.CDVARIACAOC;
        currentRow.CDRECEITACONTR = currentRow.CDRECEITACONTRNC || currentRow.CDRECEITACONTRC;
        currentRow.IDPERIODICREC = currentRow.IDPERIODICRECNC || currentRow.IDPERIODICRECC;
        currentRow.IDDEBSCPINC = currentRow.IDDEBSCPINCNC || currentRow.IDDEBSCPINCC;
        Fis00100_ApuracaoDeImposto_Service.saveArrecadacaoContribuicoes(widget.currentRow).then(function() {
            var mainWidget = templateManager.container.getWidget("apuracao_de_imposto");
            // Muda o template para modo de visualização novamente.
            widget.view();
            General.formWidgetSwitchTemplate(widget);
            changeWidgetsEnabledProperty(true);
            mainWidget.reload();
            this.checkElementsVisibility(templateManager.container.getWidget('apuracao_de_imposto'));
        }.bind(this))
        .catch(errorHandler);
    };

    /*
     * Função para salvar um item de detalhamento de um mapa de Contribuições.
     * Não altera a propriedade "enabled" das outras widgets por haver somente
     * um widget exibida na tabbed.
     */
    this.saveItemDetalhamentoContribuicoes = function(widget) {
        General.saveCrud(widget).then(function() {
            var mainWidget = templateManager.container.getWidget("apuracao_de_imposto");
            mainWidget.reload();
        });
    };
   

    /*
        Função para salvar registro da widgte de Guias complementares que 
        só esta disponivél para apuração de Impostos Gerais e caso o imposto seja ICMS
    */
    this.salvarGuiasComplementares = function (widget){
        var widgetApuracao = templateManager.container.getWidget('apuracao_de_imposto');
        if( widget.isValid() ){
            if(!widget.currentRow.NRPROCESSOGUIA)  {
                widget.currentRow.IDORIGEMGUIA    = '9';
                widget.currentRow.DSHISTGUIACOMPL = '';
            }
            
            widget.currentRow.DATASOURCENAME = widget.dataSource.name.substr(20);
                
            if(widget.currentRow.__is_new){
                widget.currentRow.NRSEQUMAPAPU = widgetApuracao.currentRow.NRSEQUMAPAPU;
            }
            General.callRestEngine('fis_apuracoes#/salvarGuiasComplementares','Row', widget.currentRow ).then(
                function (response) {
                    sucessoSalvarGrid(widget);
                },
                function (callback) {
                    if (callback.data) {
                        ScreenService.showMessage(callback.data.error);
                    }
                }  
            );
        }
    };
    
    /* Função que realizará o procedimento de save de todas as abas
    que serão abertas apartir dos botões existentes na aba de detalhamento
    da apuração de Impostos Gerais*/
    this.salvarSubDetalhamentoImpostosGerais = function (widget){
        if( widget.isValid() ){
            var widgetApuracao = templateManager.container.getWidget('apuracao_de_imposto');
            if(widget.currentRow.CDITEMOCOR)
                widget.currentRow.CDITEMOCOR = widget.currentRow.CDITEMOCOR.replace(/[^0-9]/g,'');
            
            General.callRestEngine('fis_apuracoes#/salvarSubDetalhamentoImpostosGerais','Row', widget.currentRow ).then(
                function (response) {
                    widgetApuracao.reload();
                    sucessoSalvarGrid(widget);        
                },
                function (callback) {
                    if (callback.data) {
                        ScreenService.showMessage(callback.data.error);
                    }
                }  
            );    
        }
    };
    
    
    
    /* Função que realizará o procedimento de save de todas as abas
    que serão abertas apartir dos botões existentes na aba de detalhamento
    da apuração do ICMS (DIFAL/FCP */
    this.salvarSubDetalhamentoIcmsDifalFcp = function (widget){
        if( widget.isValid() ){
            var widgetApuracao = templateManager.container.getWidget('apuracao_de_imposto');
            var widgetDifalFcp = templateManager.container.getWidget('widgetDifalIcms');
           
            if(widget.currentRow.__is_new){
                widget.currentRow.NRSEQMAPAPURESTNC = widgetDifalFcp.currentRow.NRSEQMAPAPURESTNC;
                widget.currentRow.NRSEQUMAPAPU      = widgetDifalFcp.currentRow.NRSEQUMAPAPU;
                widget.currentRow.IDTIPOITMAPR      = widget.dataSourceFilter[2].value;
                widget.currentRow.IDAJUSTENC        = widget.dataSourceFilter[3].value;
                widget.currentRow.NRSEQITMAPRECNC   = '';
            }
                
            General.callRestEngine('fis_apuracoes#/salvarSubDetalhamentoIcmsDifalFcp','Row', widget.currentRow ).then(
                function (response) {
                    widgetApuracao.reload();
                    widgetDifalFcp.reload();
                    sucessoSalvarGrid(widget);        
                },
                function (callback) {
                    if (callback.data) {
                        ScreenService.showMessage(callback.data.error);
                    }
                }  
            );    
        }
    };
    
    this.salvarCreditoAnterior = function (widget,dataSource,nomewidgetPai){
        if( widget.isValid() ){
            var widgetApuracao = templateManager.container.getWidget('apuracao_de_imposto');
            var widgetPai      = templateManager.container.getWidget(nomewidgetPai);
            General.callRestEngine(dataSource,'Row', widget.currentRow ).then(
                function (response) {
                    if(widget.name==='widgetCreditoAnteriorIcmsSt'){
                        widgetApuracao.reload().then(
                            function (response) {
                                widgetPai.reload();
                            }
                        );
                    }else{
                        widgetApuracao.reload();    
                    }
                    ScreenService.goBack();
                    widgetPai.activate();
                },
                function (callback) {
                    if (callback.data) {
                        ScreenService.showMessage(callback.data.error);
                    }
                }  
            );    
        }
    };
    
    this.salvarCreditoAnteriorDifalFcp = function (widget){
        if( widget.isValid() ){
            //var widgetApuracao = templateManager.container.getWidget('apuracao_de_imposto');
            var nomewidgetPai  = widget.currentRow.TIPO ==='DIFAL'?'widgetDetalhamentoIcmsDifal':'widgetDetalhamentoIcmsFcp';
            var widgetPai      = templateManager.container.getWidget(nomewidgetPai);
            widget.currentRow.IDAJUSTENC = widget.currentRow.TIPO ==='DIFAL'?'D':'F';
            General.callRestEngine('fis_apuracoes#/salvarCreditoAnteriorDifalFcp','Row', widget.currentRow ).then(
                function (response) {
                    ScreenService.goBack();
                    widgetPai.activate();
                    widgetPai.getParent().getParent().reload();
                },
                function (callback) {
                    if (callback.data) {
                        ScreenService.showMessage(callback.data.error);
                    }
                }  
            );    
        }
    };
    
    this.salvarSubDetalhamentoInss = function (widget){
        if( widget.isValid() ){
            var widgetApuracao = templateManager.container.getWidget('apuracao_de_imposto');
            if(widget.currentRow.__is_new){
                widget.currentRow.NRSEQUMAPAPU = widgetApuracao.currentRow.NRSEQUMAPAPU;
                widget.currentRow.IDTIPODETAPU = widget.dataSourceFilter[1].value;
            }
            General.callRestEngine('fis_apuracoes#/salvarSubDetalhamentoInss','Row', widget.currentRow ).then(
                function (response) {
                    widgetApuracao.reload();
                    sucessoSalvarGrid(widget);        
                },
                function (callback) {
                    if (callback.data) {
                        ScreenService.showMessage(callback.data.error);
                    }
                }  
            );    
        }
    };
    
    this.salvarSubDetalhamentoIcmsSt = function (widget){
        if( widget.isValid() ){
            var widgetApuracao    = templateManager.container.getWidget('apuracao_de_imposto');
            var widgetDetalhameto = templateManager.container.getWidget('detalhamentoIcmsSt');
            
            //valores default
            widget.currentRow.CDFILIAL    = widget.currentRow.CDFILIAL ? widget.currentRow.CDFILIAL : '';
            widget.currentRow.NRLANCTONF  = widget.currentRow.NRLANCTONF ? widget.currentRow.NRLANCTONF : '';
            
            if(widget.currentRow.__is_new){
                if(widget.dataSourceFilter[1].value == 'OC' || widget.dataSourceFilter[1].value == 'DD'){
                    widget.currentRow.IDTPAJUSTEAPSG = 'C';
                } else if(widget.dataSourceFilter[1].value == 'OD' || widget.dataSourceFilter[1].value =='DE'){
                    widget.currentRow.IDTPAJUSTEAPSG = 'D';
                }
                widget.currentRow.IDTPAJUSTE   = widget.dataSourceFilter[1].value;
                widget.currentRow.NRSEQUMAPAPU     = widgetDetalhameto.currentRow.NRSEQUMAPAPU;
                widget.currentRow.NRSEQMAPAAPUREST = widgetDetalhameto.currentRow.NRSEQMAPAAPUREST;
                widget.currentRow.CDPAIS           = widgetDetalhameto.currentRow.CDPAIS;
                widget.currentRow.SGESTADO         = widgetDetalhameto.currentRow.SGESTADO;
            }
            General.callRestEngine('fis_apuracoes#/salvarSubDetalhamentoIcmsSt','Row', widget.currentRow ).then(
                function (response) {
                    widgetApuracao.reload().then(
                        function (response) {
                            widgetDetalhameto.reload();
                        }
                    );
                    sucessoSalvarGrid(widget);        
                },
                function (callback) {
                    if (callback.data) {
                        ScreenService.showMessage(callback.data.error);
                    }
                }  
            );    
        }
    };
    
    this.salvarDetalhamento = function (widget, dataSource){
        General.callRestEngine(dataSource,'Row', widget.currentRow ).then(
            function(sucess) {
                widget.template = widget.templateToView;
                widget.view();
                widget.activate();
                General.changeWidgetAcessibility(widget.getParent().widgets, true);
                templateManager.container.getWidget('apuracao_de_imposto').enabled = true;
                templateManager.container.getWidget('apuracao_de_imposto').reload();
            }.bind(this),
            function(callback){
                if(callback.data){
                    ScreenService.showMessage(callback.data.error);
                }
            }
        );
    };
   
    /*
     Função que realizará o procedimento de exclusão de todas as abas
    que serão abertas apartir dos botões existentes na aba de detalhamento
    da apuração de Impostos Geras.
    */
    this.deletarSubDetalhamentoImpostosGerais = function (widget){
        if(!widget.currentRow.CDLOTE){
            ScreenService.confirmMessage(ScreenService.i18n('Delete Register?'), 'question', function (success) {
                widget.currentRow.CDIMPOSTO = templateManager.container.getWidget('apuracao_de_imposto').currentRow.CDIMPOSTO;
                General.callRestEngine('fis_apuracoes#/deletarSubDetalhamentoImpostosGerais','Row', widget.currentRow ).then(
                    function (response) {
                        ScreenService.closeSwipe().then(function () {
                           ScreenService.showMessage('Deletado com sucesso.');
                            widget.activate();
                            widget.reload();
                        });
                        var widgetApuracao    = templateManager.container.getWidget('apuracao_de_imposto');
                        var widgetDetalhameto = templateManager.container.getWidget('detalhamentoIcmsSt');
                        if(widget.name==='widgetItensDetalhamentoIcmsSt'){
                            widgetApuracao.reload().then(
                                function (response) {
                                    widgetDetalhameto.reload();
                                }
                            );
                        }else{
                            widgetApuracao.reload();
                        }
                    },
                    function (callback) {
                        if (callback.data && callback.data.error.indexOf('ORA-02292') !== -1) {
                            ScreenService.showMessage('Exclusão não permitida! O registro possui registros filhos.');
                        } else {
                            ScreenService.showMessage(callback.data.error);
                        }
                    }  
                );   	
            });            
        }else{
            ScreenService.showMessage('Exclusão não permitida! Existe um lote associado a esse ajuste.');
        }
    };
    
    this.editarSubDetalhamentoImpostosGerais = function(widget){
        if(!widget.currentRow.CDLOTE){
            General.edit(widget);
        }else{
            ScreenService.showMessage('Edição não permitida! Existe um lote associado a esse ajuste.');
        }
    };
    
    this.deletarSubDetalhamentoDifalFcp = function (widget){
        ScreenService.confirmMessage(ScreenService.i18n('Delete Register?'), 'question', function (success) {
            General.callRestEngine('fis_apuracoes#/deletarSubDetalhamentoDifalFcp','Row', widget.currentRow ).then(
                function (response) {
                    ScreenService.closeSwipe().then(function () {
                       ScreenService.showMessage('Deletado com sucesso.');
                        widget.activate();
                        widget.reload();
                    });
                    templateManager.container.getWidget('apuracao_de_imposto').reload();
                    templateManager.container.getWidget('widgetDifalIcms').reload();
                },
                function (callback) {
                    if (callback.data && callback.data.error.indexOf('ORA-02292') !== -1) {
                        ScreenService.showMessage('Exclusão não permitida! O registro possui registros filhos.');
                    } else {
                        ScreenService.showMessage(callback.data.error);
                    }
                }  
            );   	
        });
         
        
    };
    
    this.salvarItensComposicoes = function (args){
        var widget = args.owner.widget;
        if( widget.isValid() ){
            var nomeWidgetDetalhamento = widget.name === 'widgetItensComposicaoIcmsSt' ? 'widgetItensDetalhamentoIcmsSt': 'widgetItensDetalhamento'; 
            var nomeCampoValor         = widget.name === 'widgetItensComposicaoIcmsSt' ? 'VRAJUSTEAPURSG': 'VRITEMMAPR';  
            var widgetDetalhamento     = templateManager.container.getWidget(nomeWidgetDetalhamento);
            
            //Valores para realizar o calculo do detalahemtno do impostos ICMS ST
            if(widget.name ==='widgetItensComposicaoIcmsSt'){
                widget.currentRow.NRSEQMAPAAPUREST = widgetDetalhamento.currentRow.NRSEQMAPAAPUREST;
                widget.currentRow.CDPAIS           = widgetDetalhamento.currentRow.CDPAIS;
                widget.currentRow.SGESTADO         = widgetDetalhamento.currentRow.SGESTADO;
            }
                
            General.callRestEngine('fis_apuracoes#/salvarItensComposicoes','Row', widget.currentRow ).then(
                function (response) {
                    
                    if(widget.name==='widgetItensComposicaoIcmsSt')
                        templateManager.container.getWidget('detalhamentoIcmsSt').reload();
                    
                    templateManager.container.getWidget('apuracao_de_imposto').reload();
                    widgetDetalhamento.reload().then(
                        function () {
                            widgetDetalhamento.currentRow[nomeCampoValor] = response.dataset.soma.VALOR;
                            if(widgetDetalhamento.backupRow)
                                widgetDetalhamento.backupRow[nomeCampoValor]   = response.dataset.soma.VALOR;
                        }
                    );
                    sucessoSalvarGrid(widget);
                },
                function (callback) {
                    if (callback.data) {
                        ScreenService.showMessage(callback.data.error);
                    }
                }  
            );    
        }
    };
    
    /*
    Função que realiza procedimento necessários ao relizar um save em um grid
    */
    var sucessoSalvarGrid = function (widget){
        widget.activate();
        if (widget.currentRow.__is_new) {
            widget.list(true);
            ScreenService.goBack();
            widget.reload();
        } else {
            widget.computeDescriptionOrder();
            widget.view();
        }
        widget.currentRow.__is_new = false;    
    };

    this.salvarArrecadacaoIcmsSt = function (widget){
        if( widget.isValid() ){
            
            General.callRestEngine('fis_apuracoes#/salvarArrecadacaoIcmsSt','Row', widget.currentRow ).then(
                function (response) {
                    sucessoSalvarGrid(widget);
                },
                function (callback) {
                    if (callback.data) {
                        ScreenService.showMessage(callback.data.error);
                    }
                }  
            );    
        }
    };


    /********************************************************
     *                                                      *
     *          Funções de Manipulação de Elementos         *
     *                                                      *
     ********************************************************/

    
    /*
     * Função para validar a abertura do formulário para adição de um mapa de
     * apuração.
     */
    this.addMapa = function(widget) {
        // Verifica se o filtro foi preenchido corretamente, verificando se há
        // uma empresa filtrada.
        if (filteredData.CDEMPRESA) {
            var cdsitucrt = filteredData.CDSITUCRT;
            var idapuimpgersn = filteredData.IDAPUIMPGERESN;
            var idtipoapura = filteredData.IDTIPOAPURA;
            if (!Fis00100_ApuracaoDeImposto_Service.bloqueiaMapaRegime(idtipoapura, cdsitucrt, idapuimpgersn)) {
                Fis00100_ApuracaoDeImposto_Service.buscaPrxDataIniECodigoMapa(filteredData).then(function(response) {
                    var dtreferencia = widget.getField("DTREFERENCIA");
                    var dtiniperiodo = widget.getField("DTINIPERIODO");
                    var result = response.dataset.result;
                    var primeiroMapa = result.IDPRIMEIROMAPA;
                    var prxdtinicial = moment(result.DTINIPERIODO, 'DD/MM/YYYY');

                    widget.newRow();
                    changeWidgetsEnabledProperty(false, widget.name);
                    // Data final e de referência (para o Simples Nacional) só
                    // podem ser alterados se for o primeiro mapa.
                    dtreferencia.readOnly = !primeiroMapa;
                    dtiniperiodo.readOnly = !primeiroMapa;

                    // Seta os valores de data e número sequencial do mapa.
                    widget.currentRow.DTREFERENCIA = prxdtinicial.format('DD/MM/YYYY');
                    widget.currentRow.DTINIPERIODO = prxdtinicial.format('DD/MM/YYYY');
                    widget.currentRow.DTFIMPERIODO = prxdtinicial.endOf('month').format('DD/MM/YYYY');
                    widget.currentRow.NRSEQUMAPAPU = result.NRSEQUMAPAPU;
                    widget.currentRow.IDTIPOAPURA = idtipoapura;
                })
                .catch(errorHandler);
            }
            else {
                ScreenService.showMessage(Messages_fiscal.MAPA_REGIME_EMPRESA_ERROR, 'error');
            }
        }
        else {
            ScreenService.showMessage(Messages_fiscal.FILTRO_INVALIDO_ERROR, 'error');
        }
    };

    /*
     * Função para adicionar um ajuste de um mapa de apuração de contribuições.
     */
    this.adicionarAjusteContribuicoes = function(ajustesDetalhamentoWidget) {
        ajustesDetalhamentoWidget.newRow();
        var currentRow = ajustesDetalhamentoWidget.currentRow;
        var contribuicoesDetalhamentoWidget = templateManager.container.getWidget("contribuicoesDetalhamento");
        // Seta valores necessários para a row.
        
        currentRow.IDINDICAJUSTE = ajustesDetalhamentoWidget.idindicajuste;
        currentRow.IDTPAJUSTE = ajustesDetalhamentoWidget.idtpajuste;
        currentRow.IDFORMAPUR = ajustesDetalhamentoWidget.idformapur;
        currentRow.NRSEQUMAPAPU = contribuicoesDetalhamentoWidget.currentRow.NRSEQUMAPAPU;
        
        if(currentRow.IDINDICAJUSTE == 'DB') {
            currentRow.CDAJUSTE = "";
            currentRow.IDAPROPRIACAO = "01";
        }
        
        // Faz com que o campo "Nº do Processo" só aceite números.
        General.justInteger("#NRPROCESSO");
        General.justInteger("#NRRECIBO");
    };

    /*
     * Função para adicionar um item do detalhamento de um mapa de apuração de
     * contribuições.
     */
    this.adicionarItemDetalhamentoContribuicoes = function(calculosDetalhamentoWidget) {
        calculosDetalhamentoWidget.newRow();
        var currentRow = calculosDetalhamentoWidget.currentRow;
        var contribuicoesDetalhamentoWidget = templateManager.container.getWidget("contribuicoesDetalhamento");
        var isDeducao = calculosDetalhamentoWidget.idtipodetapu == "DD"; 
        // Seta valores necessários para a row.
        currentRow.IDTIPODETAPU = calculosDetalhamentoWidget.idtipodetapu;
        currentRow.NRSEQUMAPAPU = contribuicoesDetalhamentoWidget.currentRow.NRSEQUMAPAPU;
        // Verifica se está inserindo uma dedução, setando um valor default para
        // o campo, caso contrário.
        if (!isDeducao) {
            currentRow.IDCUMUPISCOFIL = 'S';
        }
    };

    /*
     * Função para alterar a visibilidade da action de editar nas widgets de
     * Simples Nacional conforme bloqueio do mapa.
     */
    this.alteraVisibilidadeActionsMapaBloqueado = function() {
        var filterCont = [
                {
                    "name": "CDEMPRESA",
                    "operator": "=",
                    "value": templateManager.container.getWidget("apuracao_de_imposto").currentRow.CDEMPRESA
                }
            ];
            
            General.callRestEngine('fis#/crud/contopectbl','FilterData', filterCont).then(
                function(sucess) {
                var mainWidget = templateManager.container.getWidget("apuracao_de_imposto");
                var mapaBloqueado = mainWidget.isNewRow() ? false : mainWidget.currentRow.IDBLOQMAPAPU == 'S';
                
                var dtfimperiodo;
                var dtiniintcontfis;
                var dtfinintcontfis;
                var periodoBloqueado = false;
                if(sucess.dataset.contopectbl.length > 0){
                    
                    dtfimperiodo = new Date(moment(mainWidget.currentRow.DTFIMPERIODO, 'DD/MM/YYYY').format('MM/DD/YYYY'));
                    dtiniintcontfis = new Date(moment(sucess.dataset.contopectbl[0].DTINIINTCONTFIS, 'DD/MM/YYYY').format('MM/DD/YYYY'));
                    dtfinintcontfis = new Date(moment(sucess.dataset.contopectbl[0].DTFININTCONTFIS, 'DD/MM/YYYY').format('MM/DD/YYYY'));
            
                    if((dtfimperiodo.getTime() < dtiniintcontfis.getTime()) || (dtfimperiodo.getTime() > dtfinintcontfis.getTime())){
                        periodoBloqueado = true;  
                    }
                }
                
                // Declara uma função recursiva para alterar a visibilidade de todas as
                // actions de editar, adicionar e excluir da tela.
                var alteraVisibilidadeActions = function(widget) {
                    // Verifica widgets que possuem actions de
                    // apuração/bloqueio/desbloqueio de mapas.
                   
                    var apurarMapaAction = widget.getAction("apurarMapa");
                    var bloquearMapaAction = widget.getAction("bloquearMapa");
                    var desbloquearMapaAction = widget.getAction("desbloquearMapa");
                    if (apurarMapaAction) {
                        if(periodoBloqueado){
                            apurarMapaAction.readOnly = periodoBloqueado;
                        } else {
                            apurarMapaAction.readOnly = mapaBloqueado;
                        }
                    }
                    if (bloquearMapaAction) {
                        if(periodoBloqueado){
                            bloquearMapaAction.readOnly = periodoBloqueado;
                        } else {
                            bloquearMapaAction.readOnly = mapaBloqueado;
                        }
                    }
                    if (desbloquearMapaAction) {
                        if(periodoBloqueado){
                            desbloquearMapaAction.readOnly = periodoBloqueado;
                        } else {
                            desbloquearMapaAction.readOnly = !mapaBloqueado;
                        }
                    }
                    // Nomes utilizados nas actions das widgets da tela.
                    var actionNames = ["adicionar", "editar", "excluir"];
                    actionNames.forEach(function(actionName) {
                        var action = widget.getAction(actionName);
                        if (action) {
                            if(periodoBloqueado){
                                action.readOnly = periodoBloqueado;
                            } else {
                                action.readOnly = mapaBloqueado;
                            }
                        }
                        if (Array.isArray(widget.widgets)) {
                            widget.widgets.forEach(function(childWidget) {
                                alteraVisibilidadeActions(childWidget);
                            });
                        }
                    });
                };
                alteraVisibilidadeActions(mainWidget);
            
            }
        );
    };

    /*
     * Função utilizada em widgets do Simples Nacional para cancelar a edição de
     * um detalhamento.
     */
    this.cancelarForm = function(widget) {
        // Retorna a "currentRow" ao estado anterior.
        for (var i in widget.backupRow) {
            widget.currentRow[i] = widget.backupRow[i];
        }

        widget.template = widget.templateToView;
        widget.view();
        widget.activate();

        widget.getParent().view();

        // As widgets que foram
        changeWidgetsEnabledProperty(true);
        widget.getParent().enabled = true;
    };

    /*
     * Função para cancelar a edição de um mapa de apuração.
     */
    this.cancelarMapa = function(args) {
        General.backOrCancel(args);
        changeWidgetsEnabledProperty(true);
    };

    /*
     * Função para setar dados de cabeçalhos e outros valores em widgets de um
     * mapa de apuração do Simples Nacional.
     */
    this.carregarDataSource = function(widget) {
        var widgetPai = widget.getParent();
        widgetPai.getParent().currentRow.VRIMPOSTOREC = widget.dataSource.data[0].VRIMPOSTOREC;
        setaCabecalhoDetalhamento(widgetPai, widget.dataSource.data[0]);
        widgetPai.widgets.forEach(function(widg) {
            widg.currentRow = widget.dataSource.data[0];
            this.setaMensagemDetalhamento(widg);
        }.bind(this));
    };

    /*
     * Função para alterar a propriedade "enabled" de quaisquer widgets
     * diferentes da atual, modificando a possibilidade de acessá-las.
     */
    var changeWidgetsEnabledProperty = function(status, nomeWidgetAtual) {
        var mainWidget = templateManager.container.getWidget("apuracao_de_imposto");

        // Declara uma função recursiva para alterar a propriedade de todas as
        // widgets da tela.
        var changeEnabledProperty = function(widget) {
            // Verifica se o status passado é true. Se não for, utiliza o status
            // passado em todas as widgets que não forem a atual, deixando
            // somente ela habilitada como exceção.
            widget.enabled = status || (widget.name != nomeWidgetAtual ? status : true);
            if (Array.isArray(widget.widgets)) {
                widget.widgets.forEach(function(childWidget) {
                    changeEnabledProperty(childWidget);
                });
            }
        };
        changeEnabledProperty(mainWidget);
    };

    /*
     * Função para verificar se certos campos da widget de Arrecadação Fiscal
     * de um mapa de Contribuições deve ficar required.
     */
    this.checkArrecadacaoContribuicoesFieldsRequired = function(mainWidget) {
        if (contribuicoesIsSelected()) {
            var arrecadacaoWidget = templateManager.container.getWidget("contribuicoesArrecadacao");
            var currentRow = mainWidget.currentRow;
            // Verifica se há contribuições a recolher.
            var hasDebito = currentRow.VRTOTAIMPOS > 0;
            // Verifica se há algum valor de débito cumulativo.
            var hasDebitoCumulativo = currentRow.VRDEBITOSCUM > 0;
            // Verifica se há algum valor de débito não cumulativo.
            var hasDebitoNaoCumulativo = currentRow.VRDEBITOSNC > 0;
            arrecadacaoWidget.getField("DTVENCGUIA").validations = hasDebito ? {required: true} : null;
            arrecadacaoWidget.getField("DESCRECECUMU").validations = hasDebito && hasDebitoCumulativo ? {required: true} : null;
            arrecadacaoWidget.getField("DESCRECENCUMU").validations = hasDebito && hasDebitoNaoCumulativo ? {required: true} : null;
        }
    };

    /*
     * Função chamada ao alterar a nota fiscal de um detalhamento de um mapa de
     * contribuições. Se não houver valor no detalhamento, utiliza o valor da
     * nota escolhida.
     */
    this.checkChangeDetalhamentoValue = function(calculosDetalhamentoWidget) {
        var currentRow = calculosDetalhamentoWidget.currentRow;
        if (!currentRow.VRITEMDETAPU) {
            currentRow.VRITEMDETAPU = currentRow.VRNOTAFISC;
        }
    };

    /*
     * Função para alterar a visibilidade de actions conforme bloqueio ou
     * apuração do mapa de apuração.
     */
    this.checkElementsVisibility = function(widget) {
        this.alteraVisibilidadeActionsMapaBloqueado();
        changeEnabledPropertyGridWidgets(widget);
        habilitaAjusteContribuicao(widget);
    };

    /*
     * Função para fechar as widgets de itens do detalhamento de um mapa de
     * Contribuições, retornando ao próprio detalhamento.
     */
    this.closeDetalhamentoContribuicoesWidgets = function(widget) {
        ScreenService.closeSwipe().then(function() {
        var detalhamentoWidget = templateManager.container.getWidget("contribuicoesDetalhamento");
            detalhamentoWidget.activate();
            detalhamentoWidget.view();
        });
    };

    /*
     * Função para fechar as widgets de itens do detalhamento de um mapa de
     * Contribuições, retornando ao próprio detalhamento.
     */
    /*this.closeDetalhamentoIrpjCsllWidgets = function(widget) {
        var detalhamentoWidget = templateManager.container.getWidget(widget.widgetParent);
        ScreenService.closeSwipe().then(function() {
            detalhamentoWidget.activate();
            detalhamentoWidget.view();
        });
    };*/
    
    /*
     * Função para alterar a habilitação de certas widgets do Simples Nacional
     * conforme apuração do mapa.
     */
    var changeEnabledPropertyGridWidgets = function(widget) {
        var widgetSimplesReferencia = templateManager.container.getWidget('simplesNacionalTabelaReferencia');
        var widgetSimplesNF = templateManager.container.getWidget('notasFiscais');
        var idbloqmapapu = widget.currentRow.IDBLOQMAPAPU;
        // Verifica se o mapa está apurado ou bloqueado.
        var enabled = idbloqmapapu == "A" || idbloqmapapu == "S";
        widgetSimplesReferencia.enabled = enabled;
        widgetSimplesNF.enabled = enabled;
    };

    /*
     * Função para colocar uma widget de view para o modo form, executando as
     * validações necessárias que possuem uma widget pai.
     */
    this.editarFormWidgetPai = function(widget) {
        var cdsitucrt = filteredData.CDSITUCRT;
        var idapuimpgersn = filteredData.IDAPUIMPGERESN;
        var idtipoapura = filteredData.IDTIPOAPURA;
        // Verifica se o regime atual parametrizado permite alterações.
        if (!Fis00100_ApuracaoDeImposto_Service.bloqueiaMapaRegime(idtipoapura, cdsitucrt, idapuimpgersn)) {
            widget.template = widget.templateToForm;

            widget.getParent().edit();
            General.edit(widget);

            changeWidgetsEnabledProperty(false, widget.name);
            widget.getParent().enabled = true;

        }
        else {
            ScreenService.showMessage(Messages_fiscal.MAPA_REGIME_EMPRESA_ERROR, 'error');
        }
    };

    /*
     * Função para editar a widget com as informações principais de um mapa de
     * apuração.
     */
    this.editMapa = function(args) {
        var widget = args.owner.widget;
        var currentRow = widget.currentRow;
        var cdsitucrt = filteredData.CDSITUCRT;
        var idapuimpgersn = filteredData.IDAPUIMPGERESN;
        var idtipoapura = filteredData.IDTIPOAPURA;
        // Verifica se o regime atual parametrizado permite alterações.
        if (!Fis00100_ApuracaoDeImposto_Service.bloqueiaMapaRegime(idtipoapura, cdsitucrt, idapuimpgersn)) {
            Fis00100_ApuracaoDeImposto_Service.checkUltimoMapa(currentRow)
            .then(function(response) {
                // Só é permitido alterar a data final se for o último mapa.
                widget.getField("DTFIMPERIODO").readOnlyOnEdit = !response.dataset.validation.isUltimoMapa;
                General.edit(widget);
                changeWidgetsEnabledProperty(false, widget.name);
            });
        }
        else {
            ScreenService.showMessage(Messages_fiscal.MAPA_REGIME_EMPRESA_ERROR, 'error');
        }
    };

    /*
     * Função para abrir o grid com informações sobre os detalhamentos de um
     * mapa com imposto de contribuições.
     */
    this.openAjustesWidget = function(fieldClicked) {
        // Busca o tipo de detalhamento associado ao field.
        var idindicajuste = fieldClicked.idindicajuste;
        var idtpajuste = fieldClicked.idtpajuste;
        var idformapur = fieldClicked.idformapur;
        var widgetParent = fieldClicked.widgetParent;
        var currentRow = fieldClicked.widget.currentRow;
        var ajustesTabbedWidget = templateManager.container.getWidget("ajustesDetalhamentoTabbed");
        var ajustesWidget = templateManager.container.getWidget("ajustesDetalhamento");

        // Variável de controle conforme detalhamento escolhido.
        var isCredito = idindicajuste == "C";
        var isReducao = idtpajuste == "0";

        // Atribui o label da widget conforme detalhamento escolhido.
        ajustesWidget.label = "Ajuste " + (isReducao ? "Redução" : "Acréscimo");
        ajustesWidget.label += isCredito ? " - Crédito/Entradas" : " - Débito/Saídas";

        // Verifica se o detalhamento pode ser alterado. Ele não pode ser
        // alterado se o mapa estiver bloqueado.
        var isEditable = currentRow.IDBLOQMAPAPU != 'S';
        ajustesWidget.dataSourceFilter = [
            {
                "name": "NRSEQUMAPAPU",
                "operator": "=",
                "value": currentRow.NRSEQUMAPAPU
            },
            {
                "name": "IDINDICAJUSTE",
                "operator": "=",
                "value": idindicajuste
            },
            {
                "name": "IDTPAJUSTE",
                "operator": "=",
                "value": idtpajuste
            },
            {
                "name": "IDFORMAPUR",
                "operator": "=",
                "value": idformapur
            }
        ];
        ScreenService.openSwipe(ajustesTabbedWidget);
        // Limpa os dados anteriormente presentes na widget.
        ajustesWidget.dataSource.data = [];
        ajustesWidget.reload();
        ajustesWidget.getAction("editar").isVisible = isEditable;
        ajustesWidget.getAction("adicionar").isVisible = isEditable;
        ajustesWidget.getAction("excluir").isVisible = isEditable;

        // Controla fields exibidos na tela.
        if (isCredito) {
            setCampoInvisible(ajustesWidget.getField("CDSITUTRIBITNFE"));
            setCampoObrigatorio(ajustesWidget.getField("CDTPCREDPICOITE"));
            
            setCampoInvisible(ajustesWidget.getField("VRBASECALCAJ"));
            setCampoObrigatorio(ajustesWidget.getField("VRAJUSTE"));
            
            setCampoInvisible(ajustesWidget.getField("CDAJUSTEBC"));
            setCampoObrigatorio(ajustesWidget.getField("CDAJUSTE"));

            setCampoInvisible(ajustesWidget.getField('CDCONTCTBL'));
            setCampoInvisible(ajustesWidget.getField('CDFILIAL'));
                
            setCampoInvisible(ajustesWidget.getField('NRRECIBO'));
            setCampoInvisible(ajustesWidget.getField('IDAPROPRIACAO'));
                
        }
        else{ 
            setCampoObrigatorio(ajustesWidget.getField("CDSITUTRIBITNFE"));
            setCampoInvisible(ajustesWidget.getField("CDTPCREDPICOITE"));

            if(idindicajuste == 'DI'){
                setCampoInvisible(ajustesWidget.getField("CDAJUSTEBC"));
                setCampoObrigatorio(ajustesWidget.getField("CDAJUSTE"));

                setCampoInvisible(ajustesWidget.getField("VRBASECALCAJ"));
                setCampoObrigatorio(ajustesWidget.getField("VRAJUSTE"));
                
                setCampoInvisible(ajustesWidget.getField('CDCONTCTBL'));
                setCampoInvisible(ajustesWidget.getField('CDFILIAL'));
                
                setCampoInvisible(ajustesWidget.getField('NRRECIBO'));
                setCampoInvisible(ajustesWidget.getField('IDAPROPRIACAO'));
                
            } else if(idindicajuste == 'DB'){
                setCampoObrigatorio(ajustesWidget.getField("CDAJUSTEBC"));
                setCampoInvisible(ajustesWidget.getField("CDAJUSTE"));
                
                setCampoObrigatorio(ajustesWidget.getField("VRBASECALCAJ"));
                setCampoObrigatorio(ajustesWidget.getField("VRAJUSTE"));
                
                setCampoVisible(ajustesWidget.getField('CDCONTCTBL'));
                
                ajustesWidget.getField('CDFILIAL').dataSourceFilter = [{
                    "name": "CDEMPRESA",
                    "operator": "=",
                    "value": currentRow.CDEMPRESA
                }];
                ajustesWidget.getField('CDFILIAL').reload();
                setCampoVisible(ajustesWidget.getField('CDFILIAL'));
                
                setCampoVisible(ajustesWidget.getField('NRRECIBO'));
                setCampoObrigatorio(ajustesWidget.getField('IDAPROPRIACAO'));

            }
        }
        // Armazena o tipo de detalhamento escolhido.
        ajustesWidget.idindicajuste = idindicajuste;
        ajustesWidget.idtpajuste = idtpajuste;
        ajustesWidget.idformapur = idformapur;
        ajustesWidget.widgetParent = widgetParent;
    };

    /*
     * Função para abrir o grid com informações sobre os detalhamentos de um
     * mapa com imposto de contribuições.
     */
    this.openCalculosWidget = function(fieldClicked) {
        // Busca o tipo de detalhamento associado ao field.
        var idtipodetapu = fieldClicked.idtipodetapu;
        var currentRow = fieldClicked.widget.currentRow;
        var calculosTabbedWidget = templateManager.container.getWidget("calculosDetalhamentoTabbed");
        var calculosWidget = templateManager.container.getWidget("calculosDetalhamento");

        // Variáveis de controle conforme detalhamento escolhido.
        var isCompensacao = idtipodetapu == "CO";
        var isCreditoAnterior = idtipodetapu == "CA";
        var isDeducao = idtipodetapu == "DD";

        // Atribui o label da widget conforme detalhamento escolhido.
        calculosWidget.label = isCreditoAnterior ? "Crédito Anterior" : isCompensacao ? "NF's Compensações - SPED Contribuições" : "Dedução";

        // Verifica se o detalhamento pode ser alterado. Ele não pode ser
        // alterado se o mapa estiver bloqueado, se o detalhamento não for de
        // compensação ou se o detalhamento for de crédito anterior e não for o
        // primeiro mapa de apuração da empresa/imposto.
        var isEditable = currentRow.IDBLOQMAPAPU != 'S' && !isCompensacao && (!isCreditoAnterior || currentRow.IDPRIMEIROMAPA == 'S');
        if(isDeducao)
            calculosWidget.dataSource.name = 'fis_apuracoes#/itdetapucontr_detalhamento_contribuicoes';
        else
            calculosWidget.dataSource.name = 'fis_apuracoes#/itdetapucontr_detalhamentoCompensacoes';
            
        calculosWidget.dataSourceFilter = [
            {
                "name": "NRSEQUMAPAPU",
                "operator": "=",
                "value": currentRow.NRSEQUMAPAPU
            },
            {
                "name": "IDTIPODETAPU",
                "operator": "=",
                "value": idtipodetapu
            }
        ];
        ScreenService.openSwipe(calculosTabbedWidget);
        // Limpa os dados anteriormente presentes na widget.
        calculosWidget.dataSource.data = [];
        calculosWidget.reload();
        calculosWidget.getAction("editar").isVisible = isEditable;
        calculosWidget.getAction("adicionar").isVisible = isEditable;
        calculosWidget.getAction("excluir").isVisible = isEditable;

        // Controla fields exibidos na tela.
        if (isDeducao) {
            
            setCampoObrigatorio(calculosWidget.getField("VRBASEITEMDETAPU"));
            setCampoObrigatorio(calculosWidget.getField("IDORIGDEDUC"));
            setCampoObrigatorio(calculosWidget.getField("IDCUMUPISCOFIL"));
            calculosWidget.getField("NRNOTAFISC").isVisibleOnReport = true;
            calculosWidget.getField("NRNOTAFISC").isVisible         = true;
            calculosWidget.getField("NRNOTAFISC").readOnly          = false;
            
            
            calculosWidget.getField("NRSEQITDETAPU").showOnList           = true;
            calculosWidget.getField("NRSEQITDETAPU").isVisibleOnReport    = true;
            
            calculosWidget.getField("DSITEMDETAPU").showOnList            = true;
            calculosWidget.getField("DSITEMDETAPU").isVisibleOnReport     = true;
            
            calculosWidget.getField("VRITEMDETAPU").isVisible             = true;
            calculosWidget.getField("VRITEMDETAPU").isVisibleOnReport     = true;
            
            calculosWidget.getField("VRBASEITEMDETAPU").isVisibleOnReport = true;
            
            calculosWidget.getField("IDORIGDEDUC").isVisibleOnReport      = true;
            calculosWidget.getField("IDCUMUPISCOFIL").isVisibleOnReport   = true;
            
            
            
            calculosWidget.getField("NRNOTA").isVisible              = false;
            calculosWidget.getField("NRNOTA").isVisibleOnReport      = false;
            
            calculosWidget.getField("DTEMISSAO").isVisible           = false;
            calculosWidget.getField("DTEMISSAO").isVisibleOnReport   = false;
            
            calculosWidget.getField("DTPAGAMENTO").isVisible         = false;
            calculosWidget.getField("DTPAGAMENTO").isVisibleOnReport = false;
            
            calculosWidget.getField("VR_COMP").isVisible             = false;
            calculosWidget.getField("VR_COMP").isVisibleOnReport     = false;
            
            
            calculosWidget.getField("NM_FONTE").isVisible            = false;
            calculosWidget.getField("NM_FONTE").isVisibleOnReport    = false;
            
            calculosWidget.getField("CNPJ").isVisible          = false;
            calculosWidget.getField("CNPJ").isVisibleOnReport  = false;
            
            calculosWidget.getField("VRNOTAFISC").isVisible          = false;
            calculosWidget.getField("VRNOTAFISC").isVisibleOnReport  = false;
            
        }
        else {
            
            setCampoInvisible(calculosWidget.getField("VRBASEITEMDETAPU"));
            setCampoInvisible(calculosWidget.getField("IDORIGDEDUC"));
            setCampoInvisible(calculosWidget.getField("IDCUMUPISCOFIL"));
            if (isCreditoAnterior) {
                setCampoInvisible(calculosWidget.getField("NRNOTAFISC"));
            }
            calculosWidget.getField("NRSEQITDETAPU").showOnList           = false;
            calculosWidget.getField("NRSEQITDETAPU").isVisibleOnReport    = false;
            
            calculosWidget.getField("DSITEMDETAPU").showOnList            = false;
            calculosWidget.getField("DSITEMDETAPU").isVisibleOnReport     = false;
            
            calculosWidget.getField("VRITEMDETAPU").isVisible             = false;
            calculosWidget.getField("VRITEMDETAPU").isVisibleOnReport     = false;
            
            calculosWidget.getField("VRBASEITEMDETAPU").isVisibleOnReport = false;
            calculosWidget.getField("IDORIGDEDUC").isVisibleOnReport      = false;
            calculosWidget.getField("IDCUMUPISCOFIL").isVisibleOnReport   = false;
            
            
            
            calculosWidget.getField("DTEMISSAO").isVisible                = true;
            calculosWidget.getField("DTEMISSAO").isVisibleOnReport        = true;
            
            calculosWidget.getField("DTPAGAMENTO").isVisible              = true;
            calculosWidget.getField("DTPAGAMENTO").isVisibleOnReport      = true;
            
            calculosWidget.getField("VR_COMP").isVisible                  = true;
            calculosWidget.getField("VR_COMP").isVisibleOnReport          = true;
    
            calculosWidget.getField("NM_FONTE").isVisible                 = true;
            calculosWidget.getField("NM_FONTE").isVisibleOnReport         = true;
            
            calculosWidget.getField("CNPJ").isVisible               = true;
            calculosWidget.getField("CNPJ").isVisibleOnReport       = true;
            
            calculosWidget.getField("VRNOTAFISC").isVisible               = true;
            calculosWidget.getField("VRNOTAFISC").isVisibleOnReport       = true;
                
            calculosWidget.getField("NRNOTAFISC").isVisible               = false;
            calculosWidget.getField("NRNOTAFISC").isVisibleOnReport       = false;
            
            calculosWidget.getField("NRNOTA").isVisible                   = true;
            calculosWidget.getField("NRNOTA").isVisibleOnReport           = true;
        }

        // Armazena o tipo de detalhamento escolhido.
        calculosWidget.idtipodetapu = idtipodetapu;
        calculosWidget.redraw();
    };

    /*
     * Função para abrir uma widget contendo detalhamentos sobre créditos ou
     * débitos em um mapa de Contribuições.
     */
    this.openDetalhamentoTotalizadorWidget = function(field) {
        var childWidgetTabbed = templateManager.container.getWidget(field.childWidgetName);
        ScreenService.openSwipe(childWidgetTabbed);

        // Seta a currentRow do mapa na widget form a ser aberta.
        childWidgetTabbed.widgets[0].currentRow = field.widget.currentRow;
        childWidgetTabbed.widgets[0].view();
    };

    /*
     * Função para setar os dados do detalhamento do Simples Nacional no
     * cabeçalho, para exibição.
     */
    var setaCabecalhoDetalhamento = function(widget, data) {
        var widgetApuracao = widget.getParent().getParent();
        var mesApuracao = moment(widgetApuracao.currentRow.DTINIPERIODO, 'DD/MM/YYYY');
        widget.currentRow.VRFATURA12MESES = data.VRFATURA12MESES;
        widget.currentRow.VRFATUMENSTOTAL = (data.VRBCFATUST + data.VRCOMPBCST + data.VRDEDUZBCST) + (data.VRBCFATUSEMST + data.VRCOMPBCSEMST + data.VRDEDUZBCSEMST) + (data.VRBCFATUISEN + data.VRCOMPBCISENTO + data.VRDEDUZBCISENTO) + (data.VRBCFATUEXP + data.VRCOMPBCEXP + data.VRDEDUZBCEXP);
        widget.currentRow.MESAPURAC = mesApuracao.format('MMM/YYYY');
        widget.currentRow.VRALIQSIMPLES = data.VRALIQSIMPLES;

        var params = {
            type: "currency",
            params: {
                showSymbol: false,
                precision: 2,
                thousands: ".",
                decimal: ", "
            }
        };
        // Aplica a máscara manualmente nos valores.
        var valorInicial = Util.applyMask(data.VRINIFAIXA, params, maskEngine);
        var valorFinal = Util.applyMask(data.VRFINFAIXA, params, maskEngine);
        widget.currentRow.DSFAIXA = valorInicial + ' - '+valorFinal;
    };

    /*
     * Função para setar as mensagens que serão exibidas nas widgets do Simples
     * Nacional.
     */
    this.setaMensagemDetalhamento = function(widget) {
        switch(widget.name) {
            case 'widgetFatuMensalTributadoSt':
                widget.currentRow.INFORMACOES = 'É considerado como "Faturamento Mensal Tributado pelo ST" apenas os produtos das Notas Fiscais de Saída que pussuem CSOSN = 500.\n\nNesse faturamento, é aplicada a Alíquota Total correspondente a Faixa de Valores sendo subtraído desta, a alíquota referente ao imposto ICMS.\n\nA Base de Cálculo é calculada automaticamente pelo sistema. Para os casos em que haja necessidade de aumentar ou deduzir valor nesta base, os campos "Compõe B. C. e Deduz B. C." estão disponíveis para digitação.\n\nO campo "Valor do Imposto" é utilizado para calcular o valor do Imposto a Recolher, onde é feita a soma do "Valor do Imposto" de todos os faturamentos + Majoração, com exceção do Valor do Imposto do Faturamento Mensal Retido que é reduzido do Imposto a Recolher.';
                break;

            case 'widgetFatuMensalNaoTributadoSt':
                widget.currentRow.INFORMACOES2 = 'É considerado como "Faturamento Mensal não Tributado pelo ST" apenas os produtos das Notas Fiscais de Saída que NÃO possuem CSOSN = 103, 300, 400 e 500.\n\nNesse faturamento, é aplicada a Alíquota Total correspondente a Faixa de Valores.\n\nA Base de Cálculo é calculada automaticamente pelo sistema. Para os casos em que haja necessidade de aumentar ou deduzir valor nesta base, os campos "Compõe B. C. e Deduz B. C." estão disponíveis para digitação.\n\nO campo "Valor do Imposto" é utilizado para calcular o valor do Imposto a Recolher, onde é feita a soma do "Valor do Imposto" de todos os faturamentos + Majoração, com exceção do Valor do Imposto do Faturamento Mensal Retido que é reduzido do Imposto a Recolher.';
                break;

            case 'widgetFatuMensalIsentoIcms':
                widget.currentRow.INFORMACOES_ICMS = 'É considerado como "Faturamento Mensal Isento (ICMS)" apenas os produtos das Notas Fiscais de Saída que possuem CSOSN = 103 e 300.\n\nNesse faturamento, é aplicada a Alíquota Total correspondente a Faixa de Valores sendo subtraído desta, a alíquota referente ao imposto ICMS.\n\nA Base de Cálculo é calculada automaticamente pelo sistema. Para os casos em que haja necessidade de aumentar ou deduzir valor nesta base, os campos "Compõe B. C. e Deduz B. C." estão disponíveis para digitação.\n\nO campo "Valor do Imposto" é utilizado para calcular o valor do Imposto a Recolher, onde é feita a soma do "Valor do Imposto" de todos os faturamentos + Majoração, com exceção do Valor do Imposto do Faturamento Mensal Retido que é reduzido do Imposto a Recolher.';
                break;

            case 'widgetFatuExportacao':
                widget.currentRow.INFORMACOES_FATURAMENTO = 'É considerado como "Fatu. Exportação" apenas os produtos das Notas Fiscais de Saída que possuem CFOP iniciados por "7".\n\nNesse faturamento, é aplicada a Alíquota Total correspondente a Faixa de Valores sendo subtraído desta, a alíquota referente ao imposto IPI, ICMS, PIS, COFINS E ISS.\n\nA Base de Cálculo é calculada automaticamente pelo sistema. Para os casos em que haja necessidade de aumentar ou deduzir valor nesta base, os campos "Compõe B. C. e Deduz B. C." estão disponíveis para digitação.\n\nO campo "Valor do Imposto" é utilizado para calcular o valor do Imposto a Recolher, onde é feita a soma do "Valor do Imposto" de todos os faturamentos + Majoração, com exceção do Valor do Imposto do Faturamento Mensal Retido que é reduzido do Imposto a Recolher.';
                break;

            case 'widgetFatuMensalRetido':
                widget.currentRow.INFORMACOES_RETIDO = 'É considerado como "Faturamento Mensal Retido" apenas os produtos das Notas Fiscais de Saída que possuem impostos parametrizados para Reter na Fonte.\n\nNesse faturamento, é aplicada a Alíquota correspondente aos impostos retidos pertinentes a faixa de valores.\n\nPara os casos em que haja necessidade de acrescer o valor do imposto calculado automaticamente pelo sistema, o campo "Valor Não Provisionado" está disponível para digitação.\n\nO campo "Valor do Imposto" é utilizado para calcular o valor do Imposto a Recolher, onde é feita a soma do "Valor do Imposto" de todos os faturamentos + Majoração, com exceção do Valor do Imposto do Faturamento Mensal Retido que é reduzido do Imposto a Recolher.';
                break;

            case 'widgetMajoracao':
                widget.currentRow.INFORMACOES_MAJORACAO = 'A Majoração é realizada quando a Receita Bruta Anual (RBA) da empresa ultrapassa o valor final da última faixa de valores da tabela do simples nacional. O cálculo é feito da seguinte forma:\n\nAlíquota Majorada = Alíquota Maxima + 20%\nParcela Excedente = Receita Bruta Anual (RBA) - Valor Final Faixa\nAlíquota Majorada * Parcela Excedente = Valor do Imposto \n\nO campo "Valor do Imposto" é utilizado para calcular o valor do Imposto a Recolher, onde é feita a soma do "Valor do Imposto" de todos os faturamentos + Majoração, com exceção do Valor do Imposto do Faturamento Mensal Retido que é reduzido do Imposto a Recolher.';
                break;
        }
    };

    this.editarWidgetForm = function (widget,validaCampos,nomesCampos){
        var cdsitucrt     = filteredData.CDSITUCRT;
        var idapuimpgersn = filteredData.IDAPUIMPGERESN;
        var idtipoapura   = filteredData.IDTIPOAPURA;
        // Verifica se o regime atual parametrizado permite alterações.
        if (!Fis00100_ApuracaoDeImposto_Service.bloqueiaMapaRegime(idtipoapura, cdsitucrt, idapuimpgersn)) {
            General.widgetEdit(widget);
            if(validaCampos){
                this.bloqueiaCampos(widget,nomesCampos,true);
            }
        }
        else {
            ScreenService.showMessage(Messages_fiscal.MAPA_REGIME_EMPRESA_ERROR, 'error');
        }
        
    };

    /*
     *  Função que controla se é permitido ou não a edição da widget de detalhamento.
     *  Só é permitido editar o primeiro mapa e caso ele não esteja bloqueado
     */
    this.verificaEdicaoDetalhamento = function(widget){
        var verifica = false;
        var widgetDetalhamento; 
        if(impostosGeraisIsSelected(widget.currentRow)){
            widgetDetalhamento   = templateManager.container.getWidget('detalhamentoGeral');
            verifica             = true;
            
        }else if(contribuicoesIsSelected(widget.currentRow.CDIMPOSTO)){
            widgetDetalhamento   = templateManager.container.getWidget('contribuicoesDetalhamento');    
            verifica             = true;
        }
        //So Apuração de Impostos Gerais e Contribuições Possuem Detalhamento
        if(verifica){
            var editar = widgetDetalhamento.getAction('editar');
            if(widget.currentRow.IDBLOQMAPAPU ==='S'){
                editar.readOnly = true;
            }else{
                if(widget.currentRow.IDPRIMEIROMAPA ==='S')
                    editar.readOnly = false;
                else
                    editar.readOnly = true;
            }
        }
    };

    /*
     *  Função que controla a visibilidade da aba de Guias Complementares
     *  que está contida na aba de Arrecadação Fiscal existente apenas para 
     *  Apuração de Impostos Gerais
     */
    var  controlaGuiaComplementar = function (cdimposto,idtipoapura){
        var exibe = (cdimposto === impostoIcms  || cdimposto === impostoIpi || cdimposto === impostoIcmsSt || cdimposto === impostosFecp || 
        cdimposto === impostosCargaRj || cdimposto === impostosIrrfE || cdimposto === impostosIrrfS || cdimposto === impostosPcc || 
        cdimposto === impostosIssqnE || cdimposto === impostoPisRetS || cdimposto === impostosCofinsRetS);
        var widgetGuia = templateManager.container.getWidget('widgetGuiasComplementares');
        var widgetGuiaContrib = templateManager.container.getWidget('widgetGuiasComplementaresContrib');
        if(exibe){
            if(cdimposto === impostoPisRetS || cdimposto === impostosCofinsRetS){
                widgetGuia.isVisible = false;
                widgetGuiaContrib.isVisible = true;
            } else {
                widgetGuia.isVisible = true;
                widgetGuiaContrib.isVisible = false;
            }
        }
        else {
            widgetGuia.isVisible = false;    
            widgetGuiaContrib.isVisible = false;
        }
    };
    
    /*
     *  Função que irá controlar o field código de receita.
     *  Ela buscará informações estaduais caso o imposto seja estadual ou 
     *  federal caso o imposto seja federal.
     */
    this.controlaTipoReceita = function (widget,nomeWidget,nomeCampoGuia){
        //var campoReceita = widget.getField('CDRECEITAGUIA');
        //var widgetPopupReceita = templateManager.container.getActiveWidget();
        var widgetPopupReceita = templateManager.container.getWidget(nomeWidget).getField(nomeCampoGuia).selectWidget;
        var idtipoapura   = filteredData.IDTIPOAPURA;
        
        if (idtipoapura ==='E'){
            widgetPopupReceita.fields[0].showOnList = true;
            widgetPopupReceita.fields[1].showOnList = true;
            
            widgetPopupReceita.fields[2].showOnList = false;
            widgetPopupReceita.fields[3].showOnList = false;
            widgetPopupReceita.fields[4].showOnList = false;
            widgetPopupReceita.fields[5].showOnList = false;
            widgetPopupReceita.fields[6].showOnList = false;
            
            widgetPopupReceita.order  = 'CDRECEITAEST';
            
            
        }else if (idtipoapura ==='F'){
            widgetPopupReceita.fields[0].showOnList = false;
            widgetPopupReceita.fields[1].showOnList = false;
            
            widgetPopupReceita.fields[2].showOnList = true;
            widgetPopupReceita.fields[3].showOnList = true;
            widgetPopupReceita.fields[4].showOnList = true;
            widgetPopupReceita.fields[5].showOnList = true;
            widgetPopupReceita.fields[6].showOnList = true;
        
            widgetPopupReceita.order  = 'CDRECEITACONTR';
            
        }
       // widgetPopupReceita.redraw();
    };

    this.dataSourceTipoReceita = function(widget){
        var campoReceita = widget.getField('CDRECEGUIA');
        var idtipoapura   = filteredData.IDTIPOAPURA;
        if((idtipoapura ==='E') || (idtipoapura ==='F')) {
            campoReceita.fields = [
                {
                    "label": "Código",
                    "name": "CDRECEITAEST",
                    "class": "4",
                    "showOnList": true,
                    "template": "field/text-edit.html"
                },
                {
                    "label": "Nome",
                    "name": "NMRECEITAEST",
                    "class": "8",
                    "showOnList": true,
                    "template": "field/text-edit.html"
                },
                {
                    "label": "Código",
                    "name": "CDRECEITACONTR",
                    "class": "4",
                    "showOnList": true,
                    "template": "field/text-edit.html"
                },
                {
                    "label": "Nome",
                    "name": "NMRECEITACONTR",
                    "class": "8",
                    "showOnList": true,
                    "template": "field/text-edit.html"
                },
                {
                    "label": "Variação",
                    "name": "CDVARIACAO",
                    "class": "6",
                    "showOnList": true,
                    "template": "field/text-edit.html"
                },
                {
                    "label": "Periodicidade",
                    "name": "IDPERIODICREC",
                    "class": "6",
                    "showOnList": true,
                    "template": "field/text-edit.html",
                    "options": {
                        "D": "Diária",
                        "S": "Semanal",
                        "X": "Decendial",
                        "Q": "Quinzenal",
                        "M": "Mensal",
                        "B": "Bimestral",
                        "T": "Trimestral",
                        "U": "Quadrimestral",
                        "E": "Semestral",
                        "A": "Anual"
                    }
                },
                {
                    "label": "Débito de SCP/INC",
                    "name": "IDDEBSCPINC",
                    "class": "6",
                    "showOnList": true,
                    "template": "field/text-edit.html",
                    "options": {
                        "0": "Não é SCP nem INC",
                        "1": "SCP",
                        "2": "INC"
                    }
                }
            ];    
            campoReceita.events = [
                {
                    "name": "FieldAfterSelectOpen",
                    "code": "Fis00100_ApuracaoDeImposto_Controller.controlaTipoReceita(args.owner.field.widget,'guiaFiscalArrecadaoGeral','CDRECEGUIA')"
                },
                {
                    "name": "FieldOnClick",
                    "code": "args.owner.field.initializeField()"
                }
            ];
            delete campoReceita.maxlength; 
            if (idtipoapura ==='E'){
                campoReceita.template = "zh-select-autocomplete#field/select-autocomplete.html";
                campoReceita.displayedFields=[
                    "CDRECEITAEST",
                    "NMRECEITAEST"
                ];
                campoReceita.searchableFields=[
                    "CDRECEITAEST",
                    "NMRECEITAEST"
                ];
                campoReceita.valueField       = 'CDRECEITAEST';
                campoReceita.descriptionField = 'NMRECEITAEST';
                campoReceita.showSelectAs = "grid";
                campoReceita.outData         = {
                    "CDRECEITAEST": "CDRECEGUIA",
                    "NMRECEITAEST": "NMRECEITAEST"
                };
                campoReceita.dataSourceFilter = [
                    {
                        "name":"CDPAIS",
                        "operator":"=",
                        "value":filteredData.CDPAIS
                    },
                    {
                        "name":"SGESTADO",
                        "operator":"=",
                        "value":filteredData.SGESTADO
                    }
                ];
            } else if (idtipoapura ==='F'){
                campoReceita.template = "zh-select-autocomplete#field/select-autocomplete.html";
                campoReceita.displayedFields=[
                    "CDRECEITACONTR",
                    "NMRECEITACONTR"
                ];
                campoReceita.searchableFields=[
                    "CDRECEITACONTR",
                    "NMRECEITACONTR"
                ];
                campoReceita.valueField       = 'CDRECEITACONTR';
                campoReceita.descriptionField = 'NMRECEITACONTR';
                campoReceita.showSelectAs = "grid";
                campoReceita.dataSource = {
                    "name": "fis#/crud/codreceitacontr",
                    "lazyLoad": true,
                    "rest": true
                };
                campoReceita.outData          = {
                    "CDRECEITACONTR":"CDRECEGUIA",
                    "NMRECEITACONTR":"NMRECEITACONTR",
                    "CDVARIACAO":"CDVARIACAO",
                    "IDPERIODICREC":"IDPERIODICREC",
                    "IDDEBSCPINC":"IDDEBSCPINC"
                };
                campoReceita.dataSourceFilter = [
                    {
                        "name":"CDIMPOSTO",
                        "operator":"=",
                        "value":filteredData.CDIMPOSTO
                    }
                ];
            }
        } else if (idtipoapura ==='M'){
            campoReceita.template = "field/text-edit.html";
            delete campoReceita.displayedFields;
            delete campoReceita.searchableFields;
            delete campoReceita.valueField;
            delete campoReceita.descriptionField;
            delete campoReceita.showSelectAs;
            campoReceita.dataSource = {};
            delete campoReceita.outData;
            campoReceita.fields = [];
            campoReceita.events = [];
            campoReceita.maxlength = 20;
        }
        
        // campoReceita.reload();
    };

    /*
        Função que ira abrir um swipe, para exibir informações complementares.
        Funcina somente na aba de detalhamento e quando for apuração de Impostos Gerais.
        Recebe como parâmetro o field(botão que o usuário clica-rá), e nele possui propriedades que 
        identificam o label e o filtro da widget que será aberta
    */
    this.openDetalhamentoGeral = function (field,nomeTabbedDetalhamento){
        var tabbedDetalhamento      = templateManager.container.getWidget(nomeTabbedDetalhamento);
        var widgetItensDetalhamento = tabbedDetalhamento.widgets[0];
        
        widgetItensDetalhamento.label                     = field.childWidgetLabel;
        widgetItensDetalhamento.dataSourceFilter[1].value = field.childWidgetFiltro;
        
        if(nomeTabbedDetalhamento==='tabbedItensDetalhamento')
            this.controlaCamposDetalhamentoGeralItens(widgetItensDetalhamento);
        
        if(widgetItensDetalhamento.name==='widgetItensDetalhamentoIcmsSt'){
            var substituto  = widgetItensDetalhamento.getField('IDSUBSTSOLIDST');
            if(field.childWidgetFiltro ==='D')
                substituto.isVisible = true;
            else
                substituto.isVisible = false;    
            
        }
        
        if((filteredData.SGESTADO == 'SP') && (widgetItensDetalhamento.name !== 'widgetItensDetalhamentoIcmsSt')){
            
            widgetItensDetalhamento.getField('DSITEMOCOR').class = "6";
            widgetItensDetalhamento.getField('DSITEMOCOR').readOnly = false;
            widgetItensDetalhamento.getField('DSFLEGALOCOR').class = "6";
            widgetItensDetalhamento.getField('DSFLEGALOCOR').readOnly = false;
            widgetItensDetalhamento.getField('CDITEMOCOR').class = "6";
            widgetItensDetalhamento.getField('CDITEMOCOR').template = "field/text-edit.html";
            widgetItensDetalhamento.getField('CDITEMOCOR').events = [
                {
                    "id": "63224560732920089361231",
                    "name": "FieldOnChange",
                    "code": "Fis00100_ApuracaoDeImposto_Controller.controlaCampoCodigoSubItem(args.owner.field.widget)"
                }
            ];
            widgetItensDetalhamento.getField('CDITEMOCOR').mask = {
                "type": "fix",
                "params": {
                    "mask": "999.99"
                }
            };
            delete widgetItensDetalhamento.getField('CDITEMOCOR').displayedFields;
            delete widgetItensDetalhamento.getField('CDITEMOCOR').searchableFields;
            delete widgetItensDetalhamento.getField('CDITEMOCOR').showSelectAs;
            delete widgetItensDetalhamento.getField('CDITEMOCOR').valueField;
            delete widgetItensDetalhamento.getField('CDITEMOCOR').order;
            delete widgetItensDetalhamento.getField('CDITEMOCOR').outData;
            delete widgetItensDetalhamento.getField('CDITEMOCOR').fields;
            delete widgetItensDetalhamento.getField('CDITEMOCOR').dataSource;
            delete widgetItensDetalhamento.getField('CDITEMOCOR').dataSourceFilter;
            /*{
                "id": "63224560716265511161230",
                "name": "CDITEMOCOR",
                "label": "Código do Sub-Ítem",
                "isVisible": true,
                "fieldGroup": "occorrencia_gia",
                "maxlength": 5,
                "showOnList": true,
                "showOnForm": true,
                "showOnView": true,
                "class": "6",
                "template": "field/text-edit.html",
                "events": [
                    {
                        "id": "63224560732920089361231",
                        "name": "FieldOnChange",
                        "code": "Fis00100_ApuracaoDeImposto_Controller.controlaCampoCodigoSubItem(args.owner.field.widget)"
                    }
                ],
                "mask": {
                    "type": "fix",
                    "params": {
                        "mask": "999.99"
                    }
                }
            };*/
            
        } else if(filteredData.SGESTADO == 'RJ'){
            //widgetItensDetalhamento.getField('CDITEMOCOR').template = "zh-select-autocomplete#field/select-autocomplete.html";
            General.callRestEngine('fis#/crud/ocorrenciagiarj','FilterData', []).then(function(response) {
                
                widgetItensDetalhamento.getField('DSITEMOCOR').class = "12";
                widgetItensDetalhamento.getField('DSITEMOCOR').readOnly = true;
                widgetItensDetalhamento.getField('DSFLEGALOCOR').class = "12";
                widgetItensDetalhamento.getField('DSFLEGALOCOR').readOnly = true;
                widgetItensDetalhamento.getField('CDITEMOCOR').template = "field/select.html";
                widgetItensDetalhamento.getField('CDITEMOCOR').class = "12";
                widgetItensDetalhamento.getField('CDITEMOCOR').events = [];
                delete widgetItensDetalhamento.getField('CDITEMOCOR').mask;
                /*widgetItensDetalhamento.getField('CDITEMOCOR').displayedFields = [
                    "CDINSCESTA",
                    "SGESTADO"
                ];
                widgetItensDetalhamento.getField('CDITEMOCOR').searchableFields = [
                    "CDINSCESTA",
                    "SGESTADO"
                ];*/
                widgetItensDetalhamento.getField('CDITEMOCOR').showSelectAs = "grid";
                widgetItensDetalhamento.getField('CDITEMOCOR').valueField = "NRSEQUENCIAL";
                widgetItensDetalhamento.getField('CDITEMOCOR').descriptionField = "NRSEQUENCIAL";
                widgetItensDetalhamento.getField('CDITEMOCOR').order = "NRSEQUENCIAL";
                widgetItensDetalhamento.getField('CDITEMOCOR').outData = {
                    "NRSEQUENCIAL": "NRSEQUENCIAL",
                    "CDNUMEROOCOR": "CDITEMOCOR",
                    "DSOCORRENCIA": "DSITEMOCOR",
                    "DSLEGISLACAO": "DSFLEGALOCOR"
                };
                widgetItensDetalhamento.getField('CDITEMOCOR').fields = [
                    {
                        "name": "NRSEQUENCIAL",
                        "label": "Sequencial",
                        "template": "field/text-edit.html",
                        "isVisible": true,
                        "showOnList": true,
                        "events": []
                    },
                    {
                        "name": "IDTIPO",
                        "label": "Sub-tipo",
                        "template": "field/text-edit.html",
                        "isVisible": true,
                        "showOnList": true,
                        "events": []
                    },
                    {
                        "name": "CDNUMEROOCOR",
                        "label": "Número",
                        "template": "field/text-edit.html",
                        "isVisible": true,
                        "showOnList": true,
                        "events": []
                    },
                    {
                        "name": "DSOCORRENCIA",
                        "label": "Descrição",
                        "template": "field/text-edit.html",
                        "isVisible": true,
                        "showOnList": true,
                        "events": []
                    },
                    {
                        "name": "DTINIVALIDADE",
                        "label": "Validade Inicial",
                        "template": "field/text-edit.html",
                        "isVisible": true,
                        "showOnList": true,
                        "events": []
                    },
                    {
                        "name": "DTFINVALIDADE",
                        "label": "Validade Final",
                        "template": "field/text-edit.html",
                        "isVisible": true,
                        "showOnList": true,
                        "events": []
                    },
                    {
                        "name": "DSLEGISLACAO",
                        "label": "Descrição da Legislação",
                        "template": "field/text-edit.html",
                        "isVisible": true,
                        "showOnList": true,
                        "events": []
                    }
                ];
                widgetItensDetalhamento.getField('CDITEMOCOR').dataSource = {
                    "name": "fis#/crud/ocorrenciagiarj",
                    "rest": true,
                    "lazyLoad": true
                };
                widgetItensDetalhamento.getField('CDITEMOCOR').dataSource.data = response.dataset.ocorrenciagiarj;
            });
            /*{
                "id": "63224560716265511161230",
                "name": "CDITEMOCOR",
                "label": "Código do Sub-Ítem",
                "isVisible": true,
                "fieldGroup": "occorrencia_gia",
                "maxlength": 5,
                "showOnList": true,
                "showOnForm": true,
                "showOnView": true,
                "class": "6",
                "template": "zh-select-autocomplete#field/select-autocomplete.html",
                "displayedFields": [
                    "CDINSCESTA",
                    "SGESTADO"
                ],
                "searchableFields": [
                    "CDINSCESTA",
                    "SGESTADO"
                ],
                "showSelectAs": "grid",
                "valueField": "CDINSCESTA",
                "descriptionField": "",
                "order": "CDINSCESTA",
                "outData": {
                    "CDPAIS": "CDPAIS",
                    "SGESTADO": "SGESTADO",
                    "CDINSCESTA": "CDINSCESTA"
                },
                "fields": [
                    {
                        "name": "CDINSCESTA",
                        "label": "Inscrição Estadual",
                        "template": "field/text-edit.html",
                        "isVisible": true,
                        "showOnList": true,
                        "events": []
                    },
                    {
                        "name": "SGESTADO",
                        "label": "Estado",
                        "template": "field/text-edit.html",
                        "isVisible": true,
                        "showOnList": true,
                        "events": []
                    }
                ],
                "dataSource": {
                    "name": "fis#/crud/inscrestad",
                    "rest": true,
                    "lazyLoad": true
                },
                "dataSourceFilter": {
                    "name": "CDEMPRESA",
                    "operator": "=",
                    "value": ""
                }
            },
            */
        }
        
        widgetItensDetalhamento.reload();
            
        ScreenService.openSwipe(tabbedDetalhamento).then(
            function (success) {
                widgetItensDetalhamento.reload();
            }
        );

    };
    
    this.openDetalhamento = function (field,nomeTabbedDetalhamento){
        var widget                  = field.widget;
        var tabbedDetalhamento      = templateManager.container.getWidget(nomeTabbedDetalhamento);
        var widgetItensDetalhamento = tabbedDetalhamento.widgets[0];
        var tipo  = widget.name === 'widgetItensDetalhamentoIcmsSt'? widget.currentRow.IDTPAJUSTEAPSG : widget.currentRow.IDTIPOITMAPR;
        tipo = tipo === 'C' ? tipo ='OC' : tipo ==='D'? tipo ='OD': tipo = tipo;
        widgetItensDetalhamento.dataSourceFilter = [
            {
                "name": "P_CDFILIAL",
                "operator": "=",
                "value": widget.currentRow.CDFILIAL
            },
            {
                "name": "P_IDTIPOITMAPR",
                "operator": "=",
                "value": tipo
            },
            {
                "name": "P_NRSEQUMAPAPU",
                "operator": "=",
                "value": widget.currentRow.NRSEQUMAPAPU
            },
            {
                "name": "P_CDIMPOSTO",
                "operator": "=",
                "value": templateManager.container.getWidget('apuracao_de_imposto').currentRow.CDIMPOSTO
            },
            {
                "name": "P_NRLANCTONF",
                "operator": "=",
                "value": widget.currentRow.NRLANCTONF
            }
                
        ];
        if(widgetItensDetalhamento.name ==='widgetItensComposicaoIcmsSt'){
            widgetItensDetalhamento.dataSource.name ='fis_apuracoes#/crud/itensComposicao_icmsSt';
            widgetItensDetalhamento.dataSourceFilter.push(
                {
                    "name": "P_IDSUBSTSOLIDST",
                    "operator": "=",
                    "value": widget.currentRow.IDSUBSTSOLIDST
                },
                {
                    "name": "P_NRSEQITMAPR",
                    "operator": "=",
                    "value": widget.currentRow.NRSEQAJUSAPURSG
                }
            );
        }else{
            widgetItensDetalhamento.dataSource.name ='fis_apuracoes#/crud/itensComposicao_detalhamentoGeral';
            var filtroICMS =
                {
                    "name": "P_NRSEQITMAPR",
                    "operator": "=",
                    "value": widget.currentRow.NRSEQITMAPR
                };
            
            widgetItensDetalhamento.dataSourceFilter.push(filtroICMS);
        }
        ScreenService.openSwipe(tabbedDetalhamento).then(
            function (success) {
                widgetItensDetalhamento.reload();
            }
        );

    };
    
    this.openDetalhamentoCreditoAnterior = function (field){
        var widget                  = field.widget;
        var tabbedDetalhamento      = templateManager.container.getWidget(field.childWidgetName);
        var widgetItensDetalhamento = tabbedDetalhamento.widgets[0];
        var campoCredito            = widgetItensDetalhamento.getField(field.nameField);
        var actionSalvar            = widgetItensDetalhamento.getAction('salvar');
        
        if(widget.currentRow.IDBLOQMAPAPU ==='S'){
                campoCredito.readOnly = true;
                actionSalvar.readOnly = true;
        }else{
            if(widget.currentRow.IDPRIMEIROMAPA ==='S'){
                campoCredito.readOnly = false;
                actionSalvar.readOnly = false;
            }
            else{
                campoCredito.readOnly = true;
                actionSalvar.readOnly = true;
            }
        }
        widgetItensDetalhamento.currentRow = Util.clone(field.widget.currentRow);
        ScreenService.openSwipe(tabbedDetalhamento);

    };
    
    this.openDetalhamentoCreditoAnteriorDifalFcp = function (field,tipo){
        var widgetMapa              = templateManager.container.getWidget('apuracao_de_imposto');
        var widget                  = field.widget;
        var tabbedDetalhamento      = templateManager.container.getWidget('tabbedCreditoAnteriorDifalFcp');
        var widgetItensDetalhamento = tabbedDetalhamento.widgets[0];
        
        var actionSalvar = widgetItensDetalhamento.getAction('salvar');
        var creditoDifal = widgetItensDetalhamento.getField('VRSLDCRANTEDIFAL');
        var creditoFCP   = widgetItensDetalhamento.getField('VRSLDCRANTEFCP');
        
        var primeiroMapa      = !(widgetMapa.currentRow.IDBLOQMAPAPU !='S' && widget.currentRow.IDPRIMEIROMAPA ==='S');
        actionSalvar.readOnly = primeiroMapa ;
        creditoDifal.readOnly = primeiroMapa;
        creditoFCP.readOnly   = primeiroMapa;
        
        creditoDifal.isVisible = tipo ==='DIFAL';
        creditoFCP.isVisible   = tipo ==='FCP';
       
        widgetItensDetalhamento.currentRow      =  Util.clone(field.widget.currentRow);
        widgetItensDetalhamento.currentRow.TIPO =  tipo;
        ScreenService.openSwipe(tabbedDetalhamento);

    };
    
    this.voltarCreditoAnterior = function (nomeWidget){
        var widget = templateManager.container.getWidget(nomeWidget);
        ScreenService.goBack();  
        widget.activate();
        //widget.currentRow = templateManager.container.getWidget('apuracao_de_imposto').currentRow;
    };
   
    this.voltarCreditoAnteriorDifalFcp = function(widget){
        var nomeWidget = widget.currentRow.TIPO ==='DIFAL'?'widgetDetalhamentoIcmsDifal':'widgetDetalhamentoIcmsFcp';
        var widgetAtiva = templateManager.container.getWidget(nomeWidget);
        ScreenService.goBack();  
        widgetAtiva.activate();
    };
    
    /*
        Função que ira controlar campos que só serão exibido caso o mapa
        seja de determinado imposto e respeitando condições de Estado, pois existem campos
        que são exibidos somente para um estado específico.
        Aba de detalhamento Impostos Gerais.
    */
    this.controlaCamposDetalhamentoGeralItens = function (widgetItens){
        var widgetApuracao     = templateManager.container.getWidget('apuracao_de_imposto');
        var camposImpostosICMS = ['IDCOMPOEC197'];
        var camposGerais       = ['CDAJUSTEITMAPA'];
        var campoMt            = ['CDITPROCEDENCIA'];
        var campoSc            = ['CDITEDCIPMAPA'];
        var campoPe            = ['CDAJUSTEITSEF'];
        var camposRjSp         = ['CDITEMOCOR','DSITEMOCOR','DSFLEGALOCOR'];
        
        
        camposImpostosICMS.forEach(
            function(field) {
                widgetItens.getField(field).isVisible = (widgetApuracao.currentRow.CDIMPOSTO === impostoIcms) && (filteredData.SGESTADO !=='DF');
            }
        );  
        
        campoMt.forEach(
            function(field) {
                widgetItens.getField(field).isVisible = (filteredData.SGESTADO ==='MT') && (widgetApuracao.currentRow.CDIMPOSTO === impostoIcms);
            }
        );
        
        campoSc.forEach(
            function(field) {
                widgetItens.getField(field).isVisible = (filteredData.SGESTADO ==='SC') && (widgetApuracao.currentRow.CDIMPOSTO === impostoIcms);
            }
        );
        
        campoPe.forEach(
            function(field) {
                widgetItens.getField(field).isVisible = (filteredData.SGESTADO ==='PE') && (widgetApuracao.currentRow.CDIMPOSTO === impostoIcms);
            }
        );
        
        camposRjSp.forEach(
            function(field) {
                widgetItens.getField(field).isVisible = (filteredData.SGESTADO ==='RJ' || filteredData.SGESTADO ==='SP') && (widgetApuracao.currentRow.CDIMPOSTO === impostoIcms);
            }
        );
        
        camposGerais.forEach(
            function(field) {
                widgetItens.getField(field).isVisible = ( widgetApuracao.currentRow.CDIMPOSTO === impostoIcms  || widgetApuracao.currentRow.CDIMPOSTO === impostoIpi ) && ( ( filteredData.IDTIPOAPURA ==='E') || (filteredData.IDTIPOAPURA !='E' ) );
            }
        );

    };
    
    this.controlaCampoComporSped = function (widget){
        var campoNota       = widget.getField('NRNOTAFISC');
        //var nomeCampoAjuste = widget.name ==='widgetItensDetalhamento' ? 'CDAJUSTEITMAPA' :'CDAJUSTEAPURSG'; 
        
        if (widget.currentRow.IDCOMPOEC197 ==='I' || widget.currentRow.IDCOMPOEC197 ==='D'){
            campoNota.validations.required = true;

        }else{
            delete(campoNota.validations.required);   
            //widget.getField('VRITEMMAPR').readOnly = false;
        }
        //widget.getField(nomeCampoAjuste).value('');
    };
    
    this.avisoComporSpeed = function (field){
        var valor = field.value();
        if(valor === 'D'){
            ScreenService.showMessage('Atenção! As informações serão geradas somente no registro C197 do SPED FISCAL e desconsiderada do registro E111. Será considerado o valor digitado para a nota, e os campos de Base e Alíquotas serão zerados.');            
        }else if(valor =='I'){
            ScreenService.showMessage('Atenção! As informações serão geradas somente no registro C197 do SPED FISCAL e desconsiderada do registro E111. Serão considerados os valores de Base de Cálculo, Alíquota e Valor do Imposto presente nos itens da nota. Os itens selecionados para gerar o C197 serão zerados nos registros C190 e C100.');
        }
        
    };

    this.controlaCampoCodigoSubItem = function (widget){
        var field =  widget.getField('CDITEMOCOR');
        var campoDescricao     = widget.getField('DSITEMOCOR');
        var campoFundamentacao = widget.getField('DSFLEGALOCOR');
        if( field.value() ){
            var campoCodigo = field.value().replace(/[^0-9]/g,'');
            if(campoCodigo.substr(3,4) ==='99'){
                campoDescricao.readOnly = false;
                campoDescricao.validations.required = true;
                
                campoFundamentacao.readOnly = false;
                campoFundamentacao.validations.required = true;
            }else{
                campoDescricao.readOnly = true;
                campoDescricao.value('');
                delete(campoDescricao.validations.required);
                
                campoFundamentacao.readOnly = true;
                campoFundamentacao.value('');
                delete(campoFundamentacao.validations.required);
            }
            
        }else{
            campoDescricao.readOnly = true;
            campoDescricao.value('');
            delete(campoDescricao.validations.required);
            
            campoFundamentacao.readOnly = true;
            campoFundamentacao.value('');
            delete(campoFundamentacao.validations.required);
        }  
    };
    
    /*
        Função que ira controlar campos que dependem do campo
        número do processo na aba de guias complementares
        na apurção de  impostos gerais.
    */
    this.controlaCampoNumeroProcesso = function (widget){
        var nomeProceso    = widget.name === 'widgetArrecadacaoFiscalIcmsSt' ? 'NRPROCESSO'  : 'NRPROCESSOGUIA';
        var nomeOrigem     = widget.name === 'widgetArrecadacaoFiscalIcmsSt' ? 'IDORIGEMDET' : 'IDORIGEMGUIA';
        var nomeHistorico  = widget.name === 'widgetArrecadacaoFiscalIcmsSt' ? 'DSHISTORICO' : 'DSHISTGUIACOMPL';
        
        var campoProcesso  = widget.getField(nomeProceso);
        var campoOrigem    = widget.getField(nomeOrigem);
        var campoHistorico = widget.getField(nomeHistorico);
        
        if(campoProcesso.value()){
            campoOrigem.readOnly    = false;
            campoHistorico.readOnly = false;
        }else{
            campoOrigem.readOnly    = true;
            campoHistorico.readOnly = true;
        }
        
    };
    
    
    /*
        Controla os filtros do campo codigo de ajuste
    */
    this.controlaCampoCodigoAjuste = function (field){
        var widget = field.widget;
        if(field.name==='CDAJUSTEITSEF'){
            field.dataSourceFilter =[
                {
                    "name":"IDTPCODRECEITA",
                    "operator":"=",
                    "value":'E'
                },
                {
                    "name":"SGESTADO",
                    "operator":"=",
                    "value":filteredData.SGESTADO
                },
                 {
                    "name":"IDTPAJUSTE",
                    "operator":"=",
                    "value":'D'
                }
                
            ];
            field.reload();
        }
        else{
            if(filteredData.IDTIPOAPURA ==='E'){
                var tipoAjuste =  widget.currentRow.IDCOMPOEC197 === 'I' || widget.currentRow.IDCOMPOEC197 === 'D' ?'D':'A';
                field.dataSourceFilter =[
                    {
                        "name":"IDTPCODRECEITA",
                        "operator":"=",
                        "value":filteredData.IDTIPOAPURA
                    },
                    {
                        "name":"SGESTADO",
                        "operator":"=",
                        "value":filteredData.SGESTADO
                    },
                     {
                        "name":"IDTPAJUSTE",
                        "operator":"=",
                        "value":tipoAjuste
                    }
                    
                ];    
            }else if (filteredData.IDTIPOAPURA ==='F'){
                 field.dataSourceFilter =[
                    {
                        "name":"IDTPCODRECEITA",
                        "operator":"=",
                        "value":filteredData.IDTIPOAPURA
                    },
                    {
                        "name":"SGESTADO",
                        "operator":"IS_NULL"
                    },
                    {
                        "name":"IDTPAJUSTE",
                        "operator":"=",
                        "value":'A'
                    }
                ];    
            }    
            field.reload();
        }
        
    };
    
    
    this.controlaComporC197Itens = function (widget){
        var condicao       = ( filteredData.IDTIPOAPURA==='E') && ( filteredData.CDIMPOSTO ===impostoIcms || filteredData.CDIMPOSTO ===impostoIcmsSt ) && (widget.currentRow.IDCOMPOEC197 === 'I' ) && (filteredData.SGESTADO !=='PE' && filteredData.SGESTADO !=='DF');
        var nomeCampoValor = widget.name ==='widgetItensDetalhamento' ? 'VRITEMMAPR' :'VRAJUSTEAPURSG';
        
        widget.getField(nomeCampoValor).readOnly = condicao;
        widget.getField('BUTITENS').isVisible    = condicao;
        
        if(widget.name ==='widgetItensDetalhamentoIcmsSt')
            this.controlaCampoSubstitutoSolidario(widget);
    };
   
    this.addSubDetalhamento = function (widget){
        var widgetApuracao = templateManager.container.getWidget('apuracao_de_imposto');
        widget.newRow();
        widget.currentRow.NRSEQUMAPAPU = widgetApuracao.currentRow.NRSEQUMAPAPU;
        widget.currentRow.IDTIPOITMAPR = widget.dataSourceFilter[1].value;
        
        if(widget.name === 'widgetItensDetalhamento')
            this.controlaCampoComporSped(widget);
    };
    
    /*
        Funcação que pega a soma de todos os Itens da 
        Nota quando o campo compor c197 speed tem o valor dos Itens.
        Verifica as notas marcadas e as tabelas relacionadas para retornar o
        valor correta da soma
        Executada somente no onChange cos Campos que influenciam a soma(NOTA FISCAL e COMPOR C197) 
        Sub-detalhamento da apuração de impostos geral.
    */
    
    this.controlaValorItensComposicao = function(widget){
        
        var nomeCampoValor          = widget.name ==='widgetItensDetalhamento' ? 'VRITEMMAPR' :'VRAJUSTEAPURSG';
        widget.currentRow.CDIMPOSTO = templateManager.container.getWidget('apuracao_de_imposto').currentRow.CDIMPOSTO;
        
        //valores default
        widget.currentRow.CDFILIAL    = widget.currentRow.CDFILIAL ? widget.currentRow.CDFILIAL : '';
        widget.currentRow.NRLANCTONF  = widget.currentRow.NRLANCTONF ? widget.currentRow.NRLANCTONF : '';
        
        General.callRestEngine('fis_apuracoes#/controlaValorItensComposicao','Row', widget.currentRow ).then(
            function (success)  {
                widget.currentRow[nomeCampoValor] = success.dataset.soma.VRIMPOSTO;
            }.bind(this),
            function (callback) {
                if (callback.data) {
                    ScreenService.showMessage(callback.data.error);
                }
            }  
        );
        
    };
    
    this.onChangeComporC197Speed = function (field){
        var widget          = field.widget;
        var nomeCampoAjuste = widget.name ==='widgetItensDetalhamento' ? 'CDAJUSTEITMAPA' :'CDAJUSTEAPURSG'; 
        
        widget.getField(nomeCampoAjuste).value('');
        if(widget.currentRow.IDCOMPOEC197 ==='I' && ! widget.currentRow.NRNOTAFISC){
            widget.currentRow.IDCOMPOEC197 ='N';
            ScreenService.showMessage(Messages_fiscal.COMPOR_ITENS);
        }
        
        this.controlaCampoComporSped(widget);
        this.avisoComporSpeed(field);
        this.controlaComporC197Itens(widget);  
        this.controlaValorItensComposicao(widget);
    };
    
    /*  Procedimento para inserir um novo registro na aba de Inforações
        Adicionais, exibida com o imposto selecionado for o ICMS.
    */
    this.salvarInformacoesAdicionais = function(widget){
        if(widget.isValid()){
            var widgetMapa = templateManager.container.getWidget('apuracao_de_imposto');
            if(widget.currentRow.__is_new)
                widget.currentRow.NRSEQUMAPAPU = widgetMapa.currentRow.NRSEQUMAPAPU;
            General.callRestEngine('fis_apuracoes#/salvarInformacoesAdicionais','Row', widget.currentRow ).then(
                function (response) {
                    sucessoSalvarGrid(widget);        
                },
                function (callback) {
                    if (callback.data) {
                        ScreenService.showMessage(callback.data.error);
                    }
                }  
            );    
            
        }
    };
    
    this.replicarInformacoesAdicionais = function (widget){
        ScreenService.confirmMessage(ScreenService.i18n(Messages_fiscal.REPLICAR_INFORMACOES_ADICIONAIS), 'question', function (success) {
           General.callRestEngine('fis_apuracoes#/replicarInformacoesAdicionais','Row', templateManager.container.getWidget('apuracao_de_imposto').currentRow ).then(
                function (response) {
                    ScreenService.closePopup();
                    widget.reload();
                },
                function (callback) {
                    if (callback.data) {
                        ScreenService.showMessage(callback.data.error);
                    }
                }  
            );   
        });
    };
    
    this.addGuiasFiscaisIcms = function (widget){
        var widgetDifalIcms = templateManager.container.getWidget('widgetDifalIcms');
        widget.newRow();
        General.justInteger('#CDOBRIGAGUIA, #NRPROCESSOGUIA');
        
        //Procedimetos para gerar novo código;
        var paramsNewCode     = widget.paramsNewCode;
        var keysParamsNewCode = Object.keys(paramsNewCode);
        keysParamsNewCode.forEach(function(value) {
        widget.currentRow[value] = paramsNewCode[value];
        });
        
        widget.currentRow.NRSEQUMAPAPU      = widgetDifalIcms.currentRow.NRSEQUMAPAPU;
        widget.currentRow.NRSEQMAPAPURESTNC = widgetDifalIcms.currentRow.NRSEQMAPAPURESTNC;
    };
    
    /*
     *   Função que controla os sub detlahemnto da aba de DIFAL/FCP.
     */
    this.openDetalhamentoDifalFcp = function (field){
        var tabbedDetalhamento      = templateManager.container.getWidget('tabbedItensDetalhamentoDifalFcp');
        var widgetItensDetalhamento = tabbedDetalhamento.widgets[0];
       
        widgetItensDetalhamento.label                     = field.childWidgetLabel;
        widgetItensDetalhamento.dataSourceFilter[2].value = field.childWidgetFiltro;
        widgetItensDetalhamento.dataSourceFilter[3].value = field.tipoWidget;
        
        ScreenService.openSwipe(tabbedDetalhamento).then(
            function (success) {
                widgetItensDetalhamento.reload();
            }
        );

    };
    
    this.voltarDetalhamentoDifalFcp = function (widget){
        var nomeWidget = widget.dataSourceFilter[3].value ==='D'?'widgetDetalhamentoIcmsDifal':'widgetDetalhamentoIcmsFcp';
        ScreenService.goBack();
        templateManager.container.getWidget(nomeWidget).activate();
    };
    
    this.addArrecadacaoFiscalIcmsSt = function (widget){
        widget.newRow();
        General.justInteger('#CDOBRIGACAO, #NRPROCESSO');
        this.controlaCampoNumeroProcesso(widget);
        widget.currentRow.NRSEQUDETUF      = '';
        widget.currentRow.NRSEQUMAPAPU     = widget.getParent().currentRow.NRSEQUMAPAPU;
        widget.currentRow.NRSEQMAPAAPUREST = widget.getParent().currentRow.NRSEQMAPAAPUREST;
        widget.currentRow.SGESTADO         = widget.getParent().currentRow.SGESTADO;
        widget.currentRow.CDPAIS           = widget.getParent().currentRow.CDPAIS;
    };
    
    this.controlaCampoSubstitutoSolidario = function (widget){
        var campoSolidario = widget.getField('IDSUBSTSOLIDST');
        if(widget.currentRow.IDCOMPOEC197==='I'){
            campoSolidario.readOnly = false;
        }else{
            campoSolidario.readOnly = true;
            campoSolidario.value('N');
        }
    };
    
    /*
        Caso os itens sejam do substituto solidario E compoem C197,
        é permitido alterar o valor do imposto e da base de cálculo.
    */
    this.controlaValorItensSubstituto = function (widget){
        var widgetDetalhamento = templateManager.container.getWidget('widgetItensDetalhamentoIcmsSt');
        var campoValor         = widget.getField('VRIMPOSTO');
        var condicao           = widgetDetalhamento.currentRow.IDSUBSTSOLIDST ==='S' && widget.currentRow.IDCOMPOE ==='S';
        
        campoValor.readOnly       = !condicao;
    };

    
    /********************************************************
     *                                                      *
     *                  Funções Auxiliares                  *
     *                                                      *
     ********************************************************/


    /*  Função que dispara todas outras funções necessária
    que são executadas quando ocorre o evento de after moveRow do
    grid de apuração de imposto;
        
    */
    this.afterMoveRowApuracaoImposto = function (args){
        var widget = args.owner;
        this.setChildGridsNeedReload(widget); 
        this.checkElementsVisibility(widget); 
        this.setSameCurrentRowChildWidgets(widget); 
        this.alteraVisibilidadeActionsMapaBloqueado(); 
        this.checkArrecadacaoContribuicoesFieldsRequired(widget);
        if(widget.currentRow.CDIMPOSTO === impostoIcms)
            this.recarregarWidget('widgetDifalIcms');
            
        if(icmsStIsSelected(widget.currentRow.CDIMPOSTO))
            this.recarregarWidget('detalhamentoIcmsSt');
            widget.reload();
        //this.verificaEdicaoDetalhamento(widget);
    };
    
    /*
     * Função para recarregar um elemento conforme propriedade "needReload" que
     * é setado neste de acordo com alterações realizadas na tela.
     */
    this.checkElementNeedReload = function(element) {
        if (element.needReload) {
            element.needReload = false;
            element.reload();
        }
    };

    /*
     * Função para verificar se um número sequencial inserido pelo usuário é
     * único.
     */
    this.checkValidSequencialDetalhamento = function(calculosDetalhamentoWidget) {
        var currentRow = calculosDetalhamentoWidget.currentRow;
        if (currentRow.NRSEQITDETAPU) {
            Fis00100_ApuracaoDeImposto_Service.checkValidSequencialDetalhamento(currentRow)
            .then(function(response) {
                if (!response.dataset.validation.isValid) {
                    ScreenService.showMessage(Messages_fiscal.SEQUENCIAL_JA_CADASTRADO).then(function() {
                        currentRow.NRSEQITDETAPU = null;
                    });
                }
            })
            .catch(function(errorResponse) {
                var errorMessage = Messages_fiscal.TIMEOUT_ERROR;
                if (errorResponse && errorResponse.data && errorResponse.data.error) {
                    errorMessage = errorResponse.data.error;
                }
                ScreenService.showMessage(errorMessage);
            });
        }
    };

    /*
     * Função para verificar se um imposto é de Contribuições. Utiliza o imposto
     * filtrado, caso nenhum parâmetro seja passado.
     */
    var contribuicoesIsSelected = function(cdimposto) {
        cdimposto = cdimposto || filteredData.CDIMPOSTO;
        var impostosContribuicoes = [].concat(impostoPis,impostosCofins);
        return impostosContribuicoes.indexOf(cdimposto) !== -1;
    };

    /*
     * Função padrão para tratamento de erros de requisições.
     */
    var errorHandler = function(errorResponse) {
        // Utiliza mensagem padrão, caso não haja mensagem de erro retornada.
        var errorMessage = Messages_fiscal.TIMEOUT_ERROR;
        if (errorResponse && errorResponse.data && errorResponse.data.error) {
            errorMessage = errorResponse.data.error;
        }
        ScreenService.showMessage(errorMessage);
    };

    /*
     * Função para fazer setar a propriedade "needReload" como true em todas as
     * widgets filhas de uma principal. Ela só afeta aquelas widgets que tenham
     * o evento chamando a função "checkElementNeedReload", que recarregará
     * a widget.
     */
    this.setChildGridsNeedReload = function(mainWidget) {
        mainWidget.widgets.forEach(function(childWidget) {
            childWidget.needReload = true;
        });
    };

    /*
     * Função para fazer a currentRow de todas as filhas apontarem para a row
     * selecionada no grid principal. Assim as informações compartilhadas entre
     * as widgets podem ser sincronizadas e exibidas de forma simultânea.
     * Widgets que sejam grids não serão afetados, pois continuarão com o
     * comportamento padrão.
     */
    this.setSameCurrentRowChildWidgets = function(mainWidget) {
        // Verifica se o imposto filtrado é de contribuições.
        var widgetsGerais = ["guiaFiscalArrecadaoGeral","detalhamentoGeral"];
        var widgetsInss   = ["detalhamentoInss","guiaFiscalArrecadaoGeral"];
        var mainRow       = mainWidget.currentRow;
        
        if ( contribuicoesIsSelected() ) {
            mainWidget.widgets.forEach(function(childWidget) {
                if(childWidget.name == "tabbedContribuicoesDetalhamento"){
                    childWidget.widgets.forEach(function(newChildWidget) {
                        newChildWidget.currentRow = mainRow;
                    });
                } else {
                    childWidget.currentRow = mainRow;
                }
            });
        }
        else if ( inssIsSelected(mainRow.CDIMPOSTO) ){
            widgetsInss.forEach(function(nomeWidget) {
                templateManager.container.getWidget(nomeWidget).currentRow = mainRow;
            });
        }
        else if ( impostosGeraisIsSelected(mainRow) ){
            widgetsGerais.forEach(function(nomeWidget) {
                templateManager.container.getWidget(nomeWidget).currentRow = mainRow;
            });
        }
    };

    /*
     * Função para verificar se um tipo de apuração é de Simples Nacional.
     * Utiliza o tipo de apuração filtrado, caso nenhum parâmetro seja passado.
     */
    var simplesNacionalIsSelected = function(idtipoapura) {
        idtipoapura = idtipoapura || filteredData.IDTIPOAPURA;
        return idtipoapura == "S";
    };
    
    /*
     * Função para verificar se um tipo de apuração é de Impostos Gerais.
     * Utiliza o imposto filtrado, caso nenhum parâmetro seja passado.
     */
    var impostosGeraisIsSelected = function(row) {
        var todosImpostos = [];
        var cdimposto     = row.CDIMPOSTO;
        var tipoApurac    = row.IDTIPOAPURA;
        todosImpostos     = todosImpostos.concat(impostosCofins,impostoPis ,impostosInss, impostosIrpjCsll);
        //Caso não seja nenhum dos impostos infornmados o Tipo de Apuração e de impostos Gerais;
        if(!simplesNacionalIsSelected(tipoApurac))
            return todosImpostos.indexOf(cdimposto) == -1;     
        else
            return false;
    
    };
    
     /*
     * Função para verificar se um imposto é INSS. Utiliza o imposto
     * filtrado, caso nenhum parâmetro seja passado.
     */
    var inssIsSelected = function(cdimposto) {
        cdimposto = cdimposto || filteredData.CDIMPOSTO;
        return impostosInss.indexOf(cdimposto) !== -1;
    };
    
    /*
     * Função para verificar se um imposto é INSS. Utiliza o imposto
     * filtrado, caso nenhum parâmetro seja passado.
     */
    var icmsStIsSelected = function(cdimposto) {
        cdimposto = cdimposto || filteredData.CDIMPOSTO;
        return cdimposto === impostoIcmsSt;
    };

    /*
        Função para alterar a visibilidade da widget 
        recebendo um array com os nomes das widgets e a visibilidade desejada
    */
    var visibilidadeWidget = function (widgets, visibilidade){
        widgets.forEach(function(widget) {
            templateManager.container.getWidget(widget).isVisible = visibilidade;
        });
    };
    
    /*
        Função para alterar a visibilidade da filds 
        recebendo um array com os nomes dos fields e a visibilidade desejada
    */
    var visibilidadeField = function (widget,fields,visibilidade){
        fields.forEach(function(field) {
            widget.getField(field).isVisible = visibilidade;
        });
    };
    
    this.bloqueiaCampos = function (widget, campoExecao, status){
        widget.fields.forEach(function(field) {
            if( field.name.indexOf(campoExecao) !== -1)
                field.readOnly = !status;
            else
                field.readOnly = status;
        });
    };
    
    /*
        Recarrega uma widget para atualizar os dados, exceto se estiver abrindo um
        swipe para adicionar um novo registro
    */
    this.recarregarWidget = function (nomeWidget){
          var widget = templateManager.container.getWidget(nomeWidget);
          if( !widget.currentRow.__is_new ){
              widget.reload();
          } else {
              widget.reload();
          }
          //QUAL WID?
          if( filteredData.SGESTADO == 'RS'){
              widget.actions.forEach(function(action){
                  if(action.name == 'GERA_GIA_RS'){
                      action.isVisible = true;
                  }
              });
          } else {
              widget.actions.forEach(function(action){
                  if(action.name == 'GERA_GIA_RS'){
                      action.isVisible = false;
                  }
              });
          }
    };

    this.setCurrentRow = function (widget,nomesWidget){
        nomesWidget.forEach(function(nome) {
            templateManager.container.getWidget(nome).currentRow = widget.currentRow;
        });  
    };
    
    self.openGeraGiaRs = function(){
        var widgetGiaRs = templateManager.container.getWidget('widgetGeraGiaRs');
        ScreenService.openPopup(widgetGiaRs);
        widgetGiaRs.activate();
    };
    
    self.geraGiaRs = function(widget){
        if(widget.isValid()){
            //GERA_INFADIC_GIA_RS(:P_NRSEQUMAPAPU, :P_CDLIVROMAG, :P_NREMPREGADOS, :P_VRFOLHA, :P_INSCRCENTRAL, :P_ATODECLARA);
            //var row = widget.getParent().currentRow;
            widget.currentRow.NRSEQUMAPAPU = widget.getParent().getParent().currentRow.NRSEQUMAPAPU;
            General.callRestEngine('fis_apuracoes#/geraGiaRs','Row', widget.currentRow).then(
                function(success){
                    ScreenService.closePopup();
                    templateManager.container.getWidget('widgetInformacoesAdicionais').reload();
                    ScreenService.closePopup();
                }, function(error) {
                    ScreenService.showMessage(error.data.error);                
                });
        }
            
    };
    
    self.controlaAtoDecl = function(widget){
        if(widget.currentRow.INSCRCENTRAL == 'N'){
            widget.getField('ATODECLARA').readOnly = true;
        } 
        else if(widget.currentRow.INSCRCENTRAL == 'S'){
            widget.getField('ATODECLARA').readOnly = false;
        }
        widget.getField('ATODECLARA').reload();
    };
    
    /*
     * Função para alterar a habilitação da widget de Ajuste de Contribuição
     * conforme apuração do mapa.
     */
    var habilitaAjusteContribuicao = function(widget) {
        var widgetAjuste = templateManager.container.getWidget('ajusteContribuicao');
        var idbloqmapapu = widget.currentRow.IDBLOQMAPAPU;
        // Verifica se o mapa está apurado ou bloqueado.
        var enabled = idbloqmapapu == "A" || idbloqmapapu == "S";
        widgetAjuste.enabled = enabled;
    };
    
    /*
     * Função para alterar a visibilidade de campos da widget de Ajuste de Contribuição
     * conforme o tipo de ajuste selecionado.
     */
    self.onChangeTipoAjuste = function() {
        var widget = templateManager.container.getWidget('ajusteContribuicao');
        var tipoAjuste = widget.currentRow.IDINDICAJUSTE;
        // Verifica se qual o tipo de ajuste selecionado
        if(tipoAjuste == 'C'){
            widget.currentRow.IDCUMUPISCOFIL = "S";
            
            widget.getField('CDTPCREDPICOITE').validations  = {"required": {"message": "Campo obrigatório"}};
            widget.getField('CDAJUSTE').validations         = {"required": {"message": "Campo obrigatório"}};
            
            widget.getField('CDSITUTRIBITNFE').validations  = {};
            widget.getField('CDCONTCTBL').validations       = {};
            widget.getField('NMFILIAL').validations         = {};
            widget.getField('CDAJUSTEBC').validations       = {};
            widget.getField('VRBASECALCAJ').validations     = {};
            widget.getField('NRRECIBO').validations         = {};
            
            widget.getField('CDTPCREDPICOITE').readOnly     = false;
            widget.getField('CDAJUSTE').readOnly            = false;    
            widget.getField('IDAPROPRIACAO').readOnly       = false;
            widget.getField('CDSITUTRIBITNFE').readOnly     = true;
            widget.getField('CDCONTCTBL').readOnly          = true;
            widget.getField('NMFILIAL').readOnly            = true;
            widget.getField('CDAJUSTEBC').readOnly          = true;
            widget.getField('VRBASECALCAJ').readOnly        = true;
            widget.getField('NRRECIBO').readOnly            = true;
            widget.getField('IDCUMUPISCOFIL').readOnly      = true;

        } else if(tipoAjuste == 'DI'){
            
            widget.getField('CDSITUTRIBITNFE').validations  = {"required": {"message": "Campo obrigatório"}};
            widget.getField('CDAJUSTE').validations         = {"required": {"message": "Campo obrigatório"}};
            
            widget.getField('CDTPCREDPICOITE').validations  = {};
            widget.getField('CDCONTCTBL').validations       = {};
            widget.getField('NMFILIAL').validations         = {};
            widget.getField('CDAJUSTEBC').validations       = {};
            widget.getField('VRBASECALCAJ').validations     = {};
            widget.getField('NRRECIBO').validations         = {};
            
            widget.getField('CDSITUTRIBITNFE').readOnly     = false;
            widget.getField('CDAJUSTE').readOnly            = false;
            widget.getField('IDCUMUPISCOFIL').readOnly      = false;
            widget.getField('IDAPROPRIACAO').readOnly       = false;
            widget.getField('CDTPCREDPICOITE').readOnly     = true;
            widget.getField('CDCONTCTBL').readOnly          = true;
            widget.getField('NMFILIAL').readOnly            = true;
            widget.getField('CDAJUSTEBC').readOnly          = true;
            widget.getField('VRBASECALCAJ').readOnly        = true;
            widget.getField('NRRECIBO').readOnly            = true;
            
        } else if(tipoAjuste == 'DB'){
            
            widget.getField('CDSITUTRIBITNFE').validations  = {"required": {"message": "Campo obrigatório"}};
            widget.getField('CDCONTCTBL').validations       = {"required": {"message": "Campo obrigatório"}};
            widget.getField('NMFILIAL').validations         = {"required": {"message": "Campo obrigatório"}};
            widget.getField('CDAJUSTEBC').validations       = {"required": {"message": "Campo obrigatório"}};
            widget.getField('VRBASECALCAJ').validations     = {"required": {"message": "Campo obrigatório"}};
            widget.getField('NRRECIBO').validations         = {"required": {"message": "Campo obrigatório"}};
            
            widget.getField('CDAJUSTE').validations         = {};
            widget.getField('CDSITUTRIBITNFE').validations  = {};
            widget.getField('CDTPCREDPICOITE').validations  = {};
            
            widget.getField('CDSITUTRIBITNFE').readOnly     = false;
            widget.getField('CDCONTCTBL').readOnly          = false;
            widget.getField('NMFILIAL').readOnly            = false;
            widget.getField('CDAJUSTEBC').readOnly          = false;
            widget.getField('VRBASECALCAJ').readOnly        = false;
            widget.getField('IDAPROPRIACAO').readOnly       = false;
            widget.getField('NRRECIBO').readOnly            = false;
            widget.getField('IDCUMUPISCOFIL').readOnly      = false;
            widget.getField('CDAJUSTE').readOnly            = true;
            widget.getField('CDSITUTRIBITNFE').readOnly     = true;
            widget.getField('CDTPCREDPICOITE').readOnly     = true;
        }
    };
    
    /*
     * Função que calcula automaticamente o valor do ajuste 
     * conforme o Valor Base de Cálculo. 
     */
    self.onChangeVlrBaseCalculo = function() {
        var widgetAjusteContibuicao = templateManager.container.getWidget('ajusteContribuicao');
        var regime  = widgetAjusteContibuicao.currentRow.IDCUMUPISCOFIL; 
        var imposto = General.getFieldValue('CDIMPOSTO', 'apuracao_de_imposto');
        var aliquota;
        
        if(widgetAjusteContibuicao.currentRow.VRBASECALCAJ && regime){
            //PIS e Regime Cumulativo
            if(imposto == "50" && regime == "N")
                aliquota = 1.65;
                
            //PIS e Regime Não Cumulativo
            else if(imposto == "50" && regime == "S")
                aliquota = 0.65;
                
            //COFINS e Regime Cumulativo
            else if(imposto == "60" && regime == "N")
                aliquota = 7.6;
            
            //COFINS e Regime Não Cumulativo
            else if(imposto == "60" && regime == "S")
                aliquota = 3;
                
            widgetAjusteContibuicao.currentRow.VRAJUSTE = (widgetAjusteContibuicao.currentRow.VRBASECALCAJ * aliquota)/100;
            widgetAjusteContibuicao.reload();
        }
    };
    
    /*
     * Função que aplica o readOnly padrão nos campos.
     */
    self.aplicaReadOnly = function() {
        var widgetAjusteContibuicao = templateManager.container.getWidget('ajusteContribuicao');
        widgetAjusteContibuicao.fields.forEach(function(field){
            if(field.name != "IDINDICAJUSTE" && field.name != "IDTPAJUSTE" && field.name != "IDCUMUPISCOFIL" && field.name != "VRAJUSTE" && field.name != "NRPROCESSO" && field.name != "DSAJUSTE" && field.name != "DTAJUSTE")
                field.readOnly = true;
            else field.readOnly = false;
        });
    };
    
    /*
     * Função salva o Ajuste de Contribuição
     */
    self.salvar = function() {
        var widgetAjusteContibuicao = templateManager.container.getWidget('ajusteContribuicao');
        
        var data = [];
        data = {
            NRSEQUMAPAPU: General.getFieldValue('NRSEQUMAPAPU', 'apuracao_de_imposto'),
            NRORG: General.getFieldValue('NRORG', 'apuracao_de_imposto')
        };

        if(widgetAjusteContibuicao.isValid())
            widgetAjusteContibuicao.currentRow.NRSEQUMAPAPU = General.getFieldValue('NRSEQUMAPAPU', 'apuracao_de_imposto');
            if (widgetAjusteContibuicao.currentRow.__is_new){
                General.callRestEngine('fis#/crud/ajusteapurcontr_max', 'FilterData').then(function (result) {
        			var ajusteapurcontr = result.dataset.ajusteapurcontr_max[0];
        			
        			if(result.dataset.ajusteapurcontr_max.length > 0){
        				var nrseqajuste = ('000000000' + (parseInt(ajusteapurcontr.NRSEQAJUSTE) + 1)).slice(-10);
        				widgetAjusteContibuicao.currentRow.NRSEQAJUSTE = nrseqajuste;
        			}else widgetAjusteContibuicao.currentRow.NRSEQAJUSTE = "0000000001";
        			
        			General.saveCrud(widgetAjusteContibuicao).then(function (result) {
        			    General.callRestEngine('fis_apuracoes#/atualizaAjusteContribuicoes','Row', data).then(
                            function(success){
                                templateManager.container.getWidget("apuracao_de_imposto").reload();
                                ScreenService.showMessage("Ajuste salvo com sucesso!");
                            }, function(error) {
                                ScreenService.showMessage(error.data.error);                
                        });
        			    
        			});
        			
        			
        		}).catch(function(erro){
                    ScreenService.showMessage(erro.data.error);
                });
            } else {
                General.saveCrud(widgetAjusteContibuicao).then(function (result) {
                    General.callRestEngine('fis_apuracoes#/atualizaAjusteContribuicoes','Row', data).then(
                        function(success){
                            templateManager.container.getWidget("apuracao_de_imposto").reload();
                            ScreenService.showMessage("Ajuste salvo com sucesso!");
                        }, function(error) {
                            ScreenService.showMessage(error.data.error);                
                    });
    			});
            }
    };
    
    
    /*
     * Função para deletar o ajuste na Aba Ajuste Contribuição
     * 
    */
    
    self.deleteAjusteContribuicao = function(widget){
        var data = [];
        data = {
            NRSEQUMAPAPU: General.getFieldValue('NRSEQUMAPAPU', 'apuracao_de_imposto'),
            NRORG: General.getFieldValue('NRORG', 'apuracao_de_imposto')
        };
        
        General.deleteCrud(widget).then(function() {
             General.callRestEngine('fis_apuracoes#/atualizaAjusteContribuicoes','Row', data).then(
                function(success){
                    templateManager.container.getWidget("apuracao_de_imposto").reload();
                    ScreenService.showMessage("Ajuste deletado com sucesso!");
                }, function(error) {
                    ScreenService.showMessage(error.data.error);                
            });
        });
    };
    
    /*
     * Função que limpa o conteúdo dos campos,
     * conforme o onChange do campo Tipo de Ajuste.
     */
    self.limpaCamposAjusteContribuicao = function(widget) {
        var currentrow = widget.currentRow; 
        currentrow.CDSITUTRIBITNFE  = "";
        currentrow.CDTPCREDPICOITE  = "";
        currentrow.VRBASECALCAJ     = "";
        currentrow.CDAJUSTEBC       = "";
        currentrow.CDCONTCTBL       = "";
        currentrow.NMFILIAL         = "";
        currentrow.NRRECIBO         = "";
        currentrow.CDAJUSTE         = "";
    };
    
    /*
     * Função que altera a visibilidade da aba de Detalhamento - Competência,
     * conforme o campo IDFORMAPUREMPR da empresa selecionada.
     */
    self.alteraVisibilidadeDetalhamento = function() {
        var widgetFiltro = templateManager.container.getActiveWidget();
        var widgetDetalhamento = templateManager.container.getWidget("contribuicoesDetalhamento");
        var widgetDetalhamentoCompetencia = templateManager.container.getWidget("contribuicoesDetalhamentoCompetencia");
        var widgetDetalhamentoIrpjCsll = templateManager.container.getWidget("detalhamentoIrpjCsllLucroRealTrimestral");
        var detalhamentoIrpjCsllLucroPresumidoCompet = templateManager.container.getWidget("detalhamentoIrpjCsllLucroPresumidoCompet");
        var detalhamentoIrpjCsllLucroPresumidoPag = templateManager.container.getWidget("detalhamentoIrpjCsllLucroPresumidoPag");
        var detalhamentoIrpjCsllLucroRealMensal = templateManager.container.getWidget("detalhamentoIrpjCsllLucroRealMensal");
        var cdimposto = widgetFiltro.currentRow.CDIMPOSTO; 
        var filter = [];
        
        this.alteraVisibilidadeRateio();
        
        if(contribuicoesIsSelected(cdimposto)){
            if(widgetFiltro.currentRow.IDFORMAPUREMPR == "P"){
                widgetDetalhamento.label = "Detalhamento - Pagamento";
			    widgetDetalhamentoCompetencia.isVisible = true;
            } else {
                filter = [
                    {
                        "name": "CDIMPOSTO",
                        "operator": "=",
                        "value": cdimposto
                    }
                ];
                General.callRestEngine('fis#/crud/imposto', 'FilterData', filter).then(function (result) { 
                	result = result.dataset.imposto[0];
                    if(result.IDFORMAPUR == "P"){    
                        widgetDetalhamento.label = "Detalhamento - Pagamento";
        			    widgetDetalhamentoCompetencia.isVisible = true;
                    } else {
                        widgetDetalhamento.label = "Detalhamento";
        			    widgetDetalhamentoCompetencia.isVisible = false;
                    } 
                });
            }
        } else {
            widgetDetalhamento.label = "Detalhamento";
		    widgetDetalhamentoCompetencia.isVisible = false;
        }
        
        if(irpjCsllIsSelected(cdimposto)){
            self.toggleAliquotaDetalhamentoIrpjCsll(cdimposto, widgetDetalhamentoIrpjCsll);    
            self.toggleAliquotaDetalhamentoIrpjCsll(cdimposto, detalhamentoIrpjCsllLucroPresumidoCompet);    
            self.toggleAliquotaDetalhamentoIrpjCsll(cdimposto, detalhamentoIrpjCsllLucroPresumidoPag);    
            self.toggleAliquotaDetalhamentoIrpjCsll(cdimposto, detalhamentoIrpjCsllLucroRealMensal);    
            filter = [
                {
                    "name": "CDEMPRESA",
                    "operator": "=",
                    "value": widgetFiltro.currentRow.CDEMPRESA
                }
            ];
            General.callRestEngine('fis#/crud/empresa', 'FilterData', filter).then(function (result) {
    			result = result.dataset.empresa[0];
    			switch (result.IDFORMAPUR) {
    		        case 'LRT':
    			        widgetDetalhamentoIrpjCsll.isVisible = true;
    			        widgetDetalhamentoIrpjCsll.activate();
    			        detalhamentoIrpjCsllLucroPresumidoCompet.isVisible = false;
    			        detalhamentoIrpjCsllLucroPresumidoPag.isVisible = false;
    			        detalhamentoIrpjCsllLucroRealMensal.isVisible = false;
    		            break;
    		        
    		        case 'LRM':
    			        widgetDetalhamentoIrpjCsll.isVisible = false;
    			        detalhamentoIrpjCsllLucroPresumidoCompet.isVisible = false;
    			        detalhamentoIrpjCsllLucroPresumidoPag.isVisible = false;
    			        detalhamentoIrpjCsllLucroRealMensal.isVisible = true;
    			        detalhamentoIrpjCsllLucroRealMensal.activate();
    		            break;
    		        
    		        case 'LPM':
    		        case 'LPT':
    			        widgetDetalhamentoIrpjCsll.isVisible = false;
    			        detalhamentoIrpjCsllLucroPresumidoCompet.isVisible = true;
    			        detalhamentoIrpjCsllLucroPresumidoCompet.activate();
    			        detalhamentoIrpjCsllLucroPresumidoPag.isVisible = true;
    			        detalhamentoIrpjCsllLucroRealMensal.isVisible = false;
    		            break;
    		    }
    		}).catch(function(erro){
                ScreenService.showMessage(erro.data.error);
            }); 
        }
    };
    
    /*
     * Altera visibilidade dos campos de mapeamento de rateio seguindo IDCONTCTBL da PARAMFISCAL
     */
    self.alteraVisibilidadeRateio = function() {
        var nomesWidgetDetalhamento = ['detalhamentoGeral', 'widgetItensDetalhamentoIcmsSt', 'widgetItensDetalhamento', 'widgetDetalhamentoIcmsDifal', 'widgetItensDetalhamentoDifalFcp'];
        var nomesCamposMapeamento = ["CDLOTE", "CDCONTRATEIO"];
        var nomesGruposMapeamento = ["integracao_cont"];
        
        General.callRestEngine('fis#/crud/paramfiscal', 'FilterData', []).then(function (result) { 
            result = result.dataset.paramfiscal[0] ? result.dataset.paramfiscal[0] : [];
            var camposVisiveis = result.IDCONTCTBL == 'S';
            nomesWidgetDetalhamento.forEach(function(nomeWidget){
                var widgetDetalhamentoAtual = templateManager.container.getWidget(nomeWidget);
                nomesCamposMapeamento.forEach(function(nomeCampo){
                    var campoMapeamentoAtual = widgetDetalhamentoAtual.getField(nomeCampo) || {};
                    campoMapeamentoAtual.isVisible = camposVisiveis;
                });
                // nomesGruposMapeamento.forEach(function(nomeGrupo){
                //     var grupoMapeamentoAtual = widgetDetalhamentoAtual.getField(nomeGrupo);
                //     grupoMapeamentoAtual.isVisible = camposVisiveis;
                // });
            });
        });
    };
    
    self.activeIsvisibleWidget = function(widgets){
        var widget = widgets.filter(function(widget){
            if(widget.isVisible == true){
                return widget;
            }
        })[0];
        
        widget.activate();
    };
    
    self.editDetalhamentoLRM = function(widget){
        General.edit(widget);
        widget.fields.forEach(function(field) {
            if (field.template == "field/label-with-icon.html"){
                field.isVisible = false;
            }
        });
    };
    
    self.cancelDetalhamentoLRM = function(args){
        var widget = args.owner.widget;
        
        General.backOrCancel(args);
        widget.fields.forEach(function(field) {
            if (field.template == "field/label-with-icon.html"){
                field.isVisible = true;
            }
        });
    };
    
    
    self.saveDetalhamentoLRM = function (widget){
        widget.fields.forEach(function(field) {
            if (field.template == "field/label-with-icon.html"){
                field.isVisible = true;
            }
        });
        widget.view();
        this.changeBalanceteVisibility(widget);
    };
    
    self.changeBalanceteVisibility = function (widget) {
        if(Object.keys(widget.currentRow).length == 0){
            widget.currentRow = widget.dataSource.data[0];
        }
        if(!widget.currentRow.IDBALANCETE){ 
           widget.currentRow.IDBALANCETE = "N";
        }
        
        if(widget.currentRow.IDBALANCETE == "S") {
            widget.fieldGroups.forEach(function (group){
                if(group.name == "balancete"){
                    group.isVisible = true;
                }
            });
            widget.actions.forEach(function(action){
                if(action.name == "gerarBalancete"){
                    action.isVisible = true;
                }
            });
        } else if(widget.currentRow.IDBALANCETE == "N") {
            widget.fieldGroups.forEach(function (group){
                if(group.name == "balancete"){
                    group.isVisible = false;
                }
            });
            widget.actions.forEach(function(action){
                if(action.name == "gerarBalancete"){
                    action.isVisible = false;
                }
            });
        }
        widget.redraw();
    };
    
    self.gerarBalancete = function (){
        
    };
    
    /**
     * Seta Data Souce Stripe
     * @param widget
     */
    self.setStripeData = function(widget) {
        var currentRow = widget.appliedFilter.FILTER_ROW;
        var stripeWidget = templateManager.container.getWidget("stripe");

        stripeWidget.currentRow = {};
        
        if(currentRow.IDTIPOAPURA == 'F'){
            stripeWidget.fields.forEach(function(field) {
                if (field.name != "DSIMPOSTONFE" && field.name != "NMEMPRESA") field.isVisible = false;
                else  field.isVisible = true;
            });
            stripeWidget.currentRow.DSIMPOSTONFE = currentRow.DSIMPOSTONFE;
            
        } else if (currentRow.IDTIPOAPURA == 'E') { 
            stripeWidget.fields.forEach(function(field) {
                if (field.name != "DSIMPOSTONFE" && field.name != "NMEMPRESA" && field.name != "CDINSCESTA") field.isVisible = false;
                else field.isVisible = true;
            });
            stripeWidget.currentRow.DSIMPOSTONFE = currentRow.DSIMPOSTONFE;
            stripeWidget.currentRow.CDINSCESTA = currentRow.CDINSCESTA;
            
        } else if (currentRow.IDTIPOAPURA == 'M') { 
            stripeWidget.fields.forEach(function(field) {
                if (field.name != "DSIMPOSTONFE" && field.name != "NMEMPRESA" && field.name != "CDINSCMUNI") field.isVisible = false;
                else field.isVisible = true;
            });
            stripeWidget.currentRow.DSIMPOSTONFE = currentRow.DSIMPOSTONFE;
            stripeWidget.currentRow.CDINSCMUNI = currentRow.CDINSCMUNI;
            
        } else if (currentRow.IDTIPOAPURA == 'S') { 
            stripeWidget.fields.forEach(function(field) {
                if (field.name != "NMEMPRESA") field.isVisible = false;
                else field.isVisible = true;
            });
        }
        stripeWidget.currentRow.NMEMPRESA = currentRow.CDEMPRESA + ' - ' + currentRow.NMEMPRESA;
    };
    
    /*
     * Função para fechar as widgets de itens do detalhamento - competência de um mapa de
     * Contribuições, retornando ao próprio detalhamento.
     */
    this.closeDetalhamentoContribuicoesCompetenciaWidgets = function() {
        ScreenService.closeSwipe().then(function() {
            var detalhamentoCompetenciaWidget = templateManager.container.getWidget("contribuicoesDetalhamentoCompetencia");
            detalhamentoCompetenciaWidget.activate();
            detalhamentoCompetenciaWidget.view();
        });
    };
    
    /*
     * Função para verificar se um imposto é IRPJ/CSLL. Utiliza o imposto
     * filtrado, caso nenhum parâmetro seja passado.
     */
    var irpjCsllIsSelected = function(cdimposto) {
        cdimposto = cdimposto || filteredData.CDIMPOSTO;
        return impostosIrpjCsll.indexOf(cdimposto) !== -1;
    };
    
    /*
     * Função para habilitar os campos de Cálculo do Valor Adicional
     * de acordo com o imposto da tela.
     */
    this.toggleVrAdicional = function(widget) {
        // Se o imposto for CSLL, desabilita os campos do fieldGroup de Cálculo Valor Adicional
        var bool = templateManager.container.getWidget("apuracao_de_imposto").appliedFilter.FILTER_ROW.CDIMPOSTO == impostosIrpjCsll[1];
        widget.fields.forEach(function(field) {
            if(field.fieldGroup == "vlradicional") {
                field.isVisible = !bool;
            }
            if(field.name == "VRADICIONALPRES"){
                field.isVisible = !bool;
            }
            if(field.name == "VRADICIONALPRESPAG"){
                field.isVisible = !bool;
            }
            if(field.name == "VRADICIONALREAL"){
                field.isVisible = !bool;
            }
            if(field.name == "VRADICIONAL"){
                field.isVisible = !bool;
            }
        });
    };
    
    /*
     * Função para que aplica o resultado do dataSource 
     * na currentRow da widget informada.
     */
    this.aplicaFiltroWidget = function(widget){
        widget.currentRow = widget.dataSource.data[0];
    };
    
    /*
     *   Função que controla as abas de Lucro Real Trimestral IRPJ/CSLL.
     */
    this.openDetalhamentoLucroRealTrimestral = function (field){
        var tabbedDetalhamentoLucro = templateManager.container.getWidget('calculosDetalhamentoLucroTabbed');
        var cdempresa = templateManager.container.getWidget('apuracao_de_imposto').currentRow.CDEMPRESA;
        var widgetItensDetalhamento = tabbedDetalhamentoLucro.widgets[0];
        var idformapur = (self.buscaApuracaoDataDePagamentoEmpresa(cdempresa)) ? "P" : "C";
       
        widgetItensDetalhamento.label = field.childWidgetLabel;
        
        widgetItensDetalhamento.dataSourceFilter[1].value = field.childWidgetFiltro; 
        widgetItensDetalhamento.getField("IDTIPODETAPU").setValue(field.childWidgetFiltro);

        widgetItensDetalhamento.dataSourceFilter[2].value = idformapur;
        widgetItensDetalhamento.getField("IDFORMAPUR").setValue(idformapur);
        
        ScreenService.openSwipe(tabbedDetalhamentoLucro).then(
            function (success) {
                widgetItensDetalhamento.reload();
            }
        );
    };
    
    /*
     *   Função que controla as abas de Lucro Presumido IRPJ/CSLL.
     */
    this.openDetalhamentoPresumido = function (field, widgetParent){
        var tabbedDetalhamentoLucro = templateManager.container.getWidget('calculosDetalhamentoLucroTabbed');
        var widgetItensDetalhamento = tabbedDetalhamentoLucro.widgets[0];
        
        widgetItensDetalhamento.label = field.childWidgetLabel;
        
        widgetItensDetalhamento.dataSourceFilter[1].value = field.childWidgetFiltro; 
        widgetItensDetalhamento.getField("IDTIPODETAPU").setValue(field.childWidgetFiltro);

        widgetItensDetalhamento.dataSourceFilter[2].value = field.idformapur;
        widgetItensDetalhamento.getField("IDFORMAPUR").setValue(field.idformapur);
        
        ScreenService.openSwipe(tabbedDetalhamentoLucro).then(
            function (success) {
                widgetItensDetalhamento.reload();
                widgetItensDetalhamento.widgetParent = widgetParent;
            }
        );
    };
    
    /*
     * Função para abrir uma widget contendo detalhamentos sobre créditos ou
     * débitos em um mapa de Contribuições.
     */
    this.openDetalhamentoVrfatbrutopresuWidget = function(field, widgetParent) {
        var childWidgetTabbed = templateManager.container.getWidget(field.childWidgetName);
        var childWidgetDetalhamento = childWidgetTabbed.widgets[0];
        
        childWidgetDetalhamento.dataSourceFilter[1].value = field.idformapuritem; 
        childWidgetDetalhamento.reload().then(
            function(success) {
                ScreenService.openSwipe(childWidgetTabbed);
                childWidgetDetalhamento.moveToFirst();
                childWidgetDetalhamento.view();
                childWidgetDetalhamento.widgetParent = widgetParent;
            }
        );
    };
    
    this.gerarBalancete = function(widget) {
        var widgetBalanceteTabbed = widget.widgets[2];
        var widgetBalancete = widgetBalanceteTabbed.widgets[0];
        
        widgetBalancete.reload().then(function(){
            ScreenService.closePopup();
            ScreenService.openSwipe(widgetBalanceteTabbed);
            widgetBalancete.activate();
        });
        widgetBalancete.widgetParent = widget.name;

    };
    
    /*
     *   Função que controla as abas de Lucro Presumido IRPJ/CSLL.
     */
    this.openWidgetBalanceteCalc = function (field, widget, widgetParent){
        var widgetItensDetalhamentoTabbed = templateManager.container.getWidget('calculosWidgetBalanceteTabbed');
        var widgetItensDetalhamento = widgetItensDetalhamentoTabbed.widgets[0];
        
        widgetItensDetalhamento.label = field.childWidgetLabel;
        
        widgetItensDetalhamento.dataSourceFilter[1].value = field.childWidgetFiltro; 
        widgetItensDetalhamento.getField("IDTIPODETAPUIRPJ").setValue(field.childWidgetFiltro);
        
        ScreenService.openSwipe(widgetItensDetalhamentoTabbed).then(function(success) {
            widgetItensDetalhamento.activate();
            widgetItensDetalhamento.reload();
        });
        widgetItensDetalhamento.widgetParent = widgetParent;
    };
    
    this.closeWidgetBalanceteCalc = function (widget){
        var detalhamentoWidget = templateManager.container.getWidget(widget.widgetParent);
        ScreenService.closeSwipe().then(function() {
            detalhamentoWidget.activate();
            //detalhamentoWidget.view();
        });
    };
    
    /*
     * Função booleana que retorna verdadeiro caso a empresa informada apure por 
     *  Data de Pagamento e falso, caso contrário. 
     */
    self.buscaApuracaoDataDePagamentoEmpresa = function(widget){
        var widgetFiltro = templateManager.container.getActiveWidget();
        var filter = [
            {
                "name": "CDEMPRESA",
                "operator": "=",
                "value": widgetFiltro.currentRow.CDEMPRESA
            }
        ];
        General.callRestEngine('fis#/crud/empresa', 'FilterData', filter).then(function (result) { 
        	result = result.dataset.empresa[0];
        	
			if (result.IDFORMAPUREMPR == "P")
			    return true;
			else 
			    return false;
        }).catch(function(erro){
            ScreenService.showMessage(erro.data.error);
        }.bind(this)); 
    };
    
    /*
     * Função que retorna a forma de apuração de uma empresa.
     */
    self.buscaFormaDeApuraçaoEmpresa = function(widget){
        var cdempresa = widget.currentRow.CDEMPRESA;
        var filter = [
            {
                "name": "CDEMPRESA",
                "operator": "=",
                "value": cdempresa
            }
        ];
        General.callRestEngine('fis#/crud/empresa', 'FilterData', filter).then(function (result) {
			result = result.dataset.empresa[0];
			return result.IDFORMAPUR;
		}).catch(function(erro){
            ScreenService.showMessage(erro.data.error);
        }); 
    };
    
    /*
     * Função para adicionar um item no Detalhamento IRPJ/CSLL.
     */
    this.adicionarItemDetalhamentoIrpjCsll = function(calculosDetalhamentoLucroWidget) {
        var widgetApuracao = templateManager.container.getWidget('apuracao_de_imposto');
        calculosDetalhamentoLucroWidget.newRow();
        calculosDetalhamentoLucroWidget.currentRow.NRSEQUMAPAPU = widgetApuracao.currentRow.NRSEQUMAPAPU;
        calculosDetalhamentoLucroWidget.currentRow.IDTIPODETAPU = calculosDetalhamentoLucroWidget.dataSourceFilter[1].value;
        calculosDetalhamentoLucroWidget.currentRow.IDFORMAPUR = calculosDetalhamentoLucroWidget.dataSourceFilter[2].value;
        calculosDetalhamentoLucroWidget.currentRow.IDITDETAMANUAL = "S";
    };
    
    /*
     * Função para salvar um item no Detalhamento IRPJ/CSLL.
     */
    this.saveItemDetalhamentoIrpjCsll = function(widget) {
        General.saveCrud(widget).then(function() {
            var tipoapurac = widget.dataSourceFilter[1].value;
            var widgetLucroReal = templateManager.container.getWidget(widget.widgetParent);
            var widgetApuracao = templateManager.container.getWidget("apuracao_de_imposto");
            if(widgetApuracao.appliedFilter.FILTER_ROW.IDFORMAPUR == 'LRT'){
                if(tipoapurac == "AD") {
                    widgetLucroReal.currentRow.VRADICREAL = parseFloat(widgetLucroReal.currentRow.VRADICREAL) + parseFloat(widget.currentRow.VRITEMDETAPU);
                }
                else if (tipoapurac == "EX") {
                    widgetLucroReal.currentRow.VREXCLREAL = parseFloat(widgetLucroReal.currentRow.VREXCLREAL) + parseFloat(widget.currentRow.VRITEMDETAPU);
                }
                else if (tipoapurac == "DE") {
                    widgetLucroReal.currentRow.VRDEDUCAOREAL = parseFloat(widgetLucroReal.currentRow.VRDEDUCAOREAL) + parseFloat(widget.currentRow.VRITEMDETAPU);
                }
            } else {
                if(widget.currentRow.IDFORMAPUR === 'C') {
                    if(tipoapurac == "AD") {
                        widgetLucroReal.currentRow.VRADICPRESU = parseFloat(widgetLucroReal.currentRow.VRADICPRESU) + parseFloat(widget.currentRow.VRITEMDETAPU);
                    }
                    else if (tipoapurac == "EX") {
                        widgetLucroReal.currentRow.VREXCLPRESU = parseFloat(widgetLucroReal.currentRow.VREXCLPRESU) + parseFloat(widget.currentRow.VRITEMDETAPU);
                    }
                    else if (tipoapurac == "DE") {
                        widgetLucroReal.currentRow.VRDEDUCAOPRESU = parseFloat(widgetLucroReal.currentRow.VRDEDUCAOPRESU) + parseFloat(widget.currentRow.VRITEMDETAPU);
                    }
                } else if(widget.currentRow.IDFORMAPUR === 'P') {
                    if(tipoapurac == "AD") {
                        widgetLucroReal.currentRow.VRADICPRESUPAG = parseFloat(widgetLucroReal.currentRow.VRADICPRESUPAG) + parseFloat(widget.currentRow.VRITEMDETAPU);
                    }
                    else if (tipoapurac == "EX") {
                        widgetLucroReal.currentRow.VREXCLPRESUPAG = parseFloat(widgetLucroReal.currentRow.VREXCLPRESUPAG) + parseFloat(widget.currentRow.VRITEMDETAPU);
                    }
                    else if (tipoapurac == "DE") {
                        widgetLucroReal.currentRow.VRDEDUCAOPRESUPAG = parseFloat(widgetLucroReal.currentRow.VRDEDUCAOPRESUPAG) + parseFloat(widget.currentRow.VRITEMDETAPU);
                    }
                }
            }
            // Chama função que recalcula os valores da aba de detalhamento do IRPJ/CSLL 
            self.calculaDetalhamentoLucroTrimestral(widgetLucroReal, widgetApuracao.currentRow.CDIMPOSTO);
            if (widgetApuracao.currentRow.CDIMPOSTO == impostosIrpjCsll[0]){
                self.calculaDetalhamentoLucroTrimestralValorAdicional(widgetLucroReal);
            }
            General.saveCrud(widgetLucroReal).then(function() {
                widget.activate();
            });
        });
    };
    
    /*
     * Função para deletar um item no Detalhamento IRPJ/CSLL.
     */
    this.deleteItemDetalhamentoIrpjCsll = function(widget) {
        General.deleteCrud(widget).then(function() {
            var tipoapurac = widget.dataSourceFilter[1].value;
            var widgetLucroReal = templateManager.container.getWidget(widget.widgetParent);
            var widgetApuracao = templateManager.container.getWidget("apuracao_de_imposto");
            
            if(widgetApuracao.appliedFilter.FILTER_ROW.IDFORMAPUR == 'LRT'){
                if(tipoapurac == "AD") {
                    widgetLucroReal.currentRow.VRADICREAL = parseFloat(widgetLucroReal.currentRow.VRADICREAL) - parseFloat(widget.currentRow.VRITEMDETAPU);
                }
                else if (tipoapurac == "EX") {
                    widgetLucroReal.currentRow.VREXCLREAL = parseFloat(widgetLucroReal.currentRow.VREXCLREAL) - parseFloat(widget.currentRow.VRITEMDETAPU);
                }
                else if (tipoapurac == "DE") {
                    widgetLucroReal.currentRow.VRDEDUCAOREAL = parseFloat(widgetLucroReal.currentRow.VRDEDUCAOREAL) - parseFloat(widget.currentRow.VRITEMDETAPU);
                }
            } else {
                if(widget.currentRow.IDFORMAPUR === 'C') {
                    if(tipoapurac == "AD") {
                        widgetLucroReal.currentRow.VRADICPRESU = parseFloat(widgetLucroReal.currentRow.VRADICPRESU) - parseFloat(widget.currentRow.VRITEMDETAPU);
                    }
                    else if (tipoapurac == "EX") {
                        widgetLucroReal.currentRow.VREXCLPRESU = parseFloat(widgetLucroReal.currentRow.VREXCLPRESU) - parseFloat(widget.currentRow.VRITEMDETAPU);
                    }
                    else if (tipoapurac == "DE") {
                        widgetLucroReal.currentRow.VRDEDUCAOPRESU = parseFloat(widgetLucroReal.currentRow.VRDEDUCAOPRESU) - parseFloat(widget.currentRow.VRITEMDETAPU);
                    }
                } else if(widget.currentRow.IDFORMAPUR === 'P') {
                    if(tipoapurac == "AD") {
                        widgetLucroReal.currentRow.VRADICPRESUPAG = parseFloat(widgetLucroReal.currentRow.VRADICPRESUPAG) - parseFloat(widget.currentRow.VRITEMDETAPU);
                    }
                    else if (tipoapurac == "EX") {
                        widgetLucroReal.currentRow.VREXCLPRESUPAG = parseFloat(widgetLucroReal.currentRow.VREXCLPRESUPAG) - parseFloat(widget.currentRow.VRITEMDETAPU);
                    }
                    else if (tipoapurac == "DE") {
                        widgetLucroReal.currentRow.VRDEDUCAOPRESUPAG = parseFloat(widgetLucroReal.currentRow.VRDEDUCAOPRESUPAG) - parseFloat(widget.currentRow.VRITEMDETAPU);
                    }
                }
            }
            // Chama função que recalcula os valores da aba de detalhamento do IRPJ/CSLL 
            self.calculaDetalhamentoLucroTrimestral(widgetLucroReal, widgetApuracao.currentRow.CDIMPOSTO, widgetApuracao.IDFORMAPUR);
            if (widgetApuracao.currentRow.CDIMPOSTO == impostosIrpjCsll[0]) {
                self.calculaDetalhamentoLucroTrimestralValorAdicional(widgetLucroReal);
            }
            General.saveCrud(widgetLucroReal).then(function() {
                widget.activate();
            });
        });
    };
    
    self.calculaDetalhamentoLucroTrimestral = function(widget, cdimposto, idformapur){
        var aliquota = (cdimposto == impostosIrpjCsll[0]) ? parseFloat(widget.currentRow.VRALIQIRPJ) : parseFloat(widget.currentRow.VRALIQCSLL);
        if(idformapur == 'LRT') {
            widget.currentRow.VRLUCROLIQTOT = (parseFloat(widget.currentRow.VRLUCROOPERAC) + parseFloat(widget.currentRow.VRLUCRONAOOPERAC)); 
            widget.currentRow.VRLUCROLIQREAL =  (widget.currentRow.VRLUCROLIQTOT + parseFloat(widget.currentRow.VRADICREAL) - parseFloat(widget.currentRow.VREXCLREAL)); 
            widget.currentRow.VRDEBLUCREAL = (widget.currentRow.VRLUCROLIQREAL * (aliquota/100));
            widget.currentRow.VRDEBLUCREALTOT = (widget.currentRow.VRDEBLUCREAL + parseFloat(widget.currentRow.VRADICIONALREAL) - parseFloat(widget.currentRow.VRDEDUCAOREAL));
            widget.currentRow.VRTOTAIMPOS = widget.currentRow.VRDEBLUCREALTOT;
        } else {
            widget.currentRow.VRFATBRUTOREAL = (parseFloat(widget.currentRow.VRFATBRUTOPRESU) + parseFloat(widget.currentRow.VRADICPRESU) - parseFloat(widget.currentRow.VREXCLPRESU));
            widget.currentRow.VRIMPOSAPURPRESU = widget.currentRow.VRFATBRUTOREAL * (aliquota/100);
            widget.currentRow.VRDEBITOTPRESU = widget.currentRow.VRIMPOSAPURPRESU + parseFloat(widget.currentRow.VRADICIONALPRES) - parseFloat(widget.currentRow.VRDEDUCAOPRESU);
        } 
    };
    
    self.calculaDetalhamentoLucroTrimestralValorAdicional = function(widget){
        widget.currentRow.VRPARCEXCEDREAL = (parseFloat(widget.currentRow.VRLUCROLIQTOT) - parseFloat(widget.currentRow.VRLIMITEADIC)); 
        widget.currentRow.VRADICIONALREAL =  (widget.currentRow.VRPARCEXCEDREAL * parseFloat(widget.currentRow.VRALIQADICIR)); 
    };
    
    /*
     * Função para alterar a visibilidade dos fields VRALIQIRPJ e VRALIQCSLL
     * conforme o imposto filtrado.
     */
    self.toggleAliquotaDetalhamentoIrpjCsll = function(cdimposto, widgetDetalhamento){
        var bool = (cdimposto == impostosIrpjCsll[0]) ? true : false;
        widgetDetalhamento.getField("VRALIQIRPJ").isVisible = bool;
        widgetDetalhamento.getField("VRALIQCSLL").isVisible = !bool;
    };
    
    self.mudaVisibilidadeRegimeApuracao = function(widget) {
        if(widget.currentRow.IDCUMUPISCOFIL && widget.currentRow.IDCUMUPISCOFIL != ""){
            widget.getField('VRBASECALCAJ').readOnly = false;
        } else {
            widget.getField('VRBASECALCAJ').readOnly = true;
        }
        self.calculoValorAjustePorValorBase(widget);
    };
    
    self.calculoValorAjustePorValorBase = function(widget) {
        var cdimposto = templateManager.container.getWidget('apuracao_de_imposto').appliedFilter.FILTER_ROW.CDIMPOSTO;
        if(widget.currentRow.VRBASECALCAJ && widget.currentRow.VRBASECALCAJ != ""){
            if(widget.currentRow.IDCUMUPISCOFIL == 'N'){
                if(cdimposto == '50'){
                    widget.currentRow.VRAJUSTE = 0.0065 * parseFloat(widget.currentRow.VRBASECALCAJ.replace(",","."));
                } else if(cdimposto == '60'){
                    widget.currentRow.VRAJUSTE = 0.03 * parseFloat(widget.currentRow.VRBASECALCAJ.replace(",","."));
                }
            } else if(widget.currentRow.IDCUMUPISCOFIL == 'S'){
                if(cdimposto == '50'){
                    widget.currentRow.VRAJUSTE = 0.0165 * parseFloat(widget.currentRow.VRBASECALCAJ.replace(",","."));
                } else if(cdimposto == '60'){
                    widget.currentRow.VRAJUSTE = 0.076 * parseFloat(widget.currentRow.VRBASECALCAJ.replace(",","."));
                }
            }
        }
    };
    
    self.checkFormaApurac = function(widget) {
        var imposto = widget.currentRow.CDIMPOSTO;
        var formaApuracap = widget.currentRow.IDFORMAPUR;
  
        if(imposto && (imposto.match(/^(25|70)$/) && formaApuracap == "I")){
            ScreenService.showMessage('Forma de Apuração da Empresa deve ser informada para o Imposto selecionado');
            widget.getField('NMEMPRESA').clearValue();
        }
    };
    
    self.verificaImpostoWidgetBalancete = function (widget) {
        var imposto = widget.dataSourceFilter[0].value;
        
        widget.fields.forEach(function (field){
            if (field.name == "VRALIQBALCTIRPJ"){
                if (imposto == "25") {
                    field.label = "(x) Alíq. IRPJ";
                } else { 
                    field.label = "(x) Alíq. CSLL";
                }
            }
        });
    };
    
    this.conferencia = function (args){
        var conferencia = templateManager.container.getWidget('ConfAjusteSt');
        var imposto = args.dataSourceFilter.filter(function(filter) {
            return filter.name === 'P_IMPOSTO' || filter.name == 'CDIMPOSTO';
        });
        //bem caso não ache o field por algum motivo, não vai dar erro, mas vai mostrar o campo de conferencia na tela
        imposto = imposto.length ? imposto[0].value : 0;
        if (imposto === '80'){
            conferencia.isVisible = true;
        } else {
            conferencia.isVisible = false;
        }
    };
};
Configuration(function(ContextRegister) {
     ContextRegister.register('Fis00100_ApuracaoDeImposto_Controller', Fis00100_ApuracaoDeImposto_Controller);
});